import { Vector3 } from 'three';
import { NgtsLine, NgtsLineOptions } from './line';
import * as i0 from "@angular/core";
export interface NgtsCubicBezierLineOptions extends Omit<NgtsLineOptions, 'segments'> {
    segments?: number;
}
export declare class NgtsCubicBezierLine {
    start: import("@angular/core").InputSignal<Vector3 | [number, number, number]>;
    end: import("@angular/core").InputSignal<Vector3 | [number, number, number]>;
    midA: import("@angular/core").InputSignal<Vector3 | [number, number, number]>;
    midB: import("@angular/core").InputSignal<Vector3 | [number, number, number]>;
    options: import("@angular/core").InputSignalWithTransform<NgtsCubicBezierLineOptions, "" | Partial<NgtsCubicBezierLineOptions>>;
    parameters: import("@angular/core").Signal<Omit<NgtsCubicBezierLineOptions, "segments">>;
    line: import("@angular/core").Signal<NgtsLine>;
    private segments;
    points: import("@angular/core").Signal<Vector3[]>;
    static ɵfac: i0.ɵɵFactoryDeclaration<NgtsCubicBezierLine, never>;
    static ɵcmp: i0.ɵɵComponentDeclaration<NgtsCubicBezierLine, "ngts-cubic-bezier-line", never, { "start": { "alias": "start"; "required": true; "isSignal": true; }; "end": { "alias": "end"; "required": true; "isSignal": true; }; "midA": { "alias": "midA"; "required": true; "isSignal": true; }; "midB": { "alias": "midB"; "required": true; "isSignal": true; }; "options": { "alias": "options"; "required": false; "isSignal": true; }; }, {}, never, ["*"], true, never>;
}
