import { NgtMesh } from 'angular-three';
import { BufferGeometry, ColorRepresentation, Mesh } from 'three';
import { LineMaterialParameters } from 'three-stdlib';
import { NgtLine2, NgtLineMaterial, NgtsLine } from './line';
import * as i0 from "@angular/core";
export type NgtsEdgesOptions = Partial<NgtMesh> & {
    threshold?: number;
    lineWidth?: number;
} & Omit<LineMaterialParameters, 'vertexColors' | 'color'> & Omit<Partial<NgtLine2>, 'geometry'> & Omit<Partial<NgtLineMaterial>, 'color' | 'vertexColors'> & {
    geometry?: BufferGeometry;
    color?: ColorRepresentation;
};
export declare class NgtsEdges {
    options: import("@angular/core").InputSignalWithTransform<NgtsEdgesOptions, "" | Partial<NgtsEdgesOptions>>;
    private parameters;
    protected lineOptions: import("@angular/core").Signal<{
        raycast: () => null;
        position?: import("angular-three").NgtVector3 | undefined;
        up?: import("angular-three").NgtVector3 | undefined;
        scale?: import("angular-three").NgtVector3 | undefined;
        rotation?: import("angular-three").NgtEuler | undefined;
        matrix?: import("angular-three").NgtMatrix4 | undefined;
        quaternion?: import("angular-three").NgtQuaternion | undefined;
        layers?: import("angular-three").NgtLayers | undefined;
        dispose?: (() => void) | null | undefined;
        addEventListener?: ((<TEventKey extends keyof import("angular-three").NgtNodeEventMap<TOriginal>>(type: TEventKey, listener: (this: import("angular-three").NgtNodeElement<Mesh<BufferGeometry<import("three").NormalBufferAttributes>, import("three").Material | import("three").Material[], import("three").Object3DEventMap>, typeof Mesh>, ev: import("angular-three").NgtNodeEventMap<Mesh<BufferGeometry<import("three").NormalBufferAttributes>, import("three").Material | import("three").Material[], import("three").Object3DEventMap>>[TEventKey]) => any) => void) & (<TEventKey extends keyof import("angular-three").NgtAllObject3DEventsMap>(type: TEventKey, listener: (this: {
            addEventListener: (<TEventKey_1 extends keyof import("angular-three").NgtNodeEventMap<TOriginal>>(type: TEventKey_1, listener: (this: import("angular-three").NgtNodeElement<Mesh<BufferGeometry<import("three").NormalBufferAttributes>, import("three").Material | import("three").Material[], import("three").Object3DEventMap>, typeof Mesh>, ev: import("angular-three").NgtNodeEventMap<Mesh<BufferGeometry<import("three").NormalBufferAttributes>, import("three").Material | import("three").Material[], import("three").Object3DEventMap>>[TEventKey_1]) => any) => void) & /*elided*/ any;
            removeEventListener: (<TEventKey_1 extends keyof import("angular-three").NgtNodeEventMap<TOriginal>>(type: TEventKey_1, listener: (this: import("angular-three").NgtNodeElement<Mesh<BufferGeometry<import("three").NormalBufferAttributes>, import("three").Material | import("three").Material[], import("three").Object3DEventMap>, typeof Mesh>, ev: import("angular-three").NgtNodeEventMap<Mesh<BufferGeometry<import("three").NormalBufferAttributes>, import("three").Material | import("three").Material[], import("three").Object3DEventMap>>[TEventKey_1]) => any) => void) & (<TEventKey_1 extends keyof import("angular-three").NgtAllObject3DEventsMap>(type: TEventKey_1, listener: (this: /*elided*/ any, ev: import("angular-three").NgtAllObject3DEventsMap[TEventKey_1]) => any) => void);
            attach: string | string[] | import("angular-three").NgtAttachFunction;
            __ngt_args__: [geometry?: BufferGeometry<import("three").NormalBufferAttributes> | undefined, material?: import("three").Material | import("three").Material[] | undefined];
            readonly isMesh?: true | undefined;
            readonly type?: string | undefined;
            geometry?: BufferGeometry<import("three").NormalBufferAttributes> | undefined;
            material?: import("three").Material | import("three").Material[] | undefined;
            morphTargetInfluences?: number[] | undefined | undefined;
            morphTargetDictionary?: {
                [key: string]: number;
            } | undefined | undefined;
            updateMorphTargets?: (() => void) | undefined;
            getVertexPosition?: ((index: number, target: import("three").Vector3) => import("three").Vector3) | undefined;
            toJSON?: ((meta?: import("three").JSONMeta) => import("three").MeshJSON) | undefined;
            readonly isObject3D?: true | undefined;
            readonly id?: number | undefined;
            uuid?: string | undefined;
            name?: string | undefined;
            parent?: import("three").Object3D<import("three").Object3DEventMap> | null | undefined;
            children?: import("three").Object3D<import("three").Object3DEventMap>[] | undefined;
            readonly modelViewMatrix?: import("three").Matrix4 | undefined;
            readonly normalMatrix?: import("three").Matrix3 | undefined;
            matrixWorld?: import("three").Matrix4 | undefined;
            matrixAutoUpdate?: boolean | undefined;
            matrixWorldAutoUpdate?: boolean | undefined;
            matrixWorldNeedsUpdate?: boolean | undefined;
            visible?: boolean | undefined;
            castShadow?: boolean | undefined;
            receiveShadow?: boolean | undefined;
            frustumCulled?: boolean | undefined;
            renderOrder?: number | undefined;
            animations?: import("three").AnimationClip[] | undefined;
            userData?: Record<string, any> | undefined;
            customDepthMaterial?: import("three").Material | undefined;
            customDistanceMaterial?: import("three").Material | undefined;
            onBeforeShadow?: ((renderer: import("three").WebGLRenderer, scene: import("three").Scene, camera: import("three").Camera, shadowCamera: import("three").Camera, geometry: BufferGeometry, depthMaterial: import("three").Material, group: import("three").Group) => void) | undefined;
            onAfterShadow?: ((renderer: import("three").WebGLRenderer, scene: import("three").Scene, camera: import("three").Camera, shadowCamera: import("three").Camera, geometry: BufferGeometry, depthMaterial: import("three").Material, group: import("three").Group) => void) | undefined;
            onBeforeRender?: ((renderer: import("three").WebGLRenderer, scene: import("three").Scene, camera: import("three").Camera, geometry: BufferGeometry, material: import("three").Material, group: import("three").Group) => void) | undefined;
            onAfterRender?: ((renderer: import("three").WebGLRenderer, scene: import("three").Scene, camera: import("three").Camera, geometry: BufferGeometry, material: import("three").Material, group: import("three").Group) => void) | undefined;
            applyMatrix4?: ((matrix: import("three").Matrix4) => void) | undefined;
            applyQuaternion?: ((quaternion: import("three").Quaternion) => Mesh<BufferGeometry<import("three").NormalBufferAttributes>, import("three").Material | import("three").Material[], import("three").Object3DEventMap>) | undefined;
            setRotationFromAxisAngle?: ((axis: import("three").Vector3, angle: number) => void) | undefined;
            setRotationFromEuler?: ((euler: import("three").Euler) => void) | undefined;
            setRotationFromMatrix?: ((m: import("three").Matrix4) => void) | undefined;
            setRotationFromQuaternion?: ((q: import("three").Quaternion) => void) | undefined;
            rotateOnAxis?: ((axis: import("three").Vector3, angle: number) => Mesh<BufferGeometry<import("three").NormalBufferAttributes>, import("three").Material | import("three").Material[], import("three").Object3DEventMap>) | undefined;
            rotateOnWorldAxis?: ((axis: import("three").Vector3, angle: number) => Mesh<BufferGeometry<import("three").NormalBufferAttributes>, import("three").Material | import("three").Material[], import("three").Object3DEventMap>) | undefined;
            rotateX?: ((angle: number) => Mesh<BufferGeometry<import("three").NormalBufferAttributes>, import("three").Material | import("three").Material[], import("three").Object3DEventMap>) | undefined;
            rotateY?: ((angle: number) => Mesh<BufferGeometry<import("three").NormalBufferAttributes>, import("three").Material | import("three").Material[], import("three").Object3DEventMap>) | undefined;
            rotateZ?: ((angle: number) => Mesh<BufferGeometry<import("three").NormalBufferAttributes>, import("three").Material | import("three").Material[], import("three").Object3DEventMap>) | undefined;
            translateOnAxis?: ((axis: import("three").Vector3, distance: number) => Mesh<BufferGeometry<import("three").NormalBufferAttributes>, import("three").Material | import("three").Material[], import("three").Object3DEventMap>) | undefined;
            translateX?: ((distance: number) => Mesh<BufferGeometry<import("three").NormalBufferAttributes>, import("three").Material | import("three").Material[], import("three").Object3DEventMap>) | undefined;
            translateY?: ((distance: number) => Mesh<BufferGeometry<import("three").NormalBufferAttributes>, import("three").Material | import("three").Material[], import("three").Object3DEventMap>) | undefined;
            translateZ?: ((distance: number) => Mesh<BufferGeometry<import("three").NormalBufferAttributes>, import("three").Material | import("three").Material[], import("three").Object3DEventMap>) | undefined;
            localToWorld?: ((vector: import("three").Vector3) => import("three").Vector3) | undefined;
            worldToLocal?: ((vector: import("three").Vector3) => import("three").Vector3) | undefined;
            lookAt?: {
                (vector: import("three").Vector3): void;
                (x: number, y: number, z: number): void;
            } | undefined;
            add?: ((...object: import("three").Object3D[]) => Mesh<BufferGeometry<import("three").NormalBufferAttributes>, import("three").Material | import("three").Material[], import("three").Object3DEventMap>) | undefined;
            remove?: ((...object: import("three").Object3D[]) => Mesh<BufferGeometry<import("three").NormalBufferAttributes>, import("three").Material | import("three").Material[], import("three").Object3DEventMap>) | undefined;
            removeFromParent?: (() => Mesh<BufferGeometry<import("three").NormalBufferAttributes>, import("three").Material | import("three").Material[], import("three").Object3DEventMap>) | undefined;
            clear?: (() => Mesh<BufferGeometry<import("three").NormalBufferAttributes>, import("three").Material | import("three").Material[], import("three").Object3DEventMap>) | undefined;
            getObjectById?: ((id: number) => import("three").Object3D | undefined) | undefined;
            getObjectByName?: ((name: string) => import("three").Object3D | undefined) | undefined;
            getObjectByProperty?: ((name: string, value: any) => import("three").Object3D | undefined) | undefined;
            getObjectsByProperty?: ((name: string, value: any, optionalTarget?: import("three").Object3D[]) => import("three").Object3D[]) | undefined;
            getWorldPosition?: ((target: import("three").Vector3) => import("three").Vector3) | undefined;
            getWorldQuaternion?: ((target: import("three").Quaternion) => import("three").Quaternion) | undefined;
            getWorldScale?: ((target: import("three").Vector3) => import("three").Vector3) | undefined;
            getWorldDirection?: ((target: import("three").Vector3) => import("three").Vector3) | undefined;
            traverse?: ((callback: (object: import("three").Object3D) => any) => void) | undefined;
            traverseVisible?: ((callback: (object: import("three").Object3D) => any) => void) | undefined;
            traverseAncestors?: ((callback: (object: import("three").Object3D) => any) => void) | undefined;
            updateMatrix?: (() => void) | undefined;
            updateMatrixWorld?: ((force?: boolean) => void) | undefined;
            updateWorldMatrix?: ((updateParents: boolean, updateChildren: boolean) => void) | undefined;
            clone?: ((recursive?: boolean) => Mesh<BufferGeometry<import("three").NormalBufferAttributes>, import("three").Material | import("three").Material[], import("three").Object3DEventMap>) | undefined;
            copy?: ((object: import("three").Object3D, recursive?: boolean) => Mesh<BufferGeometry<import("three").NormalBufferAttributes>, import("three").Material | import("three").Material[], import("three").Object3DEventMap>) | undefined;
            hasEventListener?: (<T extends keyof import("three").Object3DEventMap>(type: T, listener: import("three").EventListener<import("three").Object3DEventMap[T], T, Mesh<BufferGeometry<import("three").NormalBufferAttributes>, import("three").Material | import("three").Material[], import("three").Object3DEventMap>>) => boolean) | undefined;
            dispatchEvent?: (<T extends keyof import("three").Object3DEventMap>(event: import("three").BaseEvent<T> & import("three").Object3DEventMap[T]) => void) | undefined;
            position: import("angular-three").NgtVector3;
            up: import("angular-three").NgtVector3;
            scale: import("angular-three").NgtVector3;
            rotation: import("angular-three").NgtEuler;
            matrix: import("angular-three").NgtMatrix4;
            quaternion: import("angular-three").NgtQuaternion;
            layers: import("angular-three").NgtLayers;
            dispose: (() => void) | null;
            raycast: import("three").Object3D["raycast"] | null;
        }, ev: import("angular-three").NgtAllObject3DEventsMap[TEventKey]) => any) => void) & (<TEventKey extends keyof import("angular-three").NgtNodeEventMap<TOriginal>>(type: TEventKey, listener: (this: import("angular-three").NgtNodeElement<import("three-stdlib").Line2, typeof import("three-stdlib").Line2>, ev: import("angular-three").NgtNodeEventMap<import("three-stdlib").Line2>[TEventKey]) => any) => void) & (<TEventKey extends keyof import("angular-three").NgtAllObject3DEventsMap>(type: TEventKey, listener: (this: {
            addEventListener: (<TEventKey_1 extends keyof import("angular-three").NgtNodeEventMap<TOriginal>>(type: TEventKey_1, listener: (this: import("angular-three").NgtNodeElement<import("three-stdlib").Line2, typeof import("three-stdlib").Line2>, ev: import("angular-three").NgtNodeEventMap<import("three-stdlib").Line2>[TEventKey_1]) => any) => void) & /*elided*/ any;
            removeEventListener: (<TEventKey_1 extends keyof import("angular-three").NgtNodeEventMap<TOriginal>>(type: TEventKey_1, listener: (this: import("angular-three").NgtNodeElement<import("three-stdlib").Line2, typeof import("three-stdlib").Line2>, ev: import("angular-three").NgtNodeEventMap<import("three-stdlib").Line2>[TEventKey_1]) => any) => void) & (<TEventKey_1 extends keyof import("angular-three").NgtAllObject3DEventsMap>(type: TEventKey_1, listener: (this: /*elided*/ any, ev: import("angular-three").NgtAllObject3DEventsMap[TEventKey_1]) => any) => void);
            attach: string | string[] | import("angular-three").NgtAttachFunction;
            __ngt_args__: [geometry?: import("three-stdlib").LineGeometry | undefined, material?: import("three-stdlib").LineMaterial | undefined];
            readonly isMesh?: true | undefined;
            readonly type?: string | undefined;
            geometry?: import("three-stdlib").LineGeometry | undefined;
            material?: import("three-stdlib").LineMaterial | undefined;
            morphTargetInfluences?: number[] | undefined | undefined;
            morphTargetDictionary?: {
                [key: string]: number;
            } | undefined | undefined;
            updateMorphTargets?: (() => void) | undefined;
            getVertexPosition?: ((index: number, target: import("three").Vector3) => import("three").Vector3) | undefined;
            toJSON?: ((meta?: import("three").JSONMeta) => import("three").MeshJSON) | undefined;
            readonly isObject3D?: true | undefined;
            readonly id?: number | undefined;
            uuid?: string | undefined;
            name?: string | undefined;
            parent?: import("three").Object3D<import("three").Object3DEventMap> | null | undefined;
            children?: import("three").Object3D<import("three").Object3DEventMap>[] | undefined;
            readonly modelViewMatrix?: import("three").Matrix4 | undefined;
            readonly normalMatrix?: import("three").Matrix3 | undefined;
            matrixWorld?: import("three").Matrix4 | undefined;
            matrixAutoUpdate?: boolean | undefined;
            matrixWorldAutoUpdate?: boolean | undefined;
            matrixWorldNeedsUpdate?: boolean | undefined;
            visible?: boolean | undefined;
            castShadow?: boolean | undefined;
            receiveShadow?: boolean | undefined;
            frustumCulled?: boolean | undefined;
            renderOrder?: number | undefined;
            animations?: import("three").AnimationClip[] | undefined;
            userData?: Record<string, any> | undefined;
            customDepthMaterial?: import("three").Material | undefined;
            customDistanceMaterial?: import("three").Material | undefined;
            onBeforeShadow?: ((renderer: import("three").WebGLRenderer, scene: import("three").Scene, camera: import("three").Camera, shadowCamera: import("three").Camera, geometry: BufferGeometry, depthMaterial: import("three").Material, group: import("three").Group) => void) | undefined;
            onAfterShadow?: ((renderer: import("three").WebGLRenderer, scene: import("three").Scene, camera: import("three").Camera, shadowCamera: import("three").Camera, geometry: BufferGeometry, depthMaterial: import("three").Material, group: import("three").Group) => void) | undefined;
            onBeforeRender?: ((renderer: import("three").WebGLRenderer, scene: import("three").Scene, camera: import("three").Camera, geometry: BufferGeometry, material: import("three").Material, group: import("three").Group) => void) | undefined;
            onAfterRender?: ((renderer: import("three").WebGLRenderer, scene: import("three").Scene, camera: import("three").Camera, geometry: BufferGeometry, material: import("three").Material, group: import("three").Group) => void) | undefined;
            applyMatrix4?: ((matrix: import("three").Matrix4) => void) | undefined;
            applyQuaternion?: ((quaternion: import("three").Quaternion) => import("three-stdlib").Line2) | undefined;
            setRotationFromAxisAngle?: ((axis: import("three").Vector3, angle: number) => void) | undefined;
            setRotationFromEuler?: ((euler: import("three").Euler) => void) | undefined;
            setRotationFromMatrix?: ((m: import("three").Matrix4) => void) | undefined;
            setRotationFromQuaternion?: ((q: import("three").Quaternion) => void) | undefined;
            rotateOnAxis?: ((axis: import("three").Vector3, angle: number) => import("three-stdlib").Line2) | undefined;
            rotateOnWorldAxis?: ((axis: import("three").Vector3, angle: number) => import("three-stdlib").Line2) | undefined;
            rotateX?: ((angle: number) => import("three-stdlib").Line2) | undefined;
            rotateY?: ((angle: number) => import("three-stdlib").Line2) | undefined;
            rotateZ?: ((angle: number) => import("three-stdlib").Line2) | undefined;
            translateOnAxis?: ((axis: import("three").Vector3, distance: number) => import("three-stdlib").Line2) | undefined;
            translateX?: ((distance: number) => import("three-stdlib").Line2) | undefined;
            translateY?: ((distance: number) => import("three-stdlib").Line2) | undefined;
            translateZ?: ((distance: number) => import("three-stdlib").Line2) | undefined;
            localToWorld?: ((vector: import("three").Vector3) => import("three").Vector3) | undefined;
            worldToLocal?: ((vector: import("three").Vector3) => import("three").Vector3) | undefined;
            lookAt?: {
                (vector: import("three").Vector3): void;
                (x: number, y: number, z: number): void;
            } | undefined;
            add?: ((...object: import("three").Object3D[]) => import("three-stdlib").Line2) | undefined;
            remove?: ((...object: import("three").Object3D[]) => import("three-stdlib").Line2) | undefined;
            removeFromParent?: (() => import("three-stdlib").Line2) | undefined;
            clear?: (() => import("three-stdlib").Line2) | undefined;
            getObjectById?: ((id: number) => import("three").Object3D | undefined) | undefined;
            getObjectByName?: ((name: string) => import("three").Object3D | undefined) | undefined;
            getObjectByProperty?: ((name: string, value: any) => import("three").Object3D | undefined) | undefined;
            getObjectsByProperty?: ((name: string, value: any, optionalTarget?: import("three").Object3D[]) => import("three").Object3D[]) | undefined;
            getWorldPosition?: ((target: import("three").Vector3) => import("three").Vector3) | undefined;
            getWorldQuaternion?: ((target: import("three").Quaternion) => import("three").Quaternion) | undefined;
            getWorldScale?: ((target: import("three").Vector3) => import("three").Vector3) | undefined;
            getWorldDirection?: ((target: import("three").Vector3) => import("three").Vector3) | undefined;
            traverse?: ((callback: (object: import("three").Object3D) => any) => void) | undefined;
            traverseVisible?: ((callback: (object: import("three").Object3D) => any) => void) | undefined;
            traverseAncestors?: ((callback: (object: import("three").Object3D) => any) => void) | undefined;
            updateMatrix?: (() => void) | undefined;
            updateMatrixWorld?: ((force?: boolean) => void) | undefined;
            updateWorldMatrix?: ((updateParents: boolean, updateChildren: boolean) => void) | undefined;
            clone?: ((recursive?: boolean) => import("three-stdlib").Line2) | undefined;
            copy?: ((object: import("three").Object3D, recursive?: boolean) => import("three-stdlib").Line2) | undefined;
            hasEventListener?: (<T extends keyof import("three").Object3DEventMap>(type: T, listener: import("three").EventListener<import("three").Object3DEventMap[T], T, import("three-stdlib").Line2>) => boolean) | undefined;
            dispatchEvent?: (<T extends keyof import("three").Object3DEventMap>(event: import("three").BaseEvent<T> & import("three").Object3DEventMap[T]) => void) | undefined;
            readonly isLine2?: true | undefined;
            readonly isLineSegments2?: true | undefined;
            computeLineDistances?: (() => import("three-stdlib").Line2) | undefined;
            position: import("angular-three").NgtVector3;
            up: import("angular-three").NgtVector3;
            scale: import("angular-three").NgtVector3;
            rotation: import("angular-three").NgtEuler;
            matrix: import("angular-three").NgtMatrix4;
            quaternion: import("angular-three").NgtQuaternion;
            layers: import("angular-three").NgtLayers;
            dispose: (() => void) | null;
            raycast: import("three").Object3D["raycast"] | null;
        }, ev: import("angular-three").NgtAllObject3DEventsMap[TEventKey]) => any) => void) & (<TEventKey extends keyof import("angular-three").NgtNodeEventMap<TOriginal>>(type: TEventKey, listener: (this: import("angular-three").NgtNodeElement<import("three-stdlib").LineMaterial, [LineMaterialParameters]>, ev: import("angular-three").NgtNodeEventMap<import("three-stdlib").LineMaterial>[TEventKey]) => any) => void) & (<TEventKey extends keyof import("angular-three").NgtAllObject3DEventsMap>(type: TEventKey, listener: (this: {
            addEventListener: (<TEventKey_1 extends keyof import("angular-three").NgtNodeEventMap<TOriginal>>(type: TEventKey_1, listener: (this: import("angular-three").NgtNodeElement<import("three-stdlib").LineMaterial, [LineMaterialParameters]>, ev: import("angular-three").NgtNodeEventMap<import("three-stdlib").LineMaterial>[TEventKey_1]) => any) => void) & /*elided*/ any;
            removeEventListener: (<TEventKey_1 extends keyof import("angular-three").NgtNodeEventMap<TOriginal>>(type: TEventKey_1, listener: (this: import("angular-three").NgtNodeElement<import("three-stdlib").LineMaterial, [LineMaterialParameters]>, ev: import("angular-three").NgtNodeEventMap<import("three-stdlib").LineMaterial>[TEventKey_1]) => any) => void) & (<TEventKey_1 extends keyof import("angular-three").NgtAllObject3DEventsMap>(type: TEventKey_1, listener: (this: /*elided*/ any, ev: import("angular-three").NgtAllObject3DEventsMap[TEventKey_1]) => any) => void);
            attach: string | string[] | import("angular-three").NgtAttachFunction;
            __ngt_args__: [LineMaterialParameters];
            type?: string | undefined;
            toJSON?: ((meta?: import("three").JSONMeta) => import("three").ShaderMaterialJSON) | undefined;
            id?: number | undefined;
            uuid?: string | undefined;
            name?: string | undefined;
            visible?: boolean | undefined;
            userData?: Record<string, any> | undefined;
            onBeforeRender?: ((renderer: import("three").WebGLRenderer, scene: import("three").Scene, camera: import("three").Camera, geometry: BufferGeometry, object: import("three").Object3D, group: import("three").Group) => void) | undefined;
            clone?: (() => import("three-stdlib").LineMaterial) | undefined;
            copy?: ((material: import("three").Material) => import("three-stdlib").LineMaterial) | undefined;
            hasEventListener?: (<T extends "dispose">(type: T, listener: import("three").EventListener<{
                dispose: {};
            }[T], T, import("three-stdlib").LineMaterial>) => boolean) | undefined;
            dispatchEvent?: (<T extends "dispose">(event: import("three").BaseEvent<T> & {
                dispose: {};
            }[T]) => void) | undefined;
            color?: ColorRepresentation | undefined;
            vertexColors?: boolean | undefined;
            alphaToCoverage?: boolean | undefined;
            dashed?: boolean | undefined;
            dashScale?: number | undefined;
            dashSize?: number | undefined;
            dashOffset?: number | undefined;
            gapSize?: number | undefined;
            linewidth?: number | undefined;
            resolution?: import("three").Vector2 | undefined;
            wireframe?: boolean | undefined;
            worldUnits?: boolean | undefined;
            alphaHash?: boolean | undefined;
            alphaTest?: number;
            blendAlpha?: number | undefined;
            blendColor?: ColorRepresentation | undefined;
            blendDst?: import("three").BlendingDstFactor | undefined;
            blendDstAlpha?: number | null | undefined;
            blendEquation?: import("three").BlendingEquation | undefined;
            blendEquationAlpha?: number | null | undefined;
            blending?: import("three").Blending | undefined;
            blendSrc?: 200 | 201 | 202 | 203 | 204 | 205 | 206 | 207 | 208 | 209 | 211 | 212 | 213 | 214 | 210 | undefined;
            blendSrcAlpha?: number | null | undefined;
            clipIntersection?: boolean | undefined;
            clippingPlanes?: import("three").Plane[] | null | undefined;
            clipShadows?: boolean | undefined;
            colorWrite?: boolean | undefined;
            defines?: {
                [key: string]: any;
            } | undefined;
            depthFunc?: import("three").DepthModes | undefined;
            depthTest?: boolean | undefined;
            depthWrite?: boolean | undefined;
            opacity?: number | undefined;
            polygonOffset?: boolean | undefined;
            polygonOffsetFactor?: number | undefined;
            polygonOffsetUnits?: number | undefined;
            precision?: "highp" | "mediump" | "lowp" | null | undefined;
            premultipliedAlpha?: boolean | undefined;
            forceSinglePass?: boolean | undefined;
            dithering?: boolean | undefined;
            side?: import("three").Side | undefined;
            shadowSide?: import("three").Side | null | undefined;
            toneMapped?: boolean | undefined;
            transparent?: boolean | undefined;
            stencilWrite?: boolean | undefined;
            stencilFunc?: import("three").StencilFunc | undefined;
            stencilRef?: number | undefined;
            stencilWriteMask?: number | undefined;
            stencilFuncMask?: number | undefined;
            stencilFail?: import("three").StencilOp | undefined;
            stencilZFail?: import("three").StencilOp | undefined;
            stencilZPass?: import("three").StencilOp | undefined;
            readonly isLineMaterial?: true | undefined;
            readonly isShaderMaterial?: true | undefined;
            uniforms?: {
                [uniform: string]: import("three").IUniform<any>;
            } | undefined;
            uniformsGroups?: import("three").UniformsGroup[] | undefined;
            vertexShader?: string | undefined;
            fragmentShader?: string | undefined;
            wireframeLinewidth?: number | undefined;
            fog?: boolean | undefined;
            lights?: boolean | undefined;
            clipping?: boolean | undefined;
            extensions?: {
                clipCullDistance: boolean;
                multiDraw: boolean;
            } | undefined;
            defaultAttributeValues?: any;
            index0AttributeName?: string | undefined;
            uniformsNeedUpdate?: boolean | undefined;
            glslVersion?: import("three").GLSLVersion | null | undefined;
            setValues?: ((parameters: import("three").ShaderMaterialParameters) => void) | undefined;
            readonly isMaterial?: true | undefined;
            version?: number | undefined;
            onBeforeCompile?: ((parameters: import("three").WebGLProgramParametersWithUniforms, renderer: import("three").WebGLRenderer) => void) | undefined;
            customProgramCacheKey?: (() => string) | undefined;
            needsUpdate?: boolean | undefined;
            onBuild?: ((object: import("three").Object3D, parameters: import("three").WebGLProgramParametersWithUniforms, renderer: import("three").WebGLRenderer) => void) | undefined;
            position: import("angular-three").NgtVector3;
            up: import("angular-three").NgtVector3;
            scale: import("angular-three").NgtVector3;
            rotation: import("angular-three").NgtEuler;
            matrix: import("angular-three").NgtMatrix4;
            quaternion: import("angular-three").NgtQuaternion;
            layers: import("angular-three").NgtLayers;
            dispose: (() => void) | null;
            raycast: import("three").Object3D["raycast"] | null;
        }, ev: import("angular-three").NgtAllObject3DEventsMap[TEventKey]) => any) => void)) | undefined;
        removeEventListener?: ((<TEventKey extends keyof import("angular-three").NgtNodeEventMap<TOriginal>>(type: TEventKey, listener: (this: import("angular-three").NgtNodeElement<Mesh<BufferGeometry<import("three").NormalBufferAttributes>, import("three").Material | import("three").Material[], import("three").Object3DEventMap>, typeof Mesh>, ev: import("angular-three").NgtNodeEventMap<Mesh<BufferGeometry<import("three").NormalBufferAttributes>, import("three").Material | import("three").Material[], import("three").Object3DEventMap>>[TEventKey]) => any) => void) & (<TEventKey extends keyof import("angular-three").NgtAllObject3DEventsMap>(type: TEventKey, listener: (this: {
            addEventListener: (<TEventKey_1 extends keyof import("angular-three").NgtNodeEventMap<TOriginal>>(type: TEventKey_1, listener: (this: import("angular-three").NgtNodeElement<Mesh<BufferGeometry<import("three").NormalBufferAttributes>, import("three").Material | import("three").Material[], import("three").Object3DEventMap>, typeof Mesh>, ev: import("angular-three").NgtNodeEventMap<Mesh<BufferGeometry<import("three").NormalBufferAttributes>, import("three").Material | import("three").Material[], import("three").Object3DEventMap>>[TEventKey_1]) => any) => void) & (<TEventKey_1 extends keyof import("angular-three").NgtAllObject3DEventsMap>(type: TEventKey_1, listener: (this: /*elided*/ any, ev: import("angular-three").NgtAllObject3DEventsMap[TEventKey_1]) => any) => void);
            removeEventListener: (<TEventKey_1 extends keyof import("angular-three").NgtNodeEventMap<TOriginal>>(type: TEventKey_1, listener: (this: import("angular-three").NgtNodeElement<Mesh<BufferGeometry<import("three").NormalBufferAttributes>, import("three").Material | import("three").Material[], import("three").Object3DEventMap>, typeof Mesh>, ev: import("angular-three").NgtNodeEventMap<Mesh<BufferGeometry<import("three").NormalBufferAttributes>, import("three").Material | import("three").Material[], import("three").Object3DEventMap>>[TEventKey_1]) => any) => void) & /*elided*/ any;
            attach: string | string[] | import("angular-three").NgtAttachFunction;
            __ngt_args__: [geometry?: BufferGeometry<import("three").NormalBufferAttributes> | undefined, material?: import("three").Material | import("three").Material[] | undefined];
            readonly isMesh?: true | undefined;
            readonly type?: string | undefined;
            geometry?: BufferGeometry<import("three").NormalBufferAttributes> | undefined;
            material?: import("three").Material | import("three").Material[] | undefined;
            morphTargetInfluences?: number[] | undefined | undefined;
            morphTargetDictionary?: {
                [key: string]: number;
            } | undefined | undefined;
            updateMorphTargets?: (() => void) | undefined;
            getVertexPosition?: ((index: number, target: import("three").Vector3) => import("three").Vector3) | undefined;
            toJSON?: ((meta?: import("three").JSONMeta) => import("three").MeshJSON) | undefined;
            readonly isObject3D?: true | undefined;
            readonly id?: number | undefined;
            uuid?: string | undefined;
            name?: string | undefined;
            parent?: import("three").Object3D<import("three").Object3DEventMap> | null | undefined;
            children?: import("three").Object3D<import("three").Object3DEventMap>[] | undefined;
            readonly modelViewMatrix?: import("three").Matrix4 | undefined;
            readonly normalMatrix?: import("three").Matrix3 | undefined;
            matrixWorld?: import("three").Matrix4 | undefined;
            matrixAutoUpdate?: boolean | undefined;
            matrixWorldAutoUpdate?: boolean | undefined;
            matrixWorldNeedsUpdate?: boolean | undefined;
            visible?: boolean | undefined;
            castShadow?: boolean | undefined;
            receiveShadow?: boolean | undefined;
            frustumCulled?: boolean | undefined;
            renderOrder?: number | undefined;
            animations?: import("three").AnimationClip[] | undefined;
            userData?: Record<string, any> | undefined;
            customDepthMaterial?: import("three").Material | undefined;
            customDistanceMaterial?: import("three").Material | undefined;
            onBeforeShadow?: ((renderer: import("three").WebGLRenderer, scene: import("three").Scene, camera: import("three").Camera, shadowCamera: import("three").Camera, geometry: BufferGeometry, depthMaterial: import("three").Material, group: import("three").Group) => void) | undefined;
            onAfterShadow?: ((renderer: import("three").WebGLRenderer, scene: import("three").Scene, camera: import("three").Camera, shadowCamera: import("three").Camera, geometry: BufferGeometry, depthMaterial: import("three").Material, group: import("three").Group) => void) | undefined;
            onBeforeRender?: ((renderer: import("three").WebGLRenderer, scene: import("three").Scene, camera: import("three").Camera, geometry: BufferGeometry, material: import("three").Material, group: import("three").Group) => void) | undefined;
            onAfterRender?: ((renderer: import("three").WebGLRenderer, scene: import("three").Scene, camera: import("three").Camera, geometry: BufferGeometry, material: import("three").Material, group: import("three").Group) => void) | undefined;
            applyMatrix4?: ((matrix: import("three").Matrix4) => void) | undefined;
            applyQuaternion?: ((quaternion: import("three").Quaternion) => Mesh<BufferGeometry<import("three").NormalBufferAttributes>, import("three").Material | import("three").Material[], import("three").Object3DEventMap>) | undefined;
            setRotationFromAxisAngle?: ((axis: import("three").Vector3, angle: number) => void) | undefined;
            setRotationFromEuler?: ((euler: import("three").Euler) => void) | undefined;
            setRotationFromMatrix?: ((m: import("three").Matrix4) => void) | undefined;
            setRotationFromQuaternion?: ((q: import("three").Quaternion) => void) | undefined;
            rotateOnAxis?: ((axis: import("three").Vector3, angle: number) => Mesh<BufferGeometry<import("three").NormalBufferAttributes>, import("three").Material | import("three").Material[], import("three").Object3DEventMap>) | undefined;
            rotateOnWorldAxis?: ((axis: import("three").Vector3, angle: number) => Mesh<BufferGeometry<import("three").NormalBufferAttributes>, import("three").Material | import("three").Material[], import("three").Object3DEventMap>) | undefined;
            rotateX?: ((angle: number) => Mesh<BufferGeometry<import("three").NormalBufferAttributes>, import("three").Material | import("three").Material[], import("three").Object3DEventMap>) | undefined;
            rotateY?: ((angle: number) => Mesh<BufferGeometry<import("three").NormalBufferAttributes>, import("three").Material | import("three").Material[], import("three").Object3DEventMap>) | undefined;
            rotateZ?: ((angle: number) => Mesh<BufferGeometry<import("three").NormalBufferAttributes>, import("three").Material | import("three").Material[], import("three").Object3DEventMap>) | undefined;
            translateOnAxis?: ((axis: import("three").Vector3, distance: number) => Mesh<BufferGeometry<import("three").NormalBufferAttributes>, import("three").Material | import("three").Material[], import("three").Object3DEventMap>) | undefined;
            translateX?: ((distance: number) => Mesh<BufferGeometry<import("three").NormalBufferAttributes>, import("three").Material | import("three").Material[], import("three").Object3DEventMap>) | undefined;
            translateY?: ((distance: number) => Mesh<BufferGeometry<import("three").NormalBufferAttributes>, import("three").Material | import("three").Material[], import("three").Object3DEventMap>) | undefined;
            translateZ?: ((distance: number) => Mesh<BufferGeometry<import("three").NormalBufferAttributes>, import("three").Material | import("three").Material[], import("three").Object3DEventMap>) | undefined;
            localToWorld?: ((vector: import("three").Vector3) => import("three").Vector3) | undefined;
            worldToLocal?: ((vector: import("three").Vector3) => import("three").Vector3) | undefined;
            lookAt?: {
                (vector: import("three").Vector3): void;
                (x: number, y: number, z: number): void;
            } | undefined;
            add?: ((...object: import("three").Object3D[]) => Mesh<BufferGeometry<import("three").NormalBufferAttributes>, import("three").Material | import("three").Material[], import("three").Object3DEventMap>) | undefined;
            remove?: ((...object: import("three").Object3D[]) => Mesh<BufferGeometry<import("three").NormalBufferAttributes>, import("three").Material | import("three").Material[], import("three").Object3DEventMap>) | undefined;
            removeFromParent?: (() => Mesh<BufferGeometry<import("three").NormalBufferAttributes>, import("three").Material | import("three").Material[], import("three").Object3DEventMap>) | undefined;
            clear?: (() => Mesh<BufferGeometry<import("three").NormalBufferAttributes>, import("three").Material | import("three").Material[], import("three").Object3DEventMap>) | undefined;
            getObjectById?: ((id: number) => import("three").Object3D | undefined) | undefined;
            getObjectByName?: ((name: string) => import("three").Object3D | undefined) | undefined;
            getObjectByProperty?: ((name: string, value: any) => import("three").Object3D | undefined) | undefined;
            getObjectsByProperty?: ((name: string, value: any, optionalTarget?: import("three").Object3D[]) => import("three").Object3D[]) | undefined;
            getWorldPosition?: ((target: import("three").Vector3) => import("three").Vector3) | undefined;
            getWorldQuaternion?: ((target: import("three").Quaternion) => import("three").Quaternion) | undefined;
            getWorldScale?: ((target: import("three").Vector3) => import("three").Vector3) | undefined;
            getWorldDirection?: ((target: import("three").Vector3) => import("three").Vector3) | undefined;
            traverse?: ((callback: (object: import("three").Object3D) => any) => void) | undefined;
            traverseVisible?: ((callback: (object: import("three").Object3D) => any) => void) | undefined;
            traverseAncestors?: ((callback: (object: import("three").Object3D) => any) => void) | undefined;
            updateMatrix?: (() => void) | undefined;
            updateMatrixWorld?: ((force?: boolean) => void) | undefined;
            updateWorldMatrix?: ((updateParents: boolean, updateChildren: boolean) => void) | undefined;
            clone?: ((recursive?: boolean) => Mesh<BufferGeometry<import("three").NormalBufferAttributes>, import("three").Material | import("three").Material[], import("three").Object3DEventMap>) | undefined;
            copy?: ((object: import("three").Object3D, recursive?: boolean) => Mesh<BufferGeometry<import("three").NormalBufferAttributes>, import("three").Material | import("three").Material[], import("three").Object3DEventMap>) | undefined;
            hasEventListener?: (<T extends keyof import("three").Object3DEventMap>(type: T, listener: import("three").EventListener<import("three").Object3DEventMap[T], T, Mesh<BufferGeometry<import("three").NormalBufferAttributes>, import("three").Material | import("three").Material[], import("three").Object3DEventMap>>) => boolean) | undefined;
            dispatchEvent?: (<T extends keyof import("three").Object3DEventMap>(event: import("three").BaseEvent<T> & import("three").Object3DEventMap[T]) => void) | undefined;
            position: import("angular-three").NgtVector3;
            up: import("angular-three").NgtVector3;
            scale: import("angular-three").NgtVector3;
            rotation: import("angular-three").NgtEuler;
            matrix: import("angular-three").NgtMatrix4;
            quaternion: import("angular-three").NgtQuaternion;
            layers: import("angular-three").NgtLayers;
            dispose: (() => void) | null;
            raycast: import("three").Object3D["raycast"] | null;
        }, ev: import("angular-three").NgtAllObject3DEventsMap[TEventKey]) => any) => void) & (<TEventKey extends keyof import("angular-three").NgtNodeEventMap<TOriginal>>(type: TEventKey, listener: (this: import("angular-three").NgtNodeElement<import("three-stdlib").Line2, typeof import("three-stdlib").Line2>, ev: import("angular-three").NgtNodeEventMap<import("three-stdlib").Line2>[TEventKey]) => any) => void) & (<TEventKey extends keyof import("angular-three").NgtAllObject3DEventsMap>(type: TEventKey, listener: (this: {
            addEventListener: (<TEventKey_1 extends keyof import("angular-three").NgtNodeEventMap<TOriginal>>(type: TEventKey_1, listener: (this: import("angular-three").NgtNodeElement<import("three-stdlib").Line2, typeof import("three-stdlib").Line2>, ev: import("angular-three").NgtNodeEventMap<import("three-stdlib").Line2>[TEventKey_1]) => any) => void) & (<TEventKey_1 extends keyof import("angular-three").NgtAllObject3DEventsMap>(type: TEventKey_1, listener: (this: /*elided*/ any, ev: import("angular-three").NgtAllObject3DEventsMap[TEventKey_1]) => any) => void);
            removeEventListener: (<TEventKey_1 extends keyof import("angular-three").NgtNodeEventMap<TOriginal>>(type: TEventKey_1, listener: (this: import("angular-three").NgtNodeElement<import("three-stdlib").Line2, typeof import("three-stdlib").Line2>, ev: import("angular-three").NgtNodeEventMap<import("three-stdlib").Line2>[TEventKey_1]) => any) => void) & /*elided*/ any;
            attach: string | string[] | import("angular-three").NgtAttachFunction;
            __ngt_args__: [geometry?: import("three-stdlib").LineGeometry | undefined, material?: import("three-stdlib").LineMaterial | undefined];
            readonly isMesh?: true | undefined;
            readonly type?: string | undefined;
            geometry?: import("three-stdlib").LineGeometry | undefined;
            material?: import("three-stdlib").LineMaterial | undefined;
            morphTargetInfluences?: number[] | undefined | undefined;
            morphTargetDictionary?: {
                [key: string]: number;
            } | undefined | undefined;
            updateMorphTargets?: (() => void) | undefined;
            getVertexPosition?: ((index: number, target: import("three").Vector3) => import("three").Vector3) | undefined;
            toJSON?: ((meta?: import("three").JSONMeta) => import("three").MeshJSON) | undefined;
            readonly isObject3D?: true | undefined;
            readonly id?: number | undefined;
            uuid?: string | undefined;
            name?: string | undefined;
            parent?: import("three").Object3D<import("three").Object3DEventMap> | null | undefined;
            children?: import("three").Object3D<import("three").Object3DEventMap>[] | undefined;
            readonly modelViewMatrix?: import("three").Matrix4 | undefined;
            readonly normalMatrix?: import("three").Matrix3 | undefined;
            matrixWorld?: import("three").Matrix4 | undefined;
            matrixAutoUpdate?: boolean | undefined;
            matrixWorldAutoUpdate?: boolean | undefined;
            matrixWorldNeedsUpdate?: boolean | undefined;
            visible?: boolean | undefined;
            castShadow?: boolean | undefined;
            receiveShadow?: boolean | undefined;
            frustumCulled?: boolean | undefined;
            renderOrder?: number | undefined;
            animations?: import("three").AnimationClip[] | undefined;
            userData?: Record<string, any> | undefined;
            customDepthMaterial?: import("three").Material | undefined;
            customDistanceMaterial?: import("three").Material | undefined;
            onBeforeShadow?: ((renderer: import("three").WebGLRenderer, scene: import("three").Scene, camera: import("three").Camera, shadowCamera: import("three").Camera, geometry: BufferGeometry, depthMaterial: import("three").Material, group: import("three").Group) => void) | undefined;
            onAfterShadow?: ((renderer: import("three").WebGLRenderer, scene: import("three").Scene, camera: import("three").Camera, shadowCamera: import("three").Camera, geometry: BufferGeometry, depthMaterial: import("three").Material, group: import("three").Group) => void) | undefined;
            onBeforeRender?: ((renderer: import("three").WebGLRenderer, scene: import("three").Scene, camera: import("three").Camera, geometry: BufferGeometry, material: import("three").Material, group: import("three").Group) => void) | undefined;
            onAfterRender?: ((renderer: import("three").WebGLRenderer, scene: import("three").Scene, camera: import("three").Camera, geometry: BufferGeometry, material: import("three").Material, group: import("three").Group) => void) | undefined;
            applyMatrix4?: ((matrix: import("three").Matrix4) => void) | undefined;
            applyQuaternion?: ((quaternion: import("three").Quaternion) => import("three-stdlib").Line2) | undefined;
            setRotationFromAxisAngle?: ((axis: import("three").Vector3, angle: number) => void) | undefined;
            setRotationFromEuler?: ((euler: import("three").Euler) => void) | undefined;
            setRotationFromMatrix?: ((m: import("three").Matrix4) => void) | undefined;
            setRotationFromQuaternion?: ((q: import("three").Quaternion) => void) | undefined;
            rotateOnAxis?: ((axis: import("three").Vector3, angle: number) => import("three-stdlib").Line2) | undefined;
            rotateOnWorldAxis?: ((axis: import("three").Vector3, angle: number) => import("three-stdlib").Line2) | undefined;
            rotateX?: ((angle: number) => import("three-stdlib").Line2) | undefined;
            rotateY?: ((angle: number) => import("three-stdlib").Line2) | undefined;
            rotateZ?: ((angle: number) => import("three-stdlib").Line2) | undefined;
            translateOnAxis?: ((axis: import("three").Vector3, distance: number) => import("three-stdlib").Line2) | undefined;
            translateX?: ((distance: number) => import("three-stdlib").Line2) | undefined;
            translateY?: ((distance: number) => import("three-stdlib").Line2) | undefined;
            translateZ?: ((distance: number) => import("three-stdlib").Line2) | undefined;
            localToWorld?: ((vector: import("three").Vector3) => import("three").Vector3) | undefined;
            worldToLocal?: ((vector: import("three").Vector3) => import("three").Vector3) | undefined;
            lookAt?: {
                (vector: import("three").Vector3): void;
                (x: number, y: number, z: number): void;
            } | undefined;
            add?: ((...object: import("three").Object3D[]) => import("three-stdlib").Line2) | undefined;
            remove?: ((...object: import("three").Object3D[]) => import("three-stdlib").Line2) | undefined;
            removeFromParent?: (() => import("three-stdlib").Line2) | undefined;
            clear?: (() => import("three-stdlib").Line2) | undefined;
            getObjectById?: ((id: number) => import("three").Object3D | undefined) | undefined;
            getObjectByName?: ((name: string) => import("three").Object3D | undefined) | undefined;
            getObjectByProperty?: ((name: string, value: any) => import("three").Object3D | undefined) | undefined;
            getObjectsByProperty?: ((name: string, value: any, optionalTarget?: import("three").Object3D[]) => import("three").Object3D[]) | undefined;
            getWorldPosition?: ((target: import("three").Vector3) => import("three").Vector3) | undefined;
            getWorldQuaternion?: ((target: import("three").Quaternion) => import("three").Quaternion) | undefined;
            getWorldScale?: ((target: import("three").Vector3) => import("three").Vector3) | undefined;
            getWorldDirection?: ((target: import("three").Vector3) => import("three").Vector3) | undefined;
            traverse?: ((callback: (object: import("three").Object3D) => any) => void) | undefined;
            traverseVisible?: ((callback: (object: import("three").Object3D) => any) => void) | undefined;
            traverseAncestors?: ((callback: (object: import("three").Object3D) => any) => void) | undefined;
            updateMatrix?: (() => void) | undefined;
            updateMatrixWorld?: ((force?: boolean) => void) | undefined;
            updateWorldMatrix?: ((updateParents: boolean, updateChildren: boolean) => void) | undefined;
            clone?: ((recursive?: boolean) => import("three-stdlib").Line2) | undefined;
            copy?: ((object: import("three").Object3D, recursive?: boolean) => import("three-stdlib").Line2) | undefined;
            hasEventListener?: (<T extends keyof import("three").Object3DEventMap>(type: T, listener: import("three").EventListener<import("three").Object3DEventMap[T], T, import("three-stdlib").Line2>) => boolean) | undefined;
            dispatchEvent?: (<T extends keyof import("three").Object3DEventMap>(event: import("three").BaseEvent<T> & import("three").Object3DEventMap[T]) => void) | undefined;
            readonly isLine2?: true | undefined;
            readonly isLineSegments2?: true | undefined;
            computeLineDistances?: (() => import("three-stdlib").Line2) | undefined;
            position: import("angular-three").NgtVector3;
            up: import("angular-three").NgtVector3;
            scale: import("angular-three").NgtVector3;
            rotation: import("angular-three").NgtEuler;
            matrix: import("angular-three").NgtMatrix4;
            quaternion: import("angular-three").NgtQuaternion;
            layers: import("angular-three").NgtLayers;
            dispose: (() => void) | null;
            raycast: import("three").Object3D["raycast"] | null;
        }, ev: import("angular-three").NgtAllObject3DEventsMap[TEventKey]) => any) => void) & (<TEventKey extends keyof import("angular-three").NgtNodeEventMap<TOriginal>>(type: TEventKey, listener: (this: import("angular-three").NgtNodeElement<import("three-stdlib").LineMaterial, [LineMaterialParameters]>, ev: import("angular-three").NgtNodeEventMap<import("three-stdlib").LineMaterial>[TEventKey]) => any) => void) & (<TEventKey extends keyof import("angular-three").NgtAllObject3DEventsMap>(type: TEventKey, listener: (this: {
            addEventListener: (<TEventKey_1 extends keyof import("angular-three").NgtNodeEventMap<TOriginal>>(type: TEventKey_1, listener: (this: import("angular-three").NgtNodeElement<import("three-stdlib").LineMaterial, [LineMaterialParameters]>, ev: import("angular-three").NgtNodeEventMap<import("three-stdlib").LineMaterial>[TEventKey_1]) => any) => void) & (<TEventKey_1 extends keyof import("angular-three").NgtAllObject3DEventsMap>(type: TEventKey_1, listener: (this: /*elided*/ any, ev: import("angular-three").NgtAllObject3DEventsMap[TEventKey_1]) => any) => void);
            removeEventListener: (<TEventKey_1 extends keyof import("angular-three").NgtNodeEventMap<TOriginal>>(type: TEventKey_1, listener: (this: import("angular-three").NgtNodeElement<import("three-stdlib").LineMaterial, [LineMaterialParameters]>, ev: import("angular-three").NgtNodeEventMap<import("three-stdlib").LineMaterial>[TEventKey_1]) => any) => void) & /*elided*/ any;
            attach: string | string[] | import("angular-three").NgtAttachFunction;
            __ngt_args__: [LineMaterialParameters];
            type?: string | undefined;
            toJSON?: ((meta?: import("three").JSONMeta) => import("three").ShaderMaterialJSON) | undefined;
            id?: number | undefined;
            uuid?: string | undefined;
            name?: string | undefined;
            visible?: boolean | undefined;
            userData?: Record<string, any> | undefined;
            onBeforeRender?: ((renderer: import("three").WebGLRenderer, scene: import("three").Scene, camera: import("three").Camera, geometry: BufferGeometry, object: import("three").Object3D, group: import("three").Group) => void) | undefined;
            clone?: (() => import("three-stdlib").LineMaterial) | undefined;
            copy?: ((material: import("three").Material) => import("three-stdlib").LineMaterial) | undefined;
            hasEventListener?: (<T extends "dispose">(type: T, listener: import("three").EventListener<{
                dispose: {};
            }[T], T, import("three-stdlib").LineMaterial>) => boolean) | undefined;
            dispatchEvent?: (<T extends "dispose">(event: import("three").BaseEvent<T> & {
                dispose: {};
            }[T]) => void) | undefined;
            color?: ColorRepresentation | undefined;
            vertexColors?: boolean | undefined;
            alphaToCoverage?: boolean | undefined;
            dashed?: boolean | undefined;
            dashScale?: number | undefined;
            dashSize?: number | undefined;
            dashOffset?: number | undefined;
            gapSize?: number | undefined;
            linewidth?: number | undefined;
            resolution?: import("three").Vector2 | undefined;
            wireframe?: boolean | undefined;
            worldUnits?: boolean | undefined;
            alphaHash?: boolean | undefined;
            alphaTest?: number;
            blendAlpha?: number | undefined;
            blendColor?: ColorRepresentation | undefined;
            blendDst?: import("three").BlendingDstFactor | undefined;
            blendDstAlpha?: number | null | undefined;
            blendEquation?: import("three").BlendingEquation | undefined;
            blendEquationAlpha?: number | null | undefined;
            blending?: import("three").Blending | undefined;
            blendSrc?: 200 | 201 | 202 | 203 | 204 | 205 | 206 | 207 | 208 | 209 | 211 | 212 | 213 | 214 | 210 | undefined;
            blendSrcAlpha?: number | null | undefined;
            clipIntersection?: boolean | undefined;
            clippingPlanes?: import("three").Plane[] | null | undefined;
            clipShadows?: boolean | undefined;
            colorWrite?: boolean | undefined;
            defines?: {
                [key: string]: any;
            } | undefined;
            depthFunc?: import("three").DepthModes | undefined;
            depthTest?: boolean | undefined;
            depthWrite?: boolean | undefined;
            opacity?: number | undefined;
            polygonOffset?: boolean | undefined;
            polygonOffsetFactor?: number | undefined;
            polygonOffsetUnits?: number | undefined;
            precision?: "highp" | "mediump" | "lowp" | null | undefined;
            premultipliedAlpha?: boolean | undefined;
            forceSinglePass?: boolean | undefined;
            dithering?: boolean | undefined;
            side?: import("three").Side | undefined;
            shadowSide?: import("three").Side | null | undefined;
            toneMapped?: boolean | undefined;
            transparent?: boolean | undefined;
            stencilWrite?: boolean | undefined;
            stencilFunc?: import("three").StencilFunc | undefined;
            stencilRef?: number | undefined;
            stencilWriteMask?: number | undefined;
            stencilFuncMask?: number | undefined;
            stencilFail?: import("three").StencilOp | undefined;
            stencilZFail?: import("three").StencilOp | undefined;
            stencilZPass?: import("three").StencilOp | undefined;
            readonly isLineMaterial?: true | undefined;
            readonly isShaderMaterial?: true | undefined;
            uniforms?: {
                [uniform: string]: import("three").IUniform<any>;
            } | undefined;
            uniformsGroups?: import("three").UniformsGroup[] | undefined;
            vertexShader?: string | undefined;
            fragmentShader?: string | undefined;
            wireframeLinewidth?: number | undefined;
            fog?: boolean | undefined;
            lights?: boolean | undefined;
            clipping?: boolean | undefined;
            extensions?: {
                clipCullDistance: boolean;
                multiDraw: boolean;
            } | undefined;
            defaultAttributeValues?: any;
            index0AttributeName?: string | undefined;
            uniformsNeedUpdate?: boolean | undefined;
            glslVersion?: import("three").GLSLVersion | null | undefined;
            setValues?: ((parameters: import("three").ShaderMaterialParameters) => void) | undefined;
            readonly isMaterial?: true | undefined;
            version?: number | undefined;
            onBeforeCompile?: ((parameters: import("three").WebGLProgramParametersWithUniforms, renderer: import("three").WebGLRenderer) => void) | undefined;
            customProgramCacheKey?: (() => string) | undefined;
            needsUpdate?: boolean | undefined;
            onBuild?: ((object: import("three").Object3D, parameters: import("three").WebGLProgramParametersWithUniforms, renderer: import("three").WebGLRenderer) => void) | undefined;
            position: import("angular-three").NgtVector3;
            up: import("angular-three").NgtVector3;
            scale: import("angular-three").NgtVector3;
            rotation: import("angular-three").NgtEuler;
            matrix: import("angular-three").NgtMatrix4;
            quaternion: import("angular-three").NgtQuaternion;
            layers: import("angular-three").NgtLayers;
            dispose: (() => void) | null;
            raycast: import("three").Object3D["raycast"] | null;
        }, ev: import("angular-three").NgtAllObject3DEventsMap[TEventKey]) => any) => void)) | undefined;
        attach?: string | string[] | import("angular-three").NgtAttachFunction | undefined;
        __ngt_args__?: ([geometry?: BufferGeometry<import("three").NormalBufferAttributes> | undefined, material?: import("three").Material | import("three").Material[] | undefined] & [geometry?: import("three-stdlib").LineGeometry | undefined, material?: import("three-stdlib").LineMaterial | undefined] & [LineMaterialParameters]) | undefined;
        isMesh?: true | undefined;
        type?: string | undefined;
        material?: ((import("three").Material | import("three").Material[]) & import("three-stdlib").LineMaterial) | undefined;
        morphTargetInfluences?: number[] | undefined | undefined;
        morphTargetDictionary?: {
            [key: string]: number;
        } | undefined | undefined;
        updateMorphTargets?: (() => void) | undefined;
        getVertexPosition?: ((index: number, target: import("three").Vector3) => import("three").Vector3) | undefined;
        toJSON?: (((meta?: import("three").JSONMeta) => import("three").MeshJSON) & ((meta?: import("three").JSONMeta) => import("three").ShaderMaterialJSON)) | undefined;
        isObject3D?: true | undefined;
        id?: number | undefined;
        uuid?: string | undefined;
        name?: string | undefined;
        parent?: import("three").Object3D<import("three").Object3DEventMap> | null | undefined;
        children?: import("three").Object3D<import("three").Object3DEventMap>[] | undefined;
        modelViewMatrix?: import("three").Matrix4 | undefined;
        normalMatrix?: import("three").Matrix3 | undefined;
        matrixWorld?: import("three").Matrix4 | undefined;
        matrixAutoUpdate?: boolean | undefined;
        matrixWorldAutoUpdate?: boolean | undefined;
        matrixWorldNeedsUpdate?: boolean | undefined;
        visible?: boolean | undefined;
        castShadow?: boolean | undefined;
        receiveShadow?: boolean | undefined;
        frustumCulled?: boolean | undefined;
        renderOrder?: number | undefined;
        animations?: import("three").AnimationClip[] | undefined;
        userData?: Record<string, any> | undefined;
        customDepthMaterial?: import("three").Material | undefined;
        customDistanceMaterial?: import("three").Material | undefined;
        onBeforeShadow?: ((renderer: import("three").WebGLRenderer, scene: import("three").Scene, camera: import("three").Camera, shadowCamera: import("three").Camera, geometry: BufferGeometry, depthMaterial: import("three").Material, group: import("three").Group) => void) | undefined;
        onAfterShadow?: ((renderer: import("three").WebGLRenderer, scene: import("three").Scene, camera: import("three").Camera, shadowCamera: import("three").Camera, geometry: BufferGeometry, depthMaterial: import("three").Material, group: import("three").Group) => void) | undefined;
        onBeforeRender?: (((renderer: import("three").WebGLRenderer, scene: import("three").Scene, camera: import("three").Camera, geometry: BufferGeometry, material: import("three").Material, group: import("three").Group) => void) & ((renderer: import("three").WebGLRenderer, scene: import("three").Scene, camera: import("three").Camera, geometry: BufferGeometry, object: import("three").Object3D, group: import("three").Group) => void)) | undefined;
        onAfterRender?: ((renderer: import("three").WebGLRenderer, scene: import("three").Scene, camera: import("three").Camera, geometry: BufferGeometry, material: import("three").Material, group: import("three").Group) => void) | undefined;
        applyMatrix4?: ((matrix: import("three").Matrix4) => void) | undefined;
        applyQuaternion?: (((quaternion: import("three").Quaternion) => Mesh<BufferGeometry<import("three").NormalBufferAttributes>, import("three").Material | import("three").Material[], import("three").Object3DEventMap>) & ((quaternion: import("three").Quaternion) => import("three-stdlib").Line2)) | undefined;
        setRotationFromAxisAngle?: ((axis: import("three").Vector3, angle: number) => void) | undefined;
        setRotationFromEuler?: ((euler: import("three").Euler) => void) | undefined;
        setRotationFromMatrix?: ((m: import("three").Matrix4) => void) | undefined;
        setRotationFromQuaternion?: ((q: import("three").Quaternion) => void) | undefined;
        rotateOnAxis?: (((axis: import("three").Vector3, angle: number) => Mesh<BufferGeometry<import("three").NormalBufferAttributes>, import("three").Material | import("three").Material[], import("three").Object3DEventMap>) & ((axis: import("three").Vector3, angle: number) => import("three-stdlib").Line2)) | undefined;
        rotateOnWorldAxis?: (((axis: import("three").Vector3, angle: number) => Mesh<BufferGeometry<import("three").NormalBufferAttributes>, import("three").Material | import("three").Material[], import("three").Object3DEventMap>) & ((axis: import("three").Vector3, angle: number) => import("three-stdlib").Line2)) | undefined;
        rotateX?: (((angle: number) => Mesh<BufferGeometry<import("three").NormalBufferAttributes>, import("three").Material | import("three").Material[], import("three").Object3DEventMap>) & ((angle: number) => import("three-stdlib").Line2)) | undefined;
        rotateY?: (((angle: number) => Mesh<BufferGeometry<import("three").NormalBufferAttributes>, import("three").Material | import("three").Material[], import("three").Object3DEventMap>) & ((angle: number) => import("three-stdlib").Line2)) | undefined;
        rotateZ?: (((angle: number) => Mesh<BufferGeometry<import("three").NormalBufferAttributes>, import("three").Material | import("three").Material[], import("three").Object3DEventMap>) & ((angle: number) => import("three-stdlib").Line2)) | undefined;
        translateOnAxis?: (((axis: import("three").Vector3, distance: number) => Mesh<BufferGeometry<import("three").NormalBufferAttributes>, import("three").Material | import("three").Material[], import("three").Object3DEventMap>) & ((axis: import("three").Vector3, distance: number) => import("three-stdlib").Line2)) | undefined;
        translateX?: (((distance: number) => Mesh<BufferGeometry<import("three").NormalBufferAttributes>, import("three").Material | import("three").Material[], import("three").Object3DEventMap>) & ((distance: number) => import("three-stdlib").Line2)) | undefined;
        translateY?: (((distance: number) => Mesh<BufferGeometry<import("three").NormalBufferAttributes>, import("three").Material | import("three").Material[], import("three").Object3DEventMap>) & ((distance: number) => import("three-stdlib").Line2)) | undefined;
        translateZ?: (((distance: number) => Mesh<BufferGeometry<import("three").NormalBufferAttributes>, import("three").Material | import("three").Material[], import("three").Object3DEventMap>) & ((distance: number) => import("three-stdlib").Line2)) | undefined;
        localToWorld?: ((vector: import("three").Vector3) => import("three").Vector3) | undefined;
        worldToLocal?: ((vector: import("three").Vector3) => import("three").Vector3) | undefined;
        lookAt?: {
            (vector: import("three").Vector3): void;
            (x: number, y: number, z: number): void;
        } | undefined;
        add?: (((...object: import("three").Object3D[]) => Mesh<BufferGeometry<import("three").NormalBufferAttributes>, import("three").Material | import("three").Material[], import("three").Object3DEventMap>) & ((...object: import("three").Object3D[]) => import("three-stdlib").Line2)) | undefined;
        remove?: (((...object: import("three").Object3D[]) => Mesh<BufferGeometry<import("three").NormalBufferAttributes>, import("three").Material | import("three").Material[], import("three").Object3DEventMap>) & ((...object: import("three").Object3D[]) => import("three-stdlib").Line2)) | undefined;
        removeFromParent?: ((() => Mesh<BufferGeometry<import("three").NormalBufferAttributes>, import("three").Material | import("three").Material[], import("three").Object3DEventMap>) & (() => import("three-stdlib").Line2)) | undefined;
        clear?: ((() => Mesh<BufferGeometry<import("three").NormalBufferAttributes>, import("three").Material | import("three").Material[], import("three").Object3DEventMap>) & (() => import("three-stdlib").Line2)) | undefined;
        getObjectById?: ((id: number) => import("three").Object3D | undefined) | undefined;
        getObjectByName?: ((name: string) => import("three").Object3D | undefined) | undefined;
        getObjectByProperty?: ((name: string, value: any) => import("three").Object3D | undefined) | undefined;
        getObjectsByProperty?: ((name: string, value: any, optionalTarget?: import("three").Object3D[]) => import("three").Object3D[]) | undefined;
        getWorldPosition?: ((target: import("three").Vector3) => import("three").Vector3) | undefined;
        getWorldQuaternion?: ((target: import("three").Quaternion) => import("three").Quaternion) | undefined;
        getWorldScale?: ((target: import("three").Vector3) => import("three").Vector3) | undefined;
        getWorldDirection?: ((target: import("three").Vector3) => import("three").Vector3) | undefined;
        traverse?: ((callback: (object: import("three").Object3D) => any) => void) | undefined;
        traverseVisible?: ((callback: (object: import("three").Object3D) => any) => void) | undefined;
        traverseAncestors?: ((callback: (object: import("three").Object3D) => any) => void) | undefined;
        updateMatrix?: (() => void) | undefined;
        updateMatrixWorld?: ((force?: boolean) => void) | undefined;
        updateWorldMatrix?: ((updateParents: boolean, updateChildren: boolean) => void) | undefined;
        clone?: (((recursive?: boolean) => Mesh<BufferGeometry<import("three").NormalBufferAttributes>, import("three").Material | import("three").Material[], import("three").Object3DEventMap>) & ((recursive?: boolean) => import("three-stdlib").Line2) & (() => import("three-stdlib").LineMaterial)) | undefined;
        copy?: (((object: import("three").Object3D, recursive?: boolean) => Mesh<BufferGeometry<import("three").NormalBufferAttributes>, import("three").Material | import("three").Material[], import("three").Object3DEventMap>) & ((object: import("three").Object3D, recursive?: boolean) => import("three-stdlib").Line2) & ((material: import("three").Material) => import("three-stdlib").LineMaterial)) | undefined;
        hasEventListener?: ((<T extends keyof import("three").Object3DEventMap>(type: T, listener: import("three").EventListener<import("three").Object3DEventMap[T], T, Mesh<BufferGeometry<import("three").NormalBufferAttributes>, import("three").Material | import("three").Material[], import("three").Object3DEventMap>>) => boolean) & (<T extends keyof import("three").Object3DEventMap>(type: T, listener: import("three").EventListener<import("three").Object3DEventMap[T], T, import("three-stdlib").Line2>) => boolean) & (<T extends "dispose">(type: T, listener: import("three").EventListener<{
            dispose: {};
        }[T], T, import("three-stdlib").LineMaterial>) => boolean)) | undefined;
        dispatchEvent?: ((<T extends keyof import("three").Object3DEventMap>(event: import("three").BaseEvent<T> & import("three").Object3DEventMap[T]) => void) & (<T extends "dispose">(event: import("three").BaseEvent<T> & {
            dispose: {};
        }[T]) => void)) | undefined;
        color?: ColorRepresentation | undefined;
        alphaToCoverage?: boolean | undefined | undefined;
        dashed?: boolean | undefined | undefined;
        dashScale?: number | undefined | undefined;
        dashSize?: number | undefined | undefined;
        dashOffset?: number | undefined | undefined;
        gapSize?: number | undefined | undefined;
        linewidth?: number | undefined | undefined;
        resolution?: import("three").Vector2 | undefined;
        wireframe?: boolean | undefined | undefined;
        worldUnits?: boolean | undefined | undefined;
        alphaHash?: boolean | undefined | undefined;
        alphaTest?: number | undefined | undefined;
        blendAlpha?: number | undefined | undefined;
        blendColor?: ColorRepresentation | undefined;
        blendDst?: import("three").BlendingDstFactor | undefined;
        blendDstAlpha?: number | undefined | undefined;
        blendEquation?: import("three").BlendingEquation | undefined;
        blendEquationAlpha?: number | undefined | undefined;
        blending?: import("three").Blending | undefined;
        blendSrc?: 200 | 201 | 202 | 203 | 204 | 205 | 206 | 207 | 208 | 209 | 211 | 212 | 213 | 214 | 210 | undefined;
        blendSrcAlpha?: number | undefined | undefined;
        clipIntersection?: boolean | undefined | undefined;
        clippingPlanes?: import("three").Plane[] | undefined | undefined;
        clipShadows?: boolean | undefined | undefined;
        colorWrite?: boolean | undefined | undefined;
        defines?: any;
        depthFunc?: import("three").DepthModes | undefined;
        depthTest?: boolean | undefined | undefined;
        depthWrite?: boolean | undefined | undefined;
        opacity?: number | undefined | undefined;
        polygonOffset?: boolean | undefined | undefined;
        polygonOffsetFactor?: number | undefined | undefined;
        polygonOffsetUnits?: number | undefined | undefined;
        precision?: "highp" | "mediump" | "lowp" | null | undefined | undefined;
        premultipliedAlpha?: boolean | undefined | undefined;
        forceSinglePass?: boolean | undefined | undefined;
        dithering?: boolean | undefined | undefined;
        side?: import("three").Side | undefined;
        shadowSide?: 0 | 1 | 2 | undefined;
        toneMapped?: boolean | undefined | undefined;
        transparent?: boolean | undefined | undefined;
        format?: import("three").PixelFormat | undefined;
        stencilWrite?: boolean | undefined | undefined;
        stencilFunc?: import("three").StencilFunc | undefined;
        stencilRef?: number | undefined | undefined;
        stencilWriteMask?: number | undefined | undefined;
        stencilFuncMask?: number | undefined | undefined;
        stencilFail?: import("three").StencilOp | undefined;
        stencilZFail?: import("three").StencilOp | undefined;
        stencilZPass?: import("three").StencilOp | undefined;
        isLine2?: true | undefined;
        isLineSegments2?: true | undefined;
        computeLineDistances?: (() => import("three-stdlib").Line2) | undefined;
        isLineMaterial?: true | undefined;
        isShaderMaterial?: true | undefined;
        uniforms?: {
            [uniform: string]: import("three").IUniform<any>;
        } | undefined;
        uniformsGroups?: import("three").UniformsGroup[] | undefined;
        vertexShader?: string | undefined;
        fragmentShader?: string | undefined;
        wireframeLinewidth?: number | undefined;
        fog?: boolean | undefined;
        lights?: boolean | undefined;
        clipping?: boolean | undefined;
        extensions?: {
            clipCullDistance: boolean;
            multiDraw: boolean;
        } | undefined;
        defaultAttributeValues?: any;
        index0AttributeName?: string | undefined;
        uniformsNeedUpdate?: boolean | undefined;
        glslVersion?: import("three").GLSLVersion | null | undefined;
        setValues?: ((parameters: import("three").ShaderMaterialParameters) => void) | undefined;
        isMaterial?: true | undefined;
        version?: number | undefined;
        onBeforeCompile?: ((parameters: import("three").WebGLProgramParametersWithUniforms, renderer: import("three").WebGLRenderer) => void) | undefined;
        customProgramCacheKey?: (() => string) | undefined;
        needsUpdate?: boolean | undefined;
        onBuild?: ((object: import("three").Object3D, parameters: import("three").WebGLProgramParametersWithUniforms, renderer: import("three").WebGLRenderer) => void) | undefined;
        lineWidth?: number | undefined;
    }>;
    protected tmpPoints: number[];
    line: import("@angular/core").Signal<NgtsLine>;
    private memoizedGeometry?;
    private memoizedThreshold?;
    constructor();
    static ɵfac: i0.ɵɵFactoryDeclaration<NgtsEdges, never>;
    static ɵcmp: i0.ɵɵComponentDeclaration<NgtsEdges, "ngts-edges", never, { "options": { "alias": "options"; "required": false; "isSignal": true; }; }, {}, never, ["*"], true, never>;
}
