import { ElementRef } from '@angular/core';
import { NgtAfterAttach, NgtObject3DNode } from 'angular-three';
import { ColorRepresentation, Vector2, Vector3 } from 'three';
import { Line2, LineGeometry, LineMaterial, LineMaterialParameters, LineSegments2, LineSegmentsGeometry } from 'three-stdlib';
import * as i0 from "@angular/core";
export type NgtLine2 = NgtObject3DNode<Line2, typeof Line2>;
export type NgtLineMaterial = NgtObject3DNode<LineMaterial, [LineMaterialParameters]>;
export type NgtsLineOptions = Omit<LineMaterialParameters, 'vertexColors' | 'color'> & Omit<Partial<NgtLine2>, '__ngt_args__'> & Omit<Partial<NgtLineMaterial>, 'color' | 'vertexColors' | '__ngt_args__'> & {
    /** Array of colors, [0, 0, 0] */
    vertexColors?: Array<ColorRepresentation | [number, number, number] | [number, number, number, number]>;
    /** Line width, 1 */
    lineWidth: number;
    /** Segments, false */
    segments: boolean;
    /** Color */
    color?: ColorRepresentation;
};
export declare class NgtsLine {
    points: import("@angular/core").InputSignal<(number | Vector3 | Vector2 | [number, number, number] | [number, number])[]>;
    options: import("@angular/core").InputSignalWithTransform<NgtsLineOptions, "" | Partial<NgtsLineOptions>>;
    parameters: import("@angular/core").Signal<Omit<NgtsLineOptions, "color" | "vertexColors" | "dashed" | "linewidth" | "segments" | "lineWidth">>;
    lineRef: import("@angular/core").Signal<ElementRef<Line2 | LineSegments2> | undefined>;
    private store;
    private size;
    private segments;
    private vertexColors;
    protected dashed: import("@angular/core").Signal<boolean | undefined>;
    protected color: import("@angular/core").Signal<ColorRepresentation | undefined>;
    protected vertex: import("@angular/core").Signal<boolean>;
    protected resolution: import("@angular/core").Signal<number[]>;
    private lineWidth;
    private linewidth;
    line2: import("@angular/core").Signal<LineSegments2>;
    lineMaterial: LineMaterial;
    protected actualLineWidth: import("@angular/core").Signal<number>;
    protected itemSize: import("@angular/core").Signal<3 | 4>;
    lineGeometry: import("@angular/core").Signal<LineSegmentsGeometry>;
    onGeometryAttached({ parent }: NgtAfterAttach<LineGeometry, Line2 | LineSegments2>): void;
    constructor();
    static ɵfac: i0.ɵɵFactoryDeclaration<NgtsLine, never>;
    static ɵcmp: i0.ɵɵComponentDeclaration<NgtsLine, "ngts-line", never, { "points": { "alias": "points"; "required": true; "isSignal": true; }; "options": { "alias": "options"; "required": false; "isSignal": true; }; }, {}, never, ["*"], true, never>;
}
