import { ElementRef } from '@angular/core';
import { NgtAttachable } from 'angular-three';
import { ExtrudeGeometry, ExtrudeGeometryOptions, Shape, Vector2 } from 'three';
import * as i0 from "@angular/core";
export interface NgtsPrismGeometryOptions extends Omit<ExtrudeGeometryOptions, 'depth'> {
    /** Height */
    height: number;
}
export declare class NgtsPrismGeometry {
    attach: import("@angular/core").InputSignal<NgtAttachable>;
    vertices: import("@angular/core").InputSignal<(Vector2 | [number, number])[]>;
    options: import("@angular/core").InputSignalWithTransform<NgtsPrismGeometryOptions, "" | Partial<NgtsPrismGeometryOptions>>;
    parameters: import("@angular/core").Signal<{
        depth: number;
        /** Height */
        height: number;
        bevelEnabled?: boolean | undefined | undefined;
        bevelOffset?: number | undefined | undefined;
        bevelSize?: number | undefined | undefined;
        bevelThickness?: number | undefined | undefined;
        curveSegments?: number | undefined | undefined;
        bevelSegments?: number | undefined | undefined;
        steps?: number | undefined | undefined;
        extrudePath?: import("three").Curve<import("three").Vector3> | undefined;
        UVGenerator?: import("three").UVGenerator | undefined;
    }>;
    shape: import("@angular/core").Signal<Shape>;
    geometryRef: import("@angular/core").Signal<ElementRef<ExtrudeGeometry> | undefined>;
    constructor();
    static ɵfac: i0.ɵɵFactoryDeclaration<NgtsPrismGeometry, never>;
    static ɵcmp: i0.ɵɵComponentDeclaration<NgtsPrismGeometry, "ngts-prism-geometry", never, { "attach": { "alias": "attach"; "required": false; "isSignal": true; }; "vertices": { "alias": "vertices"; "required": true; "isSignal": true; }; "options": { "alias": "options"; "required": false; "isSignal": true; }; }, {}, never, ["*"], true, never>;
}
