import { Vector3 } from 'three';
import { NgtsLine, NgtsLineOptions } from './line';
import * as i0 from "@angular/core";
export interface NgtsQuadraticBezierLineOptions extends Omit<NgtsLineOptions, 'segments'> {
    segments?: number;
}
export declare class NgtsQuadraticBezierLine {
    start: import("@angular/core").InputSignal<Vector3 | [number, number, number]>;
    end: import("@angular/core").InputSignal<Vector3 | [number, number, number]>;
    mid: import("@angular/core").InputSignal<Vector3 | [number, number, number] | undefined>;
    options: import("@angular/core").InputSignalWithTransform<NgtsQuadraticBezierLineOptions, "" | Partial<NgtsQuadraticBezierLineOptions>>;
    parameters: import("@angular/core").Signal<Omit<NgtsQuadraticBezierLineOptions, "segments">>;
    private segments;
    line: import("@angular/core").Signal<NgtsLine>;
    points: import("@angular/core").Signal<Vector3[]>;
    private curve;
    setPoints(start: Vector3 | [number, number, number], end: Vector3 | [number, number, number], mid?: Vector3 | [number, number, number]): void;
    private getPoints;
    static ɵfac: i0.ɵɵFactoryDeclaration<NgtsQuadraticBezierLine, never>;
    static ɵcmp: i0.ɵɵComponentDeclaration<NgtsQuadraticBezierLine, "ngts-quadratic-bezier-line", never, { "start": { "alias": "start"; "required": false; "isSignal": true; }; "end": { "alias": "end"; "required": false; "isSignal": true; }; "mid": { "alias": "mid"; "required": false; "isSignal": true; }; "options": { "alias": "options"; "required": false; "isSignal": true; }; }, {}, never, ["*"], true, never>;
}
