import { ElementRef } from '@angular/core';
import { NgtMesh } from 'angular-three';
import { ExtrudeGeometry, Mesh, Shape } from 'three';
import * as i0 from "@angular/core";
import * as i1 from "angular-three";
export interface NgtsRoundedBoxOptions extends Partial<NgtMesh> {
    width: number;
    height: number;
    depth: number;
    radius: number;
    smoothness: number;
    bevelSegments: number;
    steps: number;
    creaseAngle: number;
}
export declare class NgtsRoundedBox {
    options: import("@angular/core").InputSignalWithTransform<NgtsRoundedBoxOptions, "" | Partial<NgtsRoundedBoxOptions>>;
    parameters: import("@angular/core").Signal<Omit<NgtsRoundedBoxOptions, "height" | "bevelSegments" | "width" | "depth" | "radius" | "smoothness" | "steps" | "creaseAngle">>;
    private width;
    private height;
    private depth;
    private radius;
    private smoothness;
    private bevelSegments;
    private steps;
    private creaseAngle;
    meshRef: import("@angular/core").Signal<ElementRef<Mesh<import("three").BufferGeometry<import("three").NormalBufferAttributes>, import("three").Material | import("three").Material[], import("three").Object3DEventMap>>>;
    geometryRef: import("@angular/core").Signal<ElementRef<ExtrudeGeometry> | undefined>;
    protected shape: import("@angular/core").Signal<Shape>;
    protected params: import("@angular/core").Signal<{
        depth: number;
        bevelEnabled: boolean;
        bevelSegments: number;
        steps: number;
        bevelSize: number;
        bevelThickness: number;
        curveSegments: number;
    }>;
    constructor();
    static ɵfac: i0.ɵɵFactoryDeclaration<NgtsRoundedBox, never>;
    static ɵcmp: i0.ɵɵComponentDeclaration<NgtsRoundedBox, "ngts-rounded-box", never, { "options": { "alias": "options"; "required": false; "isSignal": true; }; }, {}, never, ["*"], true, [{ directive: typeof i1.NgtObjectEvents; inputs: {}; outputs: { "click": "click"; "dblclick": "dblclick"; "contextmenu": "contextmenu"; "pointerup": "pointerup"; "pointerdown": "pointerdown"; "pointerover": "pointerover"; "pointerout": "pointerout"; "pointerenter": "pointerenter"; "pointerleave": "pointerleave"; "pointermove": "pointermove"; "pointermissed": "pointermissed"; "pointercancel": "pointercancel"; "wheel": "wheel"; }; }]>;
}
