import { NgtMesh } from 'angular-three';
import { ColorRepresentation } from 'three';
import * as i0 from "@angular/core";
export interface NgtsTextOptions extends Partial<NgtMesh> {
    characters?: string;
    color?: ColorRepresentation;
    /** Font size, default: 1 */
    fontSize: number;
    fontWeight?: number | string;
    fontStyle?: 'italic' | 'normal';
    maxWidth?: number;
    lineHeight?: number;
    letterSpacing?: number;
    textAlign?: 'left' | 'right' | 'center' | 'justify';
    font?: string;
    anchorX: number | 'left' | 'center' | 'right';
    anchorY: number | 'top' | 'top-baseline' | 'middle' | 'bottom-baseline' | 'bottom';
    clipRect?: [number, number, number, number];
    depthOffset?: number;
    direction?: 'auto' | 'ltr' | 'rtl';
    overflowWrap?: 'normal' | 'break-word';
    whiteSpace?: 'normal' | 'overflowWrap' | 'nowrap';
    outlineWidth?: number | string;
    outlineOffsetX?: number | string;
    outlineOffsetY?: number | string;
    outlineBlur?: number | string;
    outlineColor?: ColorRepresentation;
    outlineOpacity?: number;
    strokeWidth?: number | string;
    strokeColor?: ColorRepresentation;
    strokeOpacity?: number;
    fillOpacity?: number;
    sdfGlyphSize: number;
    debugSDF?: boolean;
}
export declare class NgtsText {
    text: import("@angular/core").InputSignal<string>;
    options: import("@angular/core").InputSignalWithTransform<NgtsTextOptions, "" | Partial<NgtsTextOptions>>;
    parameters: import("@angular/core").Signal<Omit<NgtsTextOptions, "font" | "fontSize" | "sdfGlyphSize" | "anchorX" | "anchorY" | "characters">>;
    synced: import("@angular/core").OutputEmitterRef<Text>;
    private store;
    private invalidate;
    private characters;
    font: import("@angular/core").Signal<string | undefined>;
    anchorX: import("@angular/core").Signal<number | "left" | "center" | "right">;
    anchorY: import("@angular/core").Signal<number | "top" | "top-baseline" | "middle" | "bottom-baseline" | "bottom">;
    sdfGlyphSize: import("@angular/core").Signal<number>;
    fontSize: import("@angular/core").Signal<number>;
    troikaMesh: any;
    constructor();
    static ɵfac: i0.ɵɵFactoryDeclaration<NgtsText, never>;
    static ɵcmp: i0.ɵɵComponentDeclaration<NgtsText, "ngts-text", never, { "text": { "alias": "text"; "required": true; "isSignal": true; }; "options": { "alias": "options"; "required": false; "isSignal": true; }; }, { "synced": "synced"; }, never, ["*"], true, never>;
}
