import { ElementRef, Injector, TemplateRef } from '@angular/core';
import { NgtGroup } from 'angular-three';
import { CubeCamera, Fog, FogExp2, Group, Texture, WebGLCubeRenderTarget } from 'three';
import * as i0 from "@angular/core";
export interface CubeCameraOptions {
    /** Resolution of the FBO, 256 */
    resolution?: number;
    /** Camera near, 0.1 */
    near?: number;
    /** Camera far, 1000 */
    far?: number;
    /** Custom environment map that is temporarily set as the scenes background */
    envMap?: Texture;
    /** Custom fog that is temporarily set as the scenes fog */
    fog?: Fog | FogExp2;
}
export declare function injectCubeCamera(options: () => CubeCameraOptions, { injector }?: {
    injector?: Injector;
}): {
    fbo: import("@angular/core").Signal<WebGLCubeRenderTarget>;
    camera: import("@angular/core").Signal<CubeCamera>;
    update: () => void;
};
export interface NgtsCubeCameraOptions extends Partial<NgtGroup>, CubeCameraOptions {
    frames: number;
}
export declare class NgtsCubeCamera {
    options: import("@angular/core").InputSignalWithTransform<NgtsCubeCameraOptions, "" | Partial<NgtsCubeCameraOptions>>;
    parameters: import("@angular/core").Signal<Omit<NgtsCubeCameraOptions, "near" | "far" | "envMap" | "frames" | "resolution" | "fog">>;
    private cubeCamera;
    camera: import("@angular/core").Signal<CubeCamera>;
    texture: import("@angular/core").Signal<import("three").CubeTexture>;
    groupRef: import("@angular/core").Signal<ElementRef<Group<import("three").Object3DEventMap>>>;
    cameraContent: import("@angular/core").Signal<TemplateRef<any> | undefined>;
    constructor();
    static ɵfac: i0.ɵɵFactoryDeclaration<NgtsCubeCamera, never>;
    static ɵcmp: i0.ɵɵComponentDeclaration<NgtsCubeCamera, "ngts-cube-camera", never, { "options": { "alias": "options"; "required": false; "isSignal": true; }; }, {}, ["cameraContent"], never, true, never>;
}
