import { ElementRef, TemplateRef } from '@angular/core';
import { NgtOrthographicCamera } from 'angular-three';
import { Group, OrthographicCamera, Texture } from 'three';
import * as i0 from "@angular/core";
export interface NgtsOrthographicCameraOptions extends Partial<NgtOrthographicCamera> {
    /** Registers the camera as the system default, fiber will start rendering with it */
    makeDefault?: boolean;
    /** Making it manual will stop responsiveness and you have to calculate aspect ratio yourself. */
    manual?: boolean;
    /** Number of frames to render, Infinity */
    frames: number;
    /** Resolution of the FBO, 256 */
    resolution: number;
    /** Optional environment map for functional use */
    envMap?: Texture;
}
export declare class NgtsOrthographicCamera {
    options: import("@angular/core").InputSignalWithTransform<NgtsOrthographicCameraOptions, "" | Partial<NgtsOrthographicCameraOptions>>;
    protected parameters: import("@angular/core").Signal<Omit<NgtsOrthographicCameraOptions, "envMap" | "makeDefault" | "manual" | "frames" | "resolution" | "left" | "right" | "top" | "bottom">>;
    content: import("@angular/core").Signal<TemplateRef<any> | undefined>;
    cameraContent: import("@angular/core").Signal<TemplateRef<any> | undefined>;
    cameraRef: import("@angular/core").Signal<ElementRef<OrthographicCamera>>;
    groupRef: import("@angular/core").Signal<ElementRef<Group<import("three").Object3DEventMap>>>;
    private store;
    private camera;
    protected size: import("@angular/core").Signal<import("angular-three").NgtSize>;
    protected left: import("@angular/core").Signal<number>;
    protected right: import("@angular/core").Signal<number>;
    protected top: import("@angular/core").Signal<number>;
    protected bottom: import("@angular/core").Signal<number>;
    private manual;
    private makeDefault;
    private resolution;
    private fbo;
    protected texture: import("@angular/core").Signal<Texture>;
    constructor();
    static ɵfac: i0.ɵɵFactoryDeclaration<NgtsOrthographicCamera, never>;
    static ɵcmp: i0.ɵɵComponentDeclaration<NgtsOrthographicCamera, "ngts-orthographic-camera", never, { "options": { "alias": "options"; "required": false; "isSignal": true; }; }, {}, ["content", "cameraContent"], never, true, never>;
}
