import { ElementRef, TemplateRef } from '@angular/core';
import { NgtPerspectiveCamera } from 'angular-three';
import { Group, PerspectiveCamera, Texture } from 'three';
import * as i0 from "@angular/core";
export interface NgtsPerspectiveCameraOptions extends Partial<NgtPerspectiveCamera> {
    /** Registers the camera as the system default, fiber will start rendering with it */
    makeDefault?: boolean;
    /** Making it manual will stop responsiveness and you have to calculate aspect ratio yourself. */
    manual?: boolean;
    /** Number of frames to render, Infinity */
    frames: number;
    /** Resolution of the FBO, 256 */
    resolution: number;
    /** Optional environment map for functional use */
    envMap?: Texture;
}
export declare class NgtsPerspectiveCamera {
    options: import("@angular/core").InputSignalWithTransform<NgtsPerspectiveCameraOptions, "" | Partial<NgtsPerspectiveCameraOptions>>;
    protected parameters: import("@angular/core").Signal<Omit<NgtsPerspectiveCameraOptions, "envMap" | "makeDefault" | "manual" | "frames" | "resolution">>;
    content: import("@angular/core").Signal<TemplateRef<any> | undefined>;
    cameraContent: import("@angular/core").Signal<TemplateRef<any> | undefined>;
    cameraRef: import("@angular/core").Signal<ElementRef<PerspectiveCamera>>;
    groupRef: import("@angular/core").Signal<ElementRef<Group<import("three").Object3DEventMap>>>;
    private store;
    private camera;
    private size;
    private manual;
    private makeDefault;
    private resolution;
    private fbo;
    protected texture: import("@angular/core").Signal<Texture>;
    constructor();
    static ɵfac: i0.ɵɵFactoryDeclaration<NgtsPerspectiveCamera, never>;
    static ɵcmp: i0.ɵɵComponentDeclaration<NgtsPerspectiveCamera, "ngts-perspective-camera", never, { "options": { "alias": "options"; "required": false; "isSignal": true; }; }, {}, ["content", "cameraContent"], never, true, never>;
}
