import { NgtHTML } from 'angular-three';
import * as i0 from "@angular/core";
export interface NgtsScrollControlsOptions {
    /** Precision, default 0.00001 */
    eps: number;
    /** Horizontal scroll, default false (vertical) */
    horizontal: boolean;
    /** Infinite scroll, default false (experimental!) */
    infinite: boolean;
    /** Defines the lenght of the scroll area, each page is height:100%, default 1 */
    pages: number;
    /** A factor that increases scroll bar travel,default: 1 */
    distance: number;
    /** Friction in seconds, default: 0.25 (1/4 second) */
    damping: number;
    /** maxSpeed optionally allows you to clamp the maximum speed. If damping is 0.2s and looks OK
     *  going between, say, page 1 and 2, but not for pages far apart as it'll move very rapid,
     *  then a maxSpeed of e.g. 3 which will clamp the speed to 3 units per second, it may now
     *  take much longer than damping to reach the target if it is far away. Default: Infinity */
    maxSpeed: number;
    /** If true attaches the scroll container before the canvas */
    prepend: boolean;
    enabled: boolean;
    style: Partial<CSSStyleDeclaration>;
}
export declare class NgtsScrollControls {
    progress: import("@angular/core").ModelSignal<number>;
    options: import("@angular/core").InputSignalWithTransform<NgtsScrollControlsOptions, "" | Partial<NgtsScrollControlsOptions>>;
    private document;
    private store;
    private gl;
    private events;
    private invalidate;
    private size;
    private domElement;
    private target;
    private _el;
    private _fill;
    private _fixed;
    private style;
    private prepend;
    private enabled;
    private infinite;
    private maxSpeed;
    eps: import("@angular/core").Signal<number>;
    horizontal: import("@angular/core").Signal<boolean>;
    pages: import("@angular/core").Signal<number>;
    distance: import("@angular/core").Signal<number>;
    damping: import("@angular/core").Signal<number>;
    scroll: number;
    offset: number;
    delta: number;
    constructor();
    get el(): HTMLDivElement;
    get fill(): HTMLDivElement;
    get fixed(): HTMLDivElement;
    range(from: number, distance: number, margin?: number): number;
    curve(from: number, distance: number, margin?: number): number;
    visible(from: number, distance: number, margin?: number): boolean;
    static ɵfac: i0.ɵɵFactoryDeclaration<NgtsScrollControls, never>;
    static ɵcmp: i0.ɵɵComponentDeclaration<NgtsScrollControls, "ngts-scroll-controls", never, { "progress": { "alias": "progress"; "required": false; "isSignal": true; }; "options": { "alias": "options"; "required": false; "isSignal": true; }; }, { "progress": "progressChange"; }, never, ["*"], true, never>;
}
export declare class NgtsScrollCanvas {
    private host;
    private scrollControls;
    private store;
    private viewport;
    constructor();
    static ɵfac: i0.ɵɵFactoryDeclaration<NgtsScrollCanvas, never>;
    static ɵdir: i0.ɵɵDirectiveDeclaration<NgtsScrollCanvas, "ngt-group[ngtsScrollCanvas]", never, {}, {}, never, never, true, never>;
}
export declare class NgtsScrollHtml extends NgtHTML {
    private scrollControls;
    private size;
    constructor();
    static ɵfac: i0.ɵɵFactoryDeclaration<NgtsScrollHtml, never>;
    static ɵdir: i0.ɵɵDirectiveDeclaration<NgtsScrollHtml, "div[ngtsScrollHTML]", never, {}, {}, never, never, true, never>;
}
