import { NgtThreeEvent } from 'angular-three';
import { CanvasTexture, Vector3 } from 'three';
import * as i0 from "@angular/core";
type XYZ = [number, number, number];
export interface NgtsViewcubeCommonOptions {
    font: string;
    opacity: number;
    color: string;
    hoverColor: string;
    textColor: string;
    strokeColor: string;
    faces: string[];
}
export declare class FaceMaterial {
    hover: import("@angular/core").InputSignal<boolean>;
    index: import("@angular/core").InputSignal<number>;
    options: import("@angular/core").InputSignalWithTransform<NgtsViewcubeCommonOptions, "" | Partial<NgtsViewcubeCommonOptions>>;
    private faces;
    private font;
    private color;
    private textColor;
    private strokeColor;
    private hoverColor;
    private document;
    private store;
    private gl;
    protected opacity: import("@angular/core").Signal<number>;
    protected materialColor: import("@angular/core").Signal<string>;
    protected texture: import("@angular/core").Signal<CanvasTexture>;
    constructor();
    static ɵfac: i0.ɵɵFactoryDeclaration<FaceMaterial, never>;
    static ɵcmp: i0.ɵɵComponentDeclaration<FaceMaterial, "viewcube-face-material", never, { "hover": { "alias": "hover"; "required": true; "isSignal": true; }; "index": { "alias": "index"; "required": true; "isSignal": true; }; "options": { "alias": "options"; "required": false; "isSignal": true; }; }, {}, never, never, true, never>;
}
export declare class FaceCube {
    options: import("@angular/core").InputSignal<Partial<NgtsViewcubeCommonOptions>>;
    onClick: import("@angular/core").InputSignal<((event: NgtThreeEvent<MouseEvent>) => void) | undefined>;
    private gizmoHelper;
    protected hover: import("@angular/core").WritableSignal<number>;
    protected count: unknown[];
    constructor();
    internalOnClick(event: NgtThreeEvent<MouseEvent>): void;
    protected readonly Math: Math;
    static ɵfac: i0.ɵɵFactoryDeclaration<FaceCube, never>;
    static ɵcmp: i0.ɵɵComponentDeclaration<FaceCube, "viewcube-face-cube", never, { "options": { "alias": "options"; "required": false; "isSignal": true; }; "onClick": { "alias": "onClick"; "required": false; "isSignal": true; }; }, {}, never, never, true, never>;
}
export declare class EdgeCube {
    dimensions: import("@angular/core").InputSignal<XYZ>;
    position: import("@angular/core").InputSignal<Vector3>;
    hoverColor: import("@angular/core").InputSignalWithTransform<string, string | undefined>;
    onClick: import("@angular/core").InputSignal<((event: NgtThreeEvent<MouseEvent>) => void) | undefined>;
    private gizmoHelper;
    protected hover: import("@angular/core").WritableSignal<boolean>;
    protected color: import("@angular/core").Signal<string>;
    constructor();
    internalOnClick(event: NgtThreeEvent<MouseEvent>): void;
    static ɵfac: i0.ɵɵFactoryDeclaration<EdgeCube, never>;
    static ɵcmp: i0.ɵɵComponentDeclaration<EdgeCube, "viewcube-edge-cube", never, { "dimensions": { "alias": "dimensions"; "required": true; "isSignal": true; }; "position": { "alias": "position"; "required": true; "isSignal": true; }; "hoverColor": { "alias": "hoverColor"; "required": false; "isSignal": true; }; "onClick": { "alias": "onClick"; "required": false; "isSignal": true; }; }, {}, never, never, true, never>;
}
export type NgtsGizmoViewcubeOptions = Partial<NgtsViewcubeCommonOptions>;
export declare class NgtsGizmoViewcube {
    options: import("@angular/core").InputSignal<Partial<Partial<NgtsViewcubeCommonOptions>>>;
    click: import("@angular/core").OutputEmitterRef<NgtThreeEvent<MouseEvent>>;
    protected hoverColor: import("@angular/core").Signal<string | undefined>;
    protected corners: Vector3[];
    protected cornerDimensions: XYZ;
    protected edges: Vector3[];
    protected edgeDimensions: XYZ[];
    constructor();
    protected get onClick(): ((value: NgtThreeEvent<MouseEvent>) => void) | undefined;
    private makePositionVector;
    static ɵfac: i0.ɵɵFactoryDeclaration<NgtsGizmoViewcube, never>;
    static ɵcmp: i0.ɵɵComponentDeclaration<NgtsGizmoViewcube, "ngts-gizmo-viewcube", never, { "options": { "alias": "options"; "required": false; "isSignal": true; }; }, { "click": "click"; }, never, never, true, never>;
}
export {};
