import { NgtGroup, NgtThreeEvent, NgtVector3 } from 'angular-three';
import { CanvasTexture, ColorRepresentation } from 'three';
import * as i0 from "@angular/core";
export declare class Axis {
    scale: import("@angular/core").InputSignalWithTransform<number[], [number, number, number] | undefined>;
    color: import("@angular/core").InputSignal<ColorRepresentation | undefined>;
    rotation: import("@angular/core").InputSignal<NgtVector3>;
    constructor();
    static ɵfac: i0.ɵɵFactoryDeclaration<Axis, never>;
    static ɵcmp: i0.ɵɵComponentDeclaration<Axis, "viewport-axis", never, { "scale": { "alias": "scale"; "required": false; "isSignal": true; }; "color": { "alias": "color"; "required": false; "isSignal": true; }; "rotation": { "alias": "rotation"; "required": false; "isSignal": true; }; }, {}, never, never, true, never>;
}
export declare class AxisHead {
    arcStyle: import("@angular/core").InputSignal<string>;
    position: import("@angular/core").InputSignal<NgtVector3>;
    label: import("@angular/core").InputSignal<string | undefined>;
    labelColor: import("@angular/core").InputSignal<string>;
    axisHeadScale: import("@angular/core").InputSignal<number>;
    disabled: import("@angular/core").InputSignal<boolean>;
    font: import("@angular/core").InputSignal<string>;
    onClick: import("@angular/core").InputSignal<((event: NgtThreeEvent<MouseEvent>) => void) | undefined>;
    private document;
    private gizmoHelper;
    private store;
    private gl;
    protected texture: import("@angular/core").Signal<CanvasTexture>;
    protected active: import("@angular/core").WritableSignal<boolean>;
    protected scale: import("@angular/core").Signal<number>;
    constructor();
    onPointerOver(event: NgtThreeEvent<PointerEvent>): void;
    onPointerOut(event: NgtThreeEvent<PointerEvent>): void;
    onPointerDown(event: NgtThreeEvent<PointerEvent>): void;
    static ɵfac: i0.ɵɵFactoryDeclaration<AxisHead, never>;
    static ɵcmp: i0.ɵɵComponentDeclaration<AxisHead, "viewport-axis-head", never, { "arcStyle": { "alias": "arcStyle"; "required": true; "isSignal": true; }; "position": { "alias": "position"; "required": true; "isSignal": true; }; "label": { "alias": "label"; "required": false; "isSignal": true; }; "labelColor": { "alias": "labelColor"; "required": false; "isSignal": true; }; "axisHeadScale": { "alias": "axisHeadScale"; "required": false; "isSignal": true; }; "disabled": { "alias": "disabled"; "required": false; "isSignal": true; }; "font": { "alias": "font"; "required": false; "isSignal": true; }; "onClick": { "alias": "onClick"; "required": false; "isSignal": true; }; }, {}, never, never, true, never>;
}
export interface NgtsGizmoViewportOptions extends Partial<NgtGroup> {
    axisColors: [string, string, string];
    axisScale?: [number, number, number];
    labels: [string, string, string];
    axisHeadScale: number;
    labelColor: string;
    hideNegativeAxes: boolean;
    hideAxisHeads: boolean;
    disabled: boolean;
    font: string;
}
export declare class NgtsGizmoViewport {
    protected readonly Math: Math;
    options: import("@angular/core").InputSignalWithTransform<NgtsGizmoViewportOptions, "" | Partial<NgtsGizmoViewportOptions>>;
    parameters: import("@angular/core").Signal<Omit<NgtsGizmoViewportOptions, "axisColors" | "axisScale" | "labels" | "axisHeadScale" | "labelColor" | "hideNegativeAxes" | "hideAxisHeads" | "disabled" | "font">>;
    click: import("@angular/core").OutputEmitterRef<NgtThreeEvent<MouseEvent>>;
    protected axisColors: import("@angular/core").Signal<[string, string, string]>;
    protected axisScale: import("@angular/core").Signal<[number, number, number] | undefined>;
    protected hideAxisHeads: import("@angular/core").Signal<boolean>;
    protected hideNegativeAxes: import("@angular/core").Signal<boolean>;
    protected labels: import("@angular/core").Signal<[string, string, string]>;
    protected axisHeadScale: import("@angular/core").Signal<number>;
    protected labelColor: import("@angular/core").Signal<string>;
    protected disabled: import("@angular/core").Signal<boolean>;
    protected font: import("@angular/core").Signal<string>;
    constructor();
    protected get onClick(): ((value: NgtThreeEvent<MouseEvent>) => void) | undefined;
    static ɵfac: i0.ɵɵFactoryDeclaration<NgtsGizmoViewport, never>;
    static ɵcmp: i0.ɵɵComponentDeclaration<NgtsGizmoViewport, "ngts-gizmo-viewport", never, { "options": { "alias": "options"; "required": false; "isSignal": true; }; }, { "click": "click"; }, never, never, true, never>;
}
