import { ElementRef, Signal } from '@angular/core';
import { NgtThreeEvent } from 'angular-three';
import { Group, Matrix4, Vector3 } from 'three';
import { NgtsPivotControls } from './pivot-controls';
import * as i0 from "@angular/core";
export declare function calculateOffset(clickPoint: Vector3, normal: Vector3, rayStart: Vector3, rayDir: Vector3): number;
export declare class NgtsAxisArrow {
    protected readonly DoubleSide: 2;
    direction: import("@angular/core").InputSignal<Vector3>;
    axis: import("@angular/core").InputSignal<0 | 1 | 2>;
    groupRef: Signal<ElementRef<Group<import("three").Object3DEventMap>>>;
    annotationRef: Signal<ElementRef<HTMLDivElement> | undefined>;
    pivotControls: NgtsPivotControls;
    private store;
    private controls;
    private hovered;
    private clickInfo;
    private offset0;
    color: Signal<string | number>;
    coneWidth: Signal<number>;
    coneLength: Signal<number>;
    cylinderLength: Signal<number>;
    matrixL: Signal<Matrix4>;
    constructor();
    onPointerDown(event: NgtThreeEvent<PointerEvent>): void;
    onPointerUp(event: NgtThreeEvent<PointerEvent>): void;
    onPointerMove(event: NgtThreeEvent<PointerEvent>): void;
    onPointerOut(event: NgtThreeEvent<PointerEvent>): void;
    static ɵfac: i0.ɵɵFactoryDeclaration<NgtsAxisArrow, never>;
    static ɵcmp: i0.ɵɵComponentDeclaration<NgtsAxisArrow, "ngts-axis-arrow", never, { "direction": { "alias": "direction"; "required": true; "isSignal": true; }; "axis": { "alias": "axis"; "required": true; "isSignal": true; }; }, {}, never, never, true, never>;
}
