import { ElementRef, Signal } from '@angular/core';
import { NgtThreeEvent } from 'angular-three';
import { Group, Matrix4, Mesh, Vector3 } from 'three';
import { NgtsPivotControls } from './pivot-controls';
import * as i0 from "@angular/core";
export declare function calculateOffset(clickPoint: Vector3, normal: Vector3, rayStart: Vector3, rayDir: Vector3): number;
export declare class NgtsScalingSphere {
    direction: import("@angular/core").InputSignal<Vector3>;
    axis: import("@angular/core").InputSignal<0 | 1 | 2>;
    groupRef: Signal<ElementRef<Group<import("three").Object3DEventMap>>>;
    annotationRef: Signal<ElementRef<HTMLDivElement> | undefined>;
    meshRef: Signal<ElementRef<Mesh<import("three").BufferGeometry<import("three").NormalBufferAttributes>, import("three").Material | import("three").Material[], import("three").Object3DEventMap>>>;
    pivotControls: NgtsPivotControls;
    private store;
    private controls;
    private size;
    private hovered;
    private scale0;
    private scaleCurrent;
    private clickInfo;
    position: Signal<number>;
    radius: Signal<number>;
    matrixL: Signal<Matrix4>;
    color: Signal<string | number>;
    constructor();
    onPointerDown(event: NgtThreeEvent<PointerEvent>): void;
    onPointerMove(event: NgtThreeEvent<PointerEvent>): void;
    onPointerUp(event: NgtThreeEvent<PointerEvent>): void;
    onPointerOut(event: NgtThreeEvent<PointerEvent>): void;
    static ɵfac: i0.ɵɵFactoryDeclaration<NgtsScalingSphere, never>;
    static ɵcmp: i0.ɵɵComponentDeclaration<NgtsScalingSphere, "ngts-scaling-sphere", never, { "direction": { "alias": "direction"; "required": true; "isSignal": true; }; "axis": { "alias": "axis"; "required": true; "isSignal": true; }; }, {}, never, never, true, never>;
}
