import { ElementRef, Signal } from '@angular/core';
import { NgtGroup, NgtObject3DNode } from 'angular-three';
import { Camera, Object3D, Event as ThreeEvent } from 'three';
import { TransformControls } from 'three-stdlib';
import * as i0 from "@angular/core";
export type NgtsTransformControlsObject = NgtObject3DNode<TransformControls, typeof TransformControls>;
export type NgtsTransformControlsOptions = Partial<NgtsTransformControlsObject> & Partial<NgtGroup> & {
    enabled?: boolean;
    axis?: string | null;
    domElement?: HTMLElement;
    mode?: 'translate' | 'rotate' | 'scale';
    translationSnap?: number | null;
    rotationSnap?: number | null;
    scaleSnap?: number | null;
    space?: 'world' | 'local';
    size?: number;
    showX?: boolean;
    showY?: boolean;
    showZ?: boolean;
    camera?: Camera;
    makeDefault?: boolean;
};
export declare class NgtsTransformControls {
    object: import("@angular/core").InputSignal<Object3D<import("three").Object3DEventMap> | ElementRef<Object3D<import("three").Object3DEventMap>> | null | undefined>;
    options: import("@angular/core").InputSignal<Partial<NgtsTransformControlsOptions>>;
    parameters: Signal<Omit<Partial<NgtsTransformControlsOptions>, "enabled" | "axis" | "domElement" | "mode" | "translationSnap" | "rotationSnap" | "scaleSnap" | "space" | "size" | "showX" | "showY" | "showZ" | "camera" | "makeDefault">>;
    protected controlsOptions: Signal<Pick<Partial<NgtsTransformControlsOptions>, "enabled" | "axis" | "mode" | "translationSnap" | "rotationSnap" | "scaleSnap" | "space" | "size" | "showX" | "showY" | "showZ">>;
    private camera;
    private domElement;
    private makeDefault;
    change: import("@angular/core").OutputEmitterRef<ThreeEvent<string, unknown>>;
    mouseDown: import("@angular/core").OutputEmitterRef<ThreeEvent<string, unknown>>;
    mouseUp: import("@angular/core").OutputEmitterRef<ThreeEvent<string, unknown>>;
    objectChange: import("@angular/core").OutputEmitterRef<ThreeEvent<string, unknown>>;
    private groupRef;
    private store;
    private glDomElement;
    private defaultCamera;
    private events;
    private defaultControls;
    private invalidate;
    controls: Signal<TransformControls<Camera>>;
    constructor();
    private attachControlsEffect;
    private disableDefaultControlsEffect;
    private setupControlsEventsEffect;
    private updateDefaultControlsEffect;
    static ɵfac: i0.ɵɵFactoryDeclaration<NgtsTransformControls, never>;
    static ɵcmp: i0.ɵɵComponentDeclaration<NgtsTransformControls, "ngts-transform-controls", never, { "object": { "alias": "object"; "required": false; "isSignal": true; }; "options": { "alias": "options"; "required": false; "isSignal": true; }; }, { "change": "change"; "mouseDown": "mouseDown"; "mouseUp": "mouseUp"; "objectChange": "objectChange"; }, never, ["*"], true, never>;
}
