import { Injector, Signal } from '@angular/core';
import { NgtLoaderResults, NgtObjectMap } from 'angular-three';
import { GLTF, GLTFLoader } from 'three-stdlib';
type InjectGLTFUrl<TGltf extends GLTF | GLTF[] | Record<string, GLTF>> = TGltf extends GLTF ? string : TGltf extends GLTF[] ? string[] : TGltf extends Record<string, GLTF> ? Record<string, string> : never;
type InjectGLTFObjectMap<TGltf extends GLTF | GLTF[] | Record<string, GLTF>> = TGltf extends GLTF ? TGltf & NgtObjectMap : TGltf extends Array<infer _GLTF extends GLTF> ? Array<_GLTF & NgtObjectMap> : TGltf extends Record<string, infer _GLTF extends GLTF> ? Record<string, _GLTF & NgtObjectMap> : never;
declare function _injectGLTF<TGltf extends GLTF | GLTF[] | Record<string, GLTF> = GLTF, TUrl extends string | string[] | Record<string, string> = InjectGLTFUrl<TGltf>>(path: () => TUrl, { useDraco, useMeshOpt, injector, extensions, onLoad, }?: {
    useDraco?: boolean | string;
    useMeshOpt?: boolean;
    injector?: Injector;
    extensions?: (loader: GLTFLoader) => void;
    onLoad?: (data: InjectGLTFObjectMap<TGltf>) => void;
}): Signal<InjectGLTFObjectMap<TGltf> | null> & {
    scene: Signal<GLTF['scene'] | null>;
};
declare namespace _injectGLTF {
    var preload: <TUrl extends string | string[] | Record<string, string>>(path: () => TUrl, { useDraco, useMeshOpt, extensions, onLoad, }?: {
        useDraco?: boolean | string;
        useMeshOpt?: boolean;
        extensions?: (loader: GLTFLoader) => void;
        onLoad?: (data: NgtLoaderResults<TUrl, GLTF & NgtObjectMap>) => void;
    }) => void;
    var setDecoderPath: (path: string) => void;
}
export type NgtsGLTFLoader = typeof _injectGLTF;
export declare const injectGLTF: NgtsGLTFLoader;
export {};
