import { ElementRef, TemplateRef } from '@angular/core';
import { NgtAttachable, NgtShaderMaterial } from 'angular-three';
import { Scene, ShaderMaterial } from 'three';
import * as i0 from "@angular/core";
/**
 * This directive is used inside of the render texture, hence has access to the render texture store (a portal store)
 */
export declare class ManagePortalScene {
    events: import("@angular/core").InputSignal<boolean | undefined>;
    rootScene: import("@angular/core").InputSignal<Scene>;
    material: import("@angular/core").InputSignal<import("angular-three").NgtExtendedColors<import("angular-three").NgtOverwrite<Partial<{
        defines: {
            [key: string]: any;
        };
        map?: (import("three").Texture | null) | undefined;
        wireframe: boolean;
        wireframeLinewidth: number;
        fog: boolean;
        setValues: (parameters: import("three").ShaderMaterialParameters) => void;
        readonly isMaterial: true;
        type: string;
        alphaHash: boolean;
        alphaToCoverage: boolean;
        blendAlpha: number;
        blendColor: import("three").Color;
        blendDst: import("three").BlendingDstFactor;
        blendDstAlpha: number | null;
        blendEquation: import("three").BlendingEquation;
        blendEquationAlpha: number | null;
        blending: import("three").Blending;
        blendSrc: import("three").BlendingSrcFactor | import("three").BlendingDstFactor;
        blendSrcAlpha: number | null;
        clipIntersection: boolean;
        clippingPlanes: import("three").Plane[] | null;
        clipShadows: boolean;
        colorWrite: boolean;
        depthFunc: import("three").DepthModes;
        depthTest: boolean;
        depthWrite: boolean;
        id: number;
        stencilWrite: boolean;
        stencilFunc: import("three").StencilFunc;
        stencilRef: number;
        stencilWriteMask: number;
        stencilFuncMask: number;
        stencilFail: import("three").StencilOp;
        stencilZFail: import("three").StencilOp;
        stencilZPass: import("three").StencilOp;
        name: string;
        opacity: number;
        polygonOffset: boolean;
        polygonOffsetFactor: number;
        polygonOffsetUnits: number;
        precision: "highp" | "mediump" | "lowp" | null;
        premultipliedAlpha: boolean;
        forceSinglePass: boolean;
        dithering: boolean;
        side: import("three").Side;
        shadowSide: import("three").Side | null;
        toneMapped: boolean;
        transparent: boolean;
        uuid: string;
        vertexColors: boolean;
        visible: boolean;
        userData: Record<string, any>;
        version: number;
        alphaTest: number;
        onBeforeRender: (renderer: import("three").WebGLRenderer, scene: Scene, camera: import("three").Camera, geometry: import("three").BufferGeometry, object: import("three").Object3D, group: import("three").Group) => void;
        onBeforeCompile: (parameters: import("three").WebGLProgramParametersWithUniforms, renderer: import("three").WebGLRenderer) => void;
        customProgramCacheKey: () => string;
        toJSON: (meta?: import("three").JSONMeta) => import("three").ShaderMaterialJSON;
        clone: () => ShaderMaterial & import("@pmndrs/vanilla").PortalMaterialType;
        copy: (material: import("three").Material) => ShaderMaterial & import("@pmndrs/vanilla").PortalMaterialType;
        dispose: () => void;
        needsUpdate: boolean;
        onBuild: (object: import("three").Object3D, parameters: import("three").WebGLProgramParametersWithUniforms, renderer: import("three").WebGLRenderer) => void;
        hasEventListener: <T extends "dispose">(type: T, listener: import("three").EventListener<{
            dispose: {};
        }[T], T, ShaderMaterial & import("@pmndrs/vanilla").PortalMaterialType>) => boolean;
        dispatchEvent: <T extends "dispose">(event: import("three").BaseEvent<T> & {
            dispose: {};
        }[T]) => void;
        resolution: import("three").Vector2;
        readonly isShaderMaterial: true;
        uniforms: {
            [uniform: string]: import("three").IUniform;
        };
        uniformsGroups: import("three").UniformsGroup[];
        vertexShader: string;
        fragmentShader: string;
        linewidth: number;
        lights: boolean;
        clipping: boolean;
        extensions: {
            clipCullDistance: boolean;
            multiDraw: boolean;
        };
        defaultAttributeValues: any;
        index0AttributeName: string | undefined;
        uniformsNeedUpdate: boolean;
        glslVersion: import("three").GLSLVersion | null;
        size?: number | undefined;
        blur: number;
        sdf?: (import("three").Texture | null) | undefined;
    }>, import("angular-three").NgtNodeElement<ShaderMaterial & import("@pmndrs/vanilla").PortalMaterialType, (new (parameters?: (import("three").ShaderMaterialParameters & Partial<import("@pmndrs/vanilla").PortalMaterialType>) | undefined) => ShaderMaterial & import("@pmndrs/vanilla").PortalMaterialType) & {
        key: string;
    }>>>>;
    priority: import("@angular/core").InputSignal<number>;
    worldUnits: import("@angular/core").InputSignal<boolean>;
    constructor();
    static ɵfac: i0.ɵɵFactoryDeclaration<ManagePortalScene, never>;
    static ɵdir: i0.ɵɵDirectiveDeclaration<ManagePortalScene, "ngts-manage-portal-scene", never, { "events": { "alias": "events"; "required": false; "isSignal": true; }; "rootScene": { "alias": "rootScene"; "required": true; "isSignal": true; }; "material": { "alias": "material"; "required": true; "isSignal": true; }; "priority": { "alias": "priority"; "required": true; "isSignal": true; }; "worldUnits": { "alias": "worldUnits"; "required": true; "isSignal": true; }; }, {}, never, never, true, never>;
}
export interface NgtsMeshPortalMaterialOptions extends Partial<NgtShaderMaterial> {
    /** Mix the portals own scene with the world scene, 0 = world scene render,
     *  0.5 = both scenes render, 1 = portal scene renders, defaults to 0.   */
    blend: number;
    /** Edge fade blur, 0 = no blur (default) */
    blur: number;
    /** SDF resolution, the smaller the faster is the start-up time (default: 512) */
    resolution: number;
    /** By default portals use relative coordinates, contents are affects by the local matrix transform */
    worldUnits: boolean;
    /** Optional event priority, defaults to 0 */
    eventPriority: number;
    /** Optional render priority, defaults to 0 */
    renderPriority: number;
    /** Optionally diable events inside the portal, defaults to false */
    events: boolean;
}
export declare class NgtsMeshPortalMaterial {
    attach: import("@angular/core").InputSignal<NgtAttachable>;
    options: import("@angular/core").InputSignalWithTransform<NgtsMeshPortalMaterialOptions, "" | Partial<NgtsMeshPortalMaterialOptions>>;
    parameters: import("@angular/core").Signal<Omit<NgtsMeshPortalMaterialOptions, "resolution" | "events" | "blur" | "worldUnits" | "eventPriority" | "renderPriority">>;
    blur: import("@angular/core").Signal<number>;
    eventPriority: import("@angular/core").Signal<number>;
    renderPriority: import("@angular/core").Signal<number>;
    events: import("@angular/core").Signal<boolean>;
    worldUnits: import("@angular/core").Signal<boolean>;
    materialRef: import("@angular/core").Signal<ElementRef<ShaderMaterial & import("@pmndrs/vanilla").PortalMaterialType>>;
    content: import("@angular/core").Signal<TemplateRef<any>>;
    private store;
    private size;
    private viewport;
    private gl;
    private setEvents;
    rootScene: import("@angular/core").Signal<Scene>;
    materialResolution: import("@angular/core").Signal<number[]>;
    private resolution;
    private parent;
    private visible;
    renderTextureFrames: import("@angular/core").Signal<number>;
    renderTextureCompute: import("@angular/core").Signal<(event: import("angular-three").NgtDomEvent, root: import("angular-three").NgtSignalStore<import("angular-three").NgtState>, previous: import("angular-three").NgtSignalStore<import("angular-three").NgtState> | null) => false | undefined>;
    priority: import("@angular/core").WritableSignal<number>;
    constructor();
    static ɵfac: i0.ɵɵFactoryDeclaration<NgtsMeshPortalMaterial, never>;
    static ɵcmp: i0.ɵɵComponentDeclaration<NgtsMeshPortalMaterial, "ngts-mesh-portal-material", never, { "attach": { "alias": "attach"; "required": false; "isSignal": true; }; "options": { "alias": "options"; "required": false; "isSignal": true; }; }, {}, ["content"], never, true, never>;
}
