import { ElementRef } from '@angular/core';
import { NgtAttachable, NgtMeshStandardMaterial } from 'angular-three';
import { MeshReflectorMaterial } from 'angular-three-soba/vanilla-exports';
import { Texture } from 'three';
import * as i0 from "@angular/core";
export interface NgtsMeshReflectorMaterialOptions extends Partial<NgtMeshStandardMaterial> {
    resolution: number;
    mixBlur: number;
    mixStrength: number;
    blur: [number, number] | number;
    mirror: number;
    minDepthThreshold: number;
    maxDepthThreshold: number;
    depthScale: number;
    depthToBlurRatioBias: number;
    distortion: number;
    mixContrast: number;
    reflectorOffset: number;
    distortionMap?: Texture;
}
export declare class NgtsMeshReflectorMaterial {
    attach: import("@angular/core").InputSignal<NgtAttachable>;
    options: import("@angular/core").InputSignalWithTransform<NgtsMeshReflectorMaterialOptions, "" | Partial<NgtsMeshReflectorMaterialOptions>>;
    private parameters;
    private store;
    private gl;
    materialRef: import("@angular/core").Signal<ElementRef<MeshReflectorMaterial> | undefined>;
    private reflectOptions;
    private blur;
    private normalizedBlur;
    private hasBlur;
    private reflectorPlane;
    private normal;
    private reflectorWorldPosition;
    private cameraWorldPosition;
    private rotationMatrix;
    private lookAtPosition;
    private clipPlane;
    private view;
    private target;
    private q;
    private textureMatrix;
    private virtualCamera;
    private reflectState;
    private definesKey;
    material: import("@angular/core").Signal<MeshReflectorMaterial>;
    constructor();
    private beforeRender;
    static ɵfac: i0.ɵɵFactoryDeclaration<NgtsMeshReflectorMaterial, never>;
    static ɵcmp: i0.ɵɵComponentDeclaration<NgtsMeshReflectorMaterial, "ngts-mesh-reflector-material", never, { "attach": { "alias": "attach"; "required": false; "isSignal": true; }; "options": { "alias": "options"; "required": false; "isSignal": true; }; }, {}, never, ["*"], true, never>;
}
