import { ElementRef } from '@angular/core';
import { NgtAttachable, NgtShaderMaterial } from 'angular-three';
import { ColorRepresentation, CubeTexture, Texture } from 'three';
import * as i0 from "@angular/core";
export interface NgtsMeshRefractionMaterialOptions extends Partial<NgtShaderMaterial> {
    /** Number of ray-cast bounces, it can be expensive to have too many, 2 */
    bounces: number;
    /** Refraction index, 2.4 */
    ior: number;
    /** Fresnel (strip light), 0 */
    fresnel: number;
    /** RGB shift intensity, can be expensive, 0 */
    aberrationStrength: number;
    /** Color, white */
    color: ColorRepresentation;
    /** If this is on it uses fewer ray casts for the RGB shift sacrificing physical accuracy, true */
    fastChroma: boolean;
}
export declare class NgtsMeshRefractionMaterial {
    envMap: import("@angular/core").InputSignal<Texture | CubeTexture>;
    attach: import("@angular/core").InputSignal<NgtAttachable>;
    options: import("@angular/core").InputSignalWithTransform<NgtsMeshRefractionMaterialOptions, "" | Partial<NgtsMeshRefractionMaterialOptions>>;
    parameters: import("@angular/core").Signal<Omit<NgtsMeshRefractionMaterialOptions, "fastChroma" | "aberrationStrength">>;
    private fastChroma;
    aberrationStrength: import("@angular/core").Signal<number>;
    materialRef: import("@angular/core").Signal<ElementRef<import("three").ShaderMaterial & {
        [name: string]: number | boolean | any[] | import("three").Color | Texture | CubeTexture | Int32Array<ArrayBufferLike> | Float32Array<ArrayBufferLike> | import("three").Matrix4 | import("three").Matrix3 | import("three").Quaternion | import("three").Vector4 | import("three").Vector3 | import("three").Vector2 | null;
    }> | undefined>;
    private store;
    private size;
    resolution: import("@angular/core").Signal<number[]>;
    defines: import("@angular/core").Signal<{
        [key: string]: string;
    }>;
    private defineKeys;
    material: import("@angular/core").Signal<import("three").ShaderMaterial & {
        [name: string]: number | boolean | any[] | import("three").Color | Texture | CubeTexture | Int32Array<ArrayBufferLike> | Float32Array<ArrayBufferLike> | import("three").Matrix4 | import("three").Matrix3 | import("three").Quaternion | import("three").Vector4 | import("three").Vector3 | import("three").Vector2 | null;
    }>;
    constructor();
    static ɵfac: i0.ɵɵFactoryDeclaration<NgtsMeshRefractionMaterial, never>;
    static ɵcmp: i0.ɵɵComponentDeclaration<NgtsMeshRefractionMaterial, "ngts-mesh-refraction-material", never, { "envMap": { "alias": "envMap"; "required": true; "isSignal": true; }; "attach": { "alias": "attach"; "required": false; "isSignal": true; }; "options": { "alias": "options"; "required": false; "isSignal": true; }; }, {}, never, ["*"], true, never>;
}
