import { ElementRef } from '@angular/core';
import { NgtAttachable, NgtMeshPhysicalMaterial } from 'angular-three';
import { MeshTransmissionMaterial } from 'angular-three-soba/vanilla-exports';
import { Color, Texture } from 'three';
import * as i0 from "@angular/core";
export type MeshTransmissionMaterialOptions = ConstructorParameters<typeof MeshTransmissionMaterial>[0];
export type NgtsMeshTransmissionMaterialOptions = Partial<NgtMeshPhysicalMaterial> & Omit<MeshTransmissionMaterialOptions, 'buffer' | 'anisotropicBlur' | 'samples' | 'transmissionSampler'> & {
    anisotropicBlur?: number;
    buffer?: Texture;
    /** transmissionSampler, you can use the threejs transmission sampler texture that is
     *  generated once for all transmissive materials. The upside is that it can be faster if you
     *  use multiple MeshPhysical and Transmission materials, the downside is that transmissive materials
     *  using this can't see other transparent or transmissive objects, default: false */
    transmissionSampler: boolean;
    /** Render the backside of the material (more cost, better results), default: false */
    backside: boolean;
    /** Backside thickness (when backside is true), default: 0 */
    backsideThickness: number;
    backsideEnvMapIntensity: number;
    /** Resolution of the local buffer, default: undefined (fullscreen) */
    resolution?: number;
    /** Resolution of the local buffer for backfaces, default: undefined (fullscreen) */
    backsideResolution?: number;
    /** Refraction samples, default: 6 */
    samples: number;
    /** Buffer scene background (can be a texture, a cubetexture or a color), default: null */
    background?: Texture | Color;
};
export declare class NgtsMeshTransmissionMaterial {
    attach: import("@angular/core").InputSignal<NgtAttachable>;
    options: import("@angular/core").InputSignalWithTransform<NgtsMeshTransmissionMaterialOptions, "" | Partial<NgtsMeshTransmissionMaterialOptions>>;
    parameters: import("@angular/core").Signal<Omit<NgtsMeshTransmissionMaterialOptions, "side" | "thickness" | "anisotropy" | "transmission" | "buffer" | "anisotropicBlur" | "samples" | "transmissionSampler" | "backside" | "backsideThickness" | "backsideEnvMapIntensity" | "resolution" | "backsideResolution" | "background">>;
    private resolution;
    private backsideResolution;
    private samples;
    private buffer;
    private anisotropy;
    private anisotropicBlur;
    private background;
    private backside;
    private backsideThickness;
    private backsideEnvMapIntensity;
    transmissionSampler: import("@angular/core").Signal<boolean>;
    transmission: import("@angular/core").Signal<number | undefined>;
    thickness: import("@angular/core").Signal<number | undefined>;
    side: import("@angular/core").Signal<import("three").Side | undefined>;
    materialRef: import("@angular/core").Signal<ElementRef<MeshTransmissionMaterial & {
        samples?: number | undefined;
        transmissionSampler?: boolean | undefined;
        chromaticAberration?: number | undefined;
        transmission?: number | undefined;
        _transmission?: number | undefined;
        transmissionMap?: null | undefined;
        roughness?: number | undefined;
        thickness?: number | undefined;
        thicknessMap?: null | undefined;
        attenuationDistance?: number | undefined;
        attenuationColor?: Color | undefined;
        anisotropicBlur?: number | undefined;
        time?: number | undefined;
        distortion?: number | undefined;
        distortionScale?: number | undefined;
        temporalDistortion?: number | undefined;
        buffer?: null | undefined;
    }> | undefined>;
    private backResolution;
    private fboBack;
    private fboMain;
    bufferTexture: import("@angular/core").Signal<Texture>;
    anisotropicBlurOption: import("@angular/core").Signal<number | undefined>;
    private discardMaterial;
    material: import("@angular/core").Signal<MeshTransmissionMaterial>;
    constructor();
    static ɵfac: i0.ɵɵFactoryDeclaration<NgtsMeshTransmissionMaterial, never>;
    static ɵcmp: i0.ɵɵComponentDeclaration<NgtsMeshTransmissionMaterial, "ngts-mesh-transmission-material", never, { "attach": { "alias": "attach"; "required": false; "isSignal": true; }; "options": { "alias": "options"; "required": false; "isSignal": true; }; }, {}, never, ["*"], true, never>;
}
