import { Injector } from '@angular/core';
import { ColorSpace, DepthTexture, MagnificationTextureFilter, MinificationTextureFilter, TextureDataType, WebGLRenderTarget, Wrapping } from 'three';
import { TextureEncoding } from './deprecated';
import * as i0 from "@angular/core";
interface FBOSettings {
    /** Defines the count of MSAA samples. Can only be used with WebGL 2. Default: 0 */
    samples?: number;
    /** If set, the scene depth will be rendered into buffer.depthTexture. Default: false */
    depth?: boolean;
    wrapS?: Wrapping | undefined;
    wrapT?: Wrapping | undefined;
    magFilter?: MagnificationTextureFilter | undefined;
    minFilter?: MinificationTextureFilter | undefined;
    format?: number | undefined;
    type?: TextureDataType | undefined;
    anisotropy?: number | undefined;
    depthBuffer?: boolean | undefined;
    stencilBuffer?: boolean | undefined;
    generateMipmaps?: boolean | undefined;
    depthTexture?: DepthTexture | undefined;
    encoding?: TextureEncoding | undefined;
    colorSpace?: ColorSpace | undefined;
}
export interface NgtsFBOParams {
    width?: number | FBOSettings;
    height?: number;
    settings?: FBOSettings;
}
export declare function injectFBO(params?: () => NgtsFBOParams, { injector }?: {
    injector?: Injector;
}): import("@angular/core").Signal<WebGLRenderTarget<import("three").Texture>>;
export declare class NgtsFBO {
    fbo: import("@angular/core").InputSignal<{
        width: NgtsFBOParams["width"];
        height: NgtsFBOParams["height"];
    } & FBOSettings>;
    private template;
    private viewContainerRef;
    constructor();
    static ngTemplateContextGuard(_: NgtsFBO, ctx: unknown): ctx is {
        $implicit: ReturnType<typeof injectFBO>;
    };
    static ɵfac: i0.ɵɵFactoryDeclaration<NgtsFBO, never>;
    static ɵdir: i0.ɵɵDirectiveDeclaration<NgtsFBO, "ng-template[fbo]", never, { "fbo": { "alias": "fbo"; "required": false; "isSignal": true; }; }, {}, never, never, true, never>;
}
export {};
