import { ElementRef } from '@angular/core';
import { NgtHTML } from 'angular-three';
import { NgtsHTML } from './html';
import { CalculatePosition } from './utils';
import * as i0 from "@angular/core";
type PointerEventsProperties = 'auto' | 'none' | 'visiblePainted' | 'visibleFill' | 'visibleStroke' | 'visible' | 'painted' | 'fill' | 'stroke' | 'all' | 'inherit';
export interface NgtsHTMLContentOptions {
    eps: number;
    zIndexRange: [number, number];
    center: boolean;
    prepend: boolean;
    fullscreen: boolean;
    containerClass: string;
    containerStyle: Partial<CSSStyleDeclaration>;
    pointerEvents: PointerEventsProperties;
    calculatePosition: CalculatePosition;
    sprite: boolean;
    distanceFactor?: number;
    parent?: HTMLElement | ElementRef<HTMLElement>;
}
export declare class NgtsHTMLContent extends NgtHTML {
    options: import("@angular/core").InputSignalWithTransform<NgtsHTMLContentOptions, "" | Partial<NgtsHTMLContentOptions>>;
    occluded: import("@angular/core").OutputEmitterRef<boolean>;
    html: NgtsHTML;
    transformOuterRef: import("@angular/core").Signal<ElementRef<HTMLDivElement> | undefined>;
    transformInnerRef: import("@angular/core").Signal<ElementRef<HTMLDivElement> | undefined>;
    containerRef: import("@angular/core").Signal<ElementRef<HTMLDivElement> | undefined>;
    private gl;
    private events;
    private camera;
    private scene;
    protected size: import("@angular/core").Signal<import("angular-three").NgtSize>;
    private parent;
    private zIndexRange;
    private calculatePosition;
    private prepend;
    protected center: import("@angular/core").Signal<boolean>;
    protected fullscreen: import("@angular/core").Signal<boolean>;
    protected pointerEvents: import("@angular/core").Signal<PointerEventsProperties>;
    protected containerClass: import("@angular/core").Signal<string>;
    protected containerStyle: import("@angular/core").Signal<Partial<CSSStyleDeclaration>>;
    private target;
    constructor();
    static ɵfac: i0.ɵɵFactoryDeclaration<NgtsHTMLContent, never>;
    static ɵcmp: i0.ɵɵComponentDeclaration<NgtsHTMLContent, "[ngtsHTMLContent]", never, { "options": { "alias": "ngtsHTMLContent"; "required": false; "isSignal": true; }; }, { "occluded": "occluded"; }, never, ["*"], true, never>;
}
export {};
