import { ElementRef } from '@angular/core';
import { NgtGroup } from 'angular-three';
import { Group, Mesh, Object3D, PlaneGeometry } from 'three';
import * as i0 from "@angular/core";
export interface NgtsHTMLOptions extends Partial<NgtGroup> {
    occlude: ElementRef<Object3D>[] | Object3D[] | boolean | 'raycast' | 'blending';
    transform: boolean;
    castShadow: boolean;
    receiveShadow: boolean;
}
export declare class NgtsHTML {
    options: import("@angular/core").InputSignalWithTransform<NgtsHTMLOptions, "" | Partial<NgtsHTMLOptions>>;
    parameters: import("@angular/core").Signal<Omit<NgtsHTMLOptions, "castShadow" | "receiveShadow" | "transform" | "occlude">>;
    groupRef: import("@angular/core").Signal<ElementRef<Group<import("three").Object3DEventMap>>>;
    occlusionMeshRef: import("@angular/core").Signal<ElementRef<Mesh<import("three").BufferGeometry<import("three").NormalBufferAttributes>, import("three").Material | import("three").Material[], import("three").Object3DEventMap>> | undefined>;
    occlusionGeometryRef: import("@angular/core").Signal<ElementRef<PlaneGeometry> | undefined>;
    occlude: import("@angular/core").Signal<boolean | "raycast" | ElementRef<Object3D<import("three").Object3DEventMap>>[] | Object3D<import("three").Object3DEventMap>[] | "blending">;
    transform: import("@angular/core").Signal<boolean>;
    castShadow: import("@angular/core").Signal<boolean>;
    receiveShadow: import("@angular/core").Signal<boolean>;
    scale: import("@angular/core").Signal<import("angular-three").NgtVector3 | undefined>;
    isRaycastOcclusion: import("@angular/core").Signal<boolean | 0>;
    private shaders;
    vertexShader: import("@angular/core").Signal<string | undefined>;
    fragmentShader: import("@angular/core").Signal<string>;
    constructor();
    protected readonly DoubleSide: 2;
    static ɵfac: i0.ɵɵFactoryDeclaration<NgtsHTML, never>;
    static ɵcmp: i0.ɵɵComponentDeclaration<NgtsHTML, "ngts-html", never, { "options": { "alias": "options"; "required": false; "isSignal": true; }; }, {}, never, ["[data-occlusion-geometry]", "[data-occlusion-material]", "*"], true, never>;
}
