import { Camera, Matrix4, Object3D, Raycaster } from 'three';
export declare function defaultCalculatePosition(el: Object3D, camera: Camera, size: {
    width: number;
    height: number;
}): number[];
export type CalculatePosition = typeof defaultCalculatePosition;
export declare function isObjectBehindCamera(el: Object3D, camera: Camera): boolean;
export declare function isObjectVisible(el: Object3D, camera: Camera, raycaster: Raycaster, occlude: Object3D[]): boolean;
export declare function objectScale(el: Object3D, camera: Camera): number;
export declare function objectZIndex(el: Object3D, camera: Camera, zIndexRange: Array<number>): number | undefined;
export declare function epsilon(value: number): number;
export declare function getCSSMatrix(matrix: Matrix4, multipliers: number[], prepend?: string): string;
export declare const getCameraCSSMatrix: (matrix: Matrix4) => string;
export declare const getObjectCSSMatrix: (matrix: Matrix4, factor: number) => string;
