import { ElementRef } from '@angular/core';
import { NgtObject3DNode } from 'angular-three';
import { Color, Group, Intersection, Points, Raycaster } from 'three';
export type NgtPositionPoint = NgtObject3DNode<PositionPoint, typeof PositionPoint>;
export declare class PositionPoint extends Group {
    size: number;
    color: Color;
    instance: ElementRef<Points> | Points | null | undefined;
    constructor();
    get geometry(): import("three").BufferGeometry<import("three").NormalBufferAttributes> | undefined;
    raycast(raycaster: Raycaster, intersects: Intersection[]): void;
}
declare global {
    interface HTMLElementTagNameMap {
        /**
         * @extends ngt-group
         * @rawOptions instance|color|size
         */
        'ngt-position-point': NgtPositionPoint;
    }
}
