import { ElementRef } from '@angular/core';
import { NgtVector3 } from 'angular-three';
import { ColorRepresentation, Vector2 } from 'three';
import { Line2, LineMaterial, LineMaterialParameters, LineSegmentsGeometry } from 'three-stdlib';
import { SegmentObject } from './segment-object';
import * as i0 from "@angular/core";
export declare class NgtsSegment {
    start: import("@angular/core").InputSignal<NgtVector3>;
    end: import("@angular/core").InputSignal<NgtVector3>;
    color: import("@angular/core").InputSignal<ColorRepresentation | undefined>;
    normalizedStart: import("@angular/core").Signal<import("three").Vector3>;
    normalizedEnd: import("@angular/core").Signal<import("three").Vector3>;
    segmentRef: import("@angular/core").Signal<ElementRef<SegmentObject>>;
    segments: NgtsSegments;
    constructor();
    static ɵfac: i0.ɵɵFactoryDeclaration<NgtsSegment, never>;
    static ɵcmp: i0.ɵɵComponentDeclaration<NgtsSegment, "ngts-segment", never, { "start": { "alias": "start"; "required": true; "isSignal": true; }; "end": { "alias": "end"; "required": true; "isSignal": true; }; "color": { "alias": "color"; "required": false; "isSignal": true; }; }, {}, never, never, true, never>;
}
export interface NgtsSegmentsOptions extends LineMaterialParameters {
    limit: number;
    lineWidth: number;
}
export declare class NgtsSegments {
    options: import("@angular/core").InputSignalWithTransform<NgtsSegmentsOptions, "" | Partial<NgtsSegmentsOptions>>;
    parameters: import("@angular/core").Signal<Omit<NgtsSegmentsOptions, "limit" | "lineWidth">>;
    private lineWidth;
    private limit;
    lineRef: import("@angular/core").Signal<ElementRef<Line2> | undefined>;
    segments: Array<ElementRef<SegmentObject> | SegmentObject>;
    line: Line2;
    material: LineMaterial;
    geometry: LineSegmentsGeometry;
    resolution: Vector2;
    materialParameters: import("@angular/core").Signal<{
        alphaToCoverage?: boolean | undefined | undefined;
        color?: number | undefined | undefined;
        dashed?: boolean | undefined | undefined;
        dashScale?: number | undefined | undefined;
        dashSize?: number | undefined | undefined;
        dashOffset?: number | undefined | undefined;
        gapSize?: number | undefined | undefined;
        linewidth: number;
        resolution: Vector2;
        wireframe?: boolean | undefined | undefined;
        worldUnits?: boolean | undefined | undefined;
        alphaHash?: boolean | undefined | undefined;
        alphaTest?: number | undefined | undefined;
        blendAlpha?: number | undefined | undefined;
        blendColor?: ColorRepresentation | undefined;
        blendDst?: import("three").BlendingDstFactor | undefined;
        blendDstAlpha?: number | undefined | undefined;
        blendEquation?: import("three").BlendingEquation | undefined;
        blendEquationAlpha?: number | undefined | undefined;
        blending?: import("three").Blending | undefined;
        blendSrc?: 200 | 201 | 202 | 203 | 204 | 205 | 206 | 207 | 208 | 209 | 211 | 212 | 213 | 214 | 210 | undefined;
        blendSrcAlpha?: number | undefined | undefined;
        clipIntersection?: boolean | undefined | undefined;
        clippingPlanes?: import("three").Plane[] | undefined | undefined;
        clipShadows?: boolean | undefined | undefined;
        colorWrite?: boolean | undefined | undefined;
        defines?: any;
        depthFunc?: import("three").DepthModes | undefined;
        depthTest?: boolean | undefined | undefined;
        depthWrite?: boolean | undefined | undefined;
        name?: string | undefined | undefined;
        opacity?: number | undefined | undefined;
        polygonOffset?: boolean | undefined | undefined;
        polygonOffsetFactor?: number | undefined | undefined;
        polygonOffsetUnits?: number | undefined | undefined;
        precision?: "highp" | "mediump" | "lowp" | null | undefined | undefined;
        premultipliedAlpha?: boolean | undefined | undefined;
        forceSinglePass?: boolean | undefined | undefined;
        dithering?: boolean | undefined | undefined;
        side?: import("three").Side | undefined;
        shadowSide?: import("three").Side | undefined;
        toneMapped?: boolean | undefined | undefined;
        transparent?: boolean | undefined | undefined;
        vertexColors: boolean;
        visible?: boolean | undefined | undefined;
        format?: import("three").PixelFormat | undefined;
        stencilWrite?: boolean | undefined | undefined;
        stencilFunc?: import("three").StencilFunc | undefined;
        stencilRef?: number | undefined | undefined;
        stencilWriteMask?: number | undefined | undefined;
        stencilFuncMask?: number | undefined | undefined;
        stencilFail?: import("three").StencilOp | undefined;
        stencilZFail?: import("three").StencilOp | undefined;
        stencilZPass?: import("three").StencilOp | undefined;
        userData?: Record<string, any> | undefined;
    }>;
    positions: import("@angular/core").Signal<number[]>;
    colors: import("@angular/core").Signal<number[]>;
    constructor();
    subscribe(ref: ElementRef<SegmentObject> | SegmentObject): () => void;
    static ɵfac: i0.ɵɵFactoryDeclaration<NgtsSegments, never>;
    static ɵcmp: i0.ɵɵComponentDeclaration<NgtsSegments, "ngts-segments", never, { "options": { "alias": "options"; "required": false; "isSignal": true; }; }, {}, never, ["*"], true, never>;
}
