import { NgtMaterial } from 'angular-three';
import { Color, ColorRepresentation, Side, Vector3 } from 'three';
export interface GridMaterialOptions {
    /** Cell size, default: 0.5 */
    cellSize: number;
    /** Cell thickness, default: 0.5 */
    cellThickness: number;
    /** Cell color, default: black */
    cellColor: ColorRepresentation;
    /** Section size, default: 1 */
    sectionSize: number;
    /** Section thickness, default: 1 */
    sectionThickness: number;
    /** Section color, default: #2080ff */
    sectionColor: ColorRepresentation;
    /** Follow camera, default: false */
    followCamera: boolean;
    /** Display the grid infinitely, default: false */
    infiniteGrid: boolean;
    /** Fade distance, default: 100 */
    fadeDistance: number;
    /** Fade strength, default: 1 */
    fadeStrength: number;
    /** Fade from camera (1) or origin (0), or somewhere in between, default: camera */
    fadeFrom: number;
    /** Material side, default: THREE.BackSide */
    side: Side;
}
export declare const GridMaterial: (new (parameters?: (import("three").ShaderMaterialParameters & Partial<{
    cellSize: number;
    sectionSize: number;
    fadeDistance: number;
    fadeStrength: number;
    fadeFrom: number;
    cellThickness: number;
    sectionThickness: number;
    cellColor: Color;
    sectionColor: Color;
    infiniteGrid: false;
    followCamera: false;
    worldCamProjPosition: Vector3;
    worldPlanePosition: Vector3;
}>) | undefined) => import("three").ShaderMaterial & {
    cellSize: number;
    sectionSize: number;
    fadeDistance: number;
    fadeStrength: number;
    fadeFrom: number;
    cellThickness: number;
    sectionThickness: number;
    cellColor: Color;
    sectionColor: Color;
    infiniteGrid: false;
    followCamera: false;
    worldCamProjPosition: Vector3;
    worldPlanePosition: Vector3;
}) & {
    key: string;
};
export type NgtGridMaterial = NgtMaterial<InstanceType<typeof GridMaterial>, [GridMaterialOptions]>;
declare global {
    interface HTMLElementTagNameMap {
        /**
         * @extends ngt-shader-material
         * @options GridMaterialOptions
         */
        'ngt-grid-material': NgtGridMaterial;
    }
}
