import { ElementRef } from '@angular/core';
import { NgtGroup } from 'angular-three';
import { Group, Mesh, PlaneGeometry } from 'three';
import * as i0 from "@angular/core";
export interface NgtsAccumulativeShadowsOptions extends Partial<NgtGroup> {
    /** How many frames it can render, more yields cleaner results but takes more time, 40 */
    frames: number;
    /** If frames === Infinity blend controls the refresh ratio, 100 */
    blend: number;
    /** Can limit the amount of frames rendered if frames === Infinity, usually to get some performance back once a movable scene has settled, Infinity */
    limit: number;
    /** Scale of the plane,  */
    scale: number;
    /** Temporal accumulates shadows over time which is more performant but has a visual regression over instant results, false  */
    temporal?: boolean;
    /** Opacity of the plane, 1 */
    opacity: number;
    /** Discards alpha pixels, 0.65 */
    alphaTest: number;
    /** Shadow color, black */
    color: string;
    /** Colorblend, how much colors turn to black, 0 is black, 2 */
    colorBlend: number;
    /** Buffer resolution, 1024 */
    resolution: number;
    /** Texture tonemapping */
    toneMapped: boolean;
}
export declare class NgtsAccumulativeShadows {
    nullTraversal: () => null;
    Math: Math;
    options: import("@angular/core").InputSignalWithTransform<NgtsAccumulativeShadowsOptions, "" | Partial<NgtsAccumulativeShadowsOptions>>;
    parameters: import("@angular/core").Signal<Omit<NgtsAccumulativeShadowsOptions, "scale" | "frames" | "blend" | "limit" | "temporal" | "opacity" | "alphaTest" | "color" | "colorBlend" | "resolution" | "toneMapped">>;
    lightsRef: import("@angular/core").Signal<ElementRef<Group<import("three").Object3DEventMap>>>;
    planeRef: import("@angular/core").Signal<ElementRef<Mesh<PlaneGeometry, import("three").ShaderMaterial & {
        map: import("three").Texture | null;
        color: import("three").Color;
        alphaTest: number;
        opacity: number;
        blend: number;
    }, import("three").Object3DEventMap>>>;
    private store;
    private gl;
    private camera;
    private scene;
    private invalidate;
    private opacity;
    private alphaTest;
    private limit;
    private resolution;
    private previousPLM;
    private pLM;
    scale: import("@angular/core").Signal<number>;
    toneMapped: import("@angular/core").Signal<boolean>;
    color: import("@angular/core").Signal<string>;
    colorBlend: import("@angular/core").Signal<number>;
    map: import("@angular/core").Signal<import("three").Texture>;
    lightsMap: Map<string, () => void>;
    temporal: import("@angular/core").Signal<boolean>;
    frames: import("@angular/core").Signal<number>;
    blend: import("@angular/core").Signal<number>;
    count: number;
    constructor();
    getMesh(): Mesh<PlaneGeometry, import("three").ShaderMaterial & {
        map: import("three").Texture | null;
        color: import("three").Color;
        alphaTest: number;
        opacity: number;
        blend: number;
    }, import("three").Object3DEventMap>;
    reset(): void;
    update(frames?: number): void;
    static ɵfac: i0.ɵɵFactoryDeclaration<NgtsAccumulativeShadows, never>;
    static ɵcmp: i0.ɵɵComponentDeclaration<NgtsAccumulativeShadows, "ngts-accumulative-shadows", never, { "options": { "alias": "options"; "required": false; "isSignal": true; }; }, {}, never, ["*"], true, never>;
}
