import { ElementRef, Signal } from '@angular/core';
import { NgtGroup } from 'angular-three';
import { Box3, Group, Object3D, Vector3 } from 'three';
import * as i0 from "@angular/core";
export interface NgtsBoundsOptions extends Partial<NgtGroup> {
    maxDuration: number;
    margin: number;
    observe: boolean;
    fit: boolean;
    clip: boolean;
    interpolateFunc: (t: number) => number;
}
export declare class NgtsBounds {
    options: import("@angular/core").InputSignalWithTransform<NgtsBoundsOptions, "" | Partial<NgtsBoundsOptions>>;
    groupRef: Signal<ElementRef<Group<import("three").Object3DEventMap>>>;
    private store;
    private camera;
    private invalidate;
    private size;
    private controls;
    private clipOption;
    private fitOption;
    private observe;
    private origin;
    private goal;
    private animationState;
    private t;
    private box;
    constructor();
    getSize(): {
        box: Box3;
        size: Vector3;
        center: Vector3;
        distance: number;
    };
    refresh(object?: Object3D | Box3): this;
    reset(): this;
    moveTo(position: Vector3 | [number, number, number]): this;
    lookAt({ target, up }: {
        target: Vector3 | [number, number, number];
        up?: Vector3 | [number, number, number];
    }): this;
    fit(): this;
    clip(): this;
    static ɵfac: i0.ɵɵFactoryDeclaration<NgtsBounds, never>;
    static ɵcmp: i0.ɵɵComponentDeclaration<NgtsBounds, "ngts-bounds", never, { "options": { "alias": "options"; "required": false; "isSignal": true; }; }, {}, never, ["*"], true, never>;
}
