import { ElementRef } from '@angular/core';
import { Box3, Group, Object3D, Sphere, Vector3 } from 'three';
import * as i0 from "@angular/core";
export interface NgtsCenterState {
    /** The next parent above <Center> */
    parent: Object3D;
    /** The outmost container group of the <Center> component */
    container: Object3D;
    width: number;
    height: number;
    depth: number;
    boundingBox: Box3;
    boundingSphere: Sphere;
    center: Vector3;
    verticalAlignment: number;
    horizontalAlignment: number;
    depthAlignment: number;
}
export interface NgtsCenterOptions {
    top?: boolean;
    right?: boolean;
    bottom?: boolean;
    left?: boolean;
    front?: boolean;
    back?: boolean;
    /** Disable all axes */
    disable?: boolean;
    /** Disable x-axis centering */
    disableX?: boolean;
    /** Disable y-axis centering */
    disableY?: boolean;
    /** Disable z-axis centering */
    disableZ?: boolean;
    /** See https://threejs.org/docs/index.html?q=box3#api/en/math/Box3.setFromObject */
    precise: boolean;
    /** Optional cacheKey to keep the component from recalculating on every render */
    cacheKey: any;
}
export declare class NgtsCenter {
    options: import("@angular/core").InputSignalWithTransform<Partial<{
        addEventListener: (<TEventKey extends keyof import("angular-three").NgtNodeEventMap<TOriginal>>(type: TEventKey, listener: (this: import("angular-three").NgtNodeElement<Group<import("three").Object3DEventMap>, typeof Group>, ev: import("angular-three").NgtNodeEventMap<Group<import("three").Object3DEventMap>>[TEventKey]) => any) => void) & (<TEventKey extends keyof import("angular-three").NgtAllObject3DEventsMap>(type: TEventKey, listener: (this: /*elided*/ any, ev: import("angular-three").NgtAllObject3DEventsMap[TEventKey]) => any) => void);
        removeEventListener: (<TEventKey extends keyof import("angular-three").NgtNodeEventMap<TOriginal>>(type: TEventKey, listener: (this: import("angular-three").NgtNodeElement<Group<import("three").Object3DEventMap>, typeof Group>, ev: import("angular-three").NgtNodeEventMap<Group<import("three").Object3DEventMap>>[TEventKey]) => any) => void) & (<TEventKey extends keyof import("angular-three").NgtAllObject3DEventsMap>(type: TEventKey, listener: (this: /*elided*/ any, ev: import("angular-three").NgtAllObject3DEventsMap[TEventKey]) => any) => void);
        attach: string | string[] | import("angular-three").NgtAttachFunction;
        __ngt_args__: [];
        readonly isGroup?: true | undefined;
        readonly isObject3D?: true | undefined;
        readonly id?: number | undefined;
        uuid?: string | undefined;
        name?: string | undefined;
        readonly type?: string | undefined;
        parent?: Object3D<import("three").Object3DEventMap> | null | undefined;
        children?: Object3D<import("three").Object3DEventMap>[] | undefined;
        readonly modelViewMatrix?: import("three").Matrix4 | undefined;
        readonly normalMatrix?: import("three").Matrix3 | undefined;
        matrixWorld?: import("three").Matrix4 | undefined;
        matrixAutoUpdate?: boolean | undefined;
        matrixWorldAutoUpdate?: boolean | undefined;
        matrixWorldNeedsUpdate?: boolean | undefined;
        visible?: boolean | undefined;
        castShadow?: boolean | undefined;
        receiveShadow?: boolean | undefined;
        frustumCulled?: boolean | undefined;
        renderOrder?: number | undefined;
        animations?: import("three").AnimationClip[] | undefined;
        userData?: Record<string, any> | undefined;
        customDepthMaterial?: import("three").Material | undefined;
        customDistanceMaterial?: import("three").Material | undefined;
        onBeforeShadow?: ((renderer: import("three").WebGLRenderer, scene: import("three").Scene, camera: import("three").Camera, shadowCamera: import("three").Camera, geometry: import("three").BufferGeometry, depthMaterial: import("three").Material, group: Group) => void) | undefined;
        onAfterShadow?: ((renderer: import("three").WebGLRenderer, scene: import("three").Scene, camera: import("three").Camera, shadowCamera: import("three").Camera, geometry: import("three").BufferGeometry, depthMaterial: import("three").Material, group: Group) => void) | undefined;
        onBeforeRender?: ((renderer: import("three").WebGLRenderer, scene: import("three").Scene, camera: import("three").Camera, geometry: import("three").BufferGeometry, material: import("three").Material, group: Group) => void) | undefined;
        onAfterRender?: ((renderer: import("three").WebGLRenderer, scene: import("three").Scene, camera: import("three").Camera, geometry: import("three").BufferGeometry, material: import("three").Material, group: Group) => void) | undefined;
        applyMatrix4?: ((matrix: import("three").Matrix4) => void) | undefined;
        applyQuaternion?: ((quaternion: import("three").Quaternion) => Group<import("three").Object3DEventMap>) | undefined;
        setRotationFromAxisAngle?: ((axis: Vector3, angle: number) => void) | undefined;
        setRotationFromEuler?: ((euler: import("three").Euler) => void) | undefined;
        setRotationFromMatrix?: ((m: import("three").Matrix4) => void) | undefined;
        setRotationFromQuaternion?: ((q: import("three").Quaternion) => void) | undefined;
        rotateOnAxis?: ((axis: Vector3, angle: number) => Group<import("three").Object3DEventMap>) | undefined;
        rotateOnWorldAxis?: ((axis: Vector3, angle: number) => Group<import("three").Object3DEventMap>) | undefined;
        rotateX?: ((angle: number) => Group<import("three").Object3DEventMap>) | undefined;
        rotateY?: ((angle: number) => Group<import("three").Object3DEventMap>) | undefined;
        rotateZ?: ((angle: number) => Group<import("three").Object3DEventMap>) | undefined;
        translateOnAxis?: ((axis: Vector3, distance: number) => Group<import("three").Object3DEventMap>) | undefined;
        translateX?: ((distance: number) => Group<import("three").Object3DEventMap>) | undefined;
        translateY?: ((distance: number) => Group<import("three").Object3DEventMap>) | undefined;
        translateZ?: ((distance: number) => Group<import("three").Object3DEventMap>) | undefined;
        localToWorld?: ((vector: Vector3) => Vector3) | undefined;
        worldToLocal?: ((vector: Vector3) => Vector3) | undefined;
        lookAt?: {
            (vector: Vector3): void;
            (x: number, y: number, z: number): void;
        } | undefined;
        add?: ((...object: Object3D[]) => Group<import("three").Object3DEventMap>) | undefined;
        remove?: ((...object: Object3D[]) => Group<import("three").Object3DEventMap>) | undefined;
        removeFromParent?: (() => Group<import("three").Object3DEventMap>) | undefined;
        clear?: (() => Group<import("three").Object3DEventMap>) | undefined;
        getObjectById?: ((id: number) => Object3D | undefined) | undefined;
        getObjectByName?: ((name: string) => Object3D | undefined) | undefined;
        getObjectByProperty?: ((name: string, value: any) => Object3D | undefined) | undefined;
        getObjectsByProperty?: ((name: string, value: any, optionalTarget?: Object3D[]) => Object3D[]) | undefined;
        getWorldPosition?: ((target: Vector3) => Vector3) | undefined;
        getWorldQuaternion?: ((target: import("three").Quaternion) => import("three").Quaternion) | undefined;
        getWorldScale?: ((target: Vector3) => Vector3) | undefined;
        getWorldDirection?: ((target: Vector3) => Vector3) | undefined;
        traverse?: ((callback: (object: Object3D) => any) => void) | undefined;
        traverseVisible?: ((callback: (object: Object3D) => any) => void) | undefined;
        traverseAncestors?: ((callback: (object: Object3D) => any) => void) | undefined;
        updateMatrix?: (() => void) | undefined;
        updateMatrixWorld?: ((force?: boolean) => void) | undefined;
        updateWorldMatrix?: ((updateParents: boolean, updateChildren: boolean) => void) | undefined;
        toJSON?: ((meta?: import("three").JSONMeta) => import("three").Object3DJSON) | undefined;
        clone?: ((recursive?: boolean) => Group<import("three").Object3DEventMap>) | undefined;
        copy?: ((object: Object3D, recursive?: boolean) => Group<import("three").Object3DEventMap>) | undefined;
        hasEventListener?: (<T extends keyof import("three").Object3DEventMap>(type: T, listener: import("three").EventListener<import("three").Object3DEventMap[T], T, Group<import("three").Object3DEventMap>>) => boolean) | undefined;
        dispatchEvent?: (<T extends keyof import("three").Object3DEventMap>(event: import("three").BaseEvent<T> & import("three").Object3DEventMap[T]) => void) | undefined;
        position: import("angular-three").NgtVector3;
        up: import("angular-three").NgtVector3;
        scale: import("angular-three").NgtVector3;
        rotation: import("angular-three").NgtEuler;
        matrix: import("angular-three").NgtMatrix4;
        quaternion: import("angular-three").NgtQuaternion;
        layers: import("angular-three").NgtLayers;
        dispose: (() => void) | null;
        raycast: Object3D["raycast"] | null;
    }> & NgtsCenterOptions, "" | Partial<Partial<{
        addEventListener: (<TEventKey extends keyof import("angular-three").NgtNodeEventMap<TOriginal>>(type: TEventKey, listener: (this: import("angular-three").NgtNodeElement<Group<import("three").Object3DEventMap>, typeof Group>, ev: import("angular-three").NgtNodeEventMap<Group<import("three").Object3DEventMap>>[TEventKey]) => any) => void) & (<TEventKey extends keyof import("angular-three").NgtAllObject3DEventsMap>(type: TEventKey, listener: (this: /*elided*/ any, ev: import("angular-three").NgtAllObject3DEventsMap[TEventKey]) => any) => void);
        removeEventListener: (<TEventKey extends keyof import("angular-three").NgtNodeEventMap<TOriginal>>(type: TEventKey, listener: (this: import("angular-three").NgtNodeElement<Group<import("three").Object3DEventMap>, typeof Group>, ev: import("angular-three").NgtNodeEventMap<Group<import("three").Object3DEventMap>>[TEventKey]) => any) => void) & (<TEventKey extends keyof import("angular-three").NgtAllObject3DEventsMap>(type: TEventKey, listener: (this: /*elided*/ any, ev: import("angular-three").NgtAllObject3DEventsMap[TEventKey]) => any) => void);
        attach: string | string[] | import("angular-three").NgtAttachFunction;
        __ngt_args__: [];
        readonly isGroup?: true | undefined;
        readonly isObject3D?: true | undefined;
        readonly id?: number | undefined;
        uuid?: string | undefined;
        name?: string | undefined;
        readonly type?: string | undefined;
        parent?: Object3D<import("three").Object3DEventMap> | null | undefined;
        children?: Object3D<import("three").Object3DEventMap>[] | undefined;
        readonly modelViewMatrix?: import("three").Matrix4 | undefined;
        readonly normalMatrix?: import("three").Matrix3 | undefined;
        matrixWorld?: import("three").Matrix4 | undefined;
        matrixAutoUpdate?: boolean | undefined;
        matrixWorldAutoUpdate?: boolean | undefined;
        matrixWorldNeedsUpdate?: boolean | undefined;
        visible?: boolean | undefined;
        castShadow?: boolean | undefined;
        receiveShadow?: boolean | undefined;
        frustumCulled?: boolean | undefined;
        renderOrder?: number | undefined;
        animations?: import("three").AnimationClip[] | undefined;
        userData?: Record<string, any> | undefined;
        customDepthMaterial?: import("three").Material | undefined;
        customDistanceMaterial?: import("three").Material | undefined;
        onBeforeShadow?: ((renderer: import("three").WebGLRenderer, scene: import("three").Scene, camera: import("three").Camera, shadowCamera: import("three").Camera, geometry: import("three").BufferGeometry, depthMaterial: import("three").Material, group: Group) => void) | undefined;
        onAfterShadow?: ((renderer: import("three").WebGLRenderer, scene: import("three").Scene, camera: import("three").Camera, shadowCamera: import("three").Camera, geometry: import("three").BufferGeometry, depthMaterial: import("three").Material, group: Group) => void) | undefined;
        onBeforeRender?: ((renderer: import("three").WebGLRenderer, scene: import("three").Scene, camera: import("three").Camera, geometry: import("three").BufferGeometry, material: import("three").Material, group: Group) => void) | undefined;
        onAfterRender?: ((renderer: import("three").WebGLRenderer, scene: import("three").Scene, camera: import("three").Camera, geometry: import("three").BufferGeometry, material: import("three").Material, group: Group) => void) | undefined;
        applyMatrix4?: ((matrix: import("three").Matrix4) => void) | undefined;
        applyQuaternion?: ((quaternion: import("three").Quaternion) => Group<import("three").Object3DEventMap>) | undefined;
        setRotationFromAxisAngle?: ((axis: Vector3, angle: number) => void) | undefined;
        setRotationFromEuler?: ((euler: import("three").Euler) => void) | undefined;
        setRotationFromMatrix?: ((m: import("three").Matrix4) => void) | undefined;
        setRotationFromQuaternion?: ((q: import("three").Quaternion) => void) | undefined;
        rotateOnAxis?: ((axis: Vector3, angle: number) => Group<import("three").Object3DEventMap>) | undefined;
        rotateOnWorldAxis?: ((axis: Vector3, angle: number) => Group<import("three").Object3DEventMap>) | undefined;
        rotateX?: ((angle: number) => Group<import("three").Object3DEventMap>) | undefined;
        rotateY?: ((angle: number) => Group<import("three").Object3DEventMap>) | undefined;
        rotateZ?: ((angle: number) => Group<import("three").Object3DEventMap>) | undefined;
        translateOnAxis?: ((axis: Vector3, distance: number) => Group<import("three").Object3DEventMap>) | undefined;
        translateX?: ((distance: number) => Group<import("three").Object3DEventMap>) | undefined;
        translateY?: ((distance: number) => Group<import("three").Object3DEventMap>) | undefined;
        translateZ?: ((distance: number) => Group<import("three").Object3DEventMap>) | undefined;
        localToWorld?: ((vector: Vector3) => Vector3) | undefined;
        worldToLocal?: ((vector: Vector3) => Vector3) | undefined;
        lookAt?: {
            (vector: Vector3): void;
            (x: number, y: number, z: number): void;
        } | undefined;
        add?: ((...object: Object3D[]) => Group<import("three").Object3DEventMap>) | undefined;
        remove?: ((...object: Object3D[]) => Group<import("three").Object3DEventMap>) | undefined;
        removeFromParent?: (() => Group<import("three").Object3DEventMap>) | undefined;
        clear?: (() => Group<import("three").Object3DEventMap>) | undefined;
        getObjectById?: ((id: number) => Object3D | undefined) | undefined;
        getObjectByName?: ((name: string) => Object3D | undefined) | undefined;
        getObjectByProperty?: ((name: string, value: any) => Object3D | undefined) | undefined;
        getObjectsByProperty?: ((name: string, value: any, optionalTarget?: Object3D[]) => Object3D[]) | undefined;
        getWorldPosition?: ((target: Vector3) => Vector3) | undefined;
        getWorldQuaternion?: ((target: import("three").Quaternion) => import("three").Quaternion) | undefined;
        getWorldScale?: ((target: Vector3) => Vector3) | undefined;
        getWorldDirection?: ((target: Vector3) => Vector3) | undefined;
        traverse?: ((callback: (object: Object3D) => any) => void) | undefined;
        traverseVisible?: ((callback: (object: Object3D) => any) => void) | undefined;
        traverseAncestors?: ((callback: (object: Object3D) => any) => void) | undefined;
        updateMatrix?: (() => void) | undefined;
        updateMatrixWorld?: ((force?: boolean) => void) | undefined;
        updateWorldMatrix?: ((updateParents: boolean, updateChildren: boolean) => void) | undefined;
        toJSON?: ((meta?: import("three").JSONMeta) => import("three").Object3DJSON) | undefined;
        clone?: ((recursive?: boolean) => Group<import("three").Object3DEventMap>) | undefined;
        copy?: ((object: Object3D, recursive?: boolean) => Group<import("three").Object3DEventMap>) | undefined;
        hasEventListener?: (<T extends keyof import("three").Object3DEventMap>(type: T, listener: import("three").EventListener<import("three").Object3DEventMap[T], T, Group<import("three").Object3DEventMap>>) => boolean) | undefined;
        dispatchEvent?: (<T extends keyof import("three").Object3DEventMap>(event: import("three").BaseEvent<T> & import("three").Object3DEventMap[T]) => void) | undefined;
        position: import("angular-three").NgtVector3;
        up: import("angular-three").NgtVector3;
        scale: import("angular-three").NgtVector3;
        rotation: import("angular-three").NgtEuler;
        matrix: import("angular-three").NgtMatrix4;
        quaternion: import("angular-three").NgtQuaternion;
        layers: import("angular-three").NgtLayers;
        dispose: (() => void) | null;
        raycast: Object3D["raycast"] | null;
    }> & NgtsCenterOptions>>;
    parameters: import("@angular/core").Signal<Omit<Partial<{
        addEventListener: (<TEventKey extends keyof import("angular-three").NgtNodeEventMap<TOriginal>>(type: TEventKey, listener: (this: import("angular-three").NgtNodeElement<Group<import("three").Object3DEventMap>, typeof Group>, ev: import("angular-three").NgtNodeEventMap<Group<import("three").Object3DEventMap>>[TEventKey]) => any) => void) & (<TEventKey extends keyof import("angular-three").NgtAllObject3DEventsMap>(type: TEventKey, listener: (this: /*elided*/ any, ev: import("angular-three").NgtAllObject3DEventsMap[TEventKey]) => any) => void);
        removeEventListener: (<TEventKey extends keyof import("angular-three").NgtNodeEventMap<TOriginal>>(type: TEventKey, listener: (this: import("angular-three").NgtNodeElement<Group<import("three").Object3DEventMap>, typeof Group>, ev: import("angular-three").NgtNodeEventMap<Group<import("three").Object3DEventMap>>[TEventKey]) => any) => void) & (<TEventKey extends keyof import("angular-three").NgtAllObject3DEventsMap>(type: TEventKey, listener: (this: /*elided*/ any, ev: import("angular-three").NgtAllObject3DEventsMap[TEventKey]) => any) => void);
        attach: string | string[] | import("angular-three").NgtAttachFunction;
        __ngt_args__: [];
        readonly isGroup?: true | undefined;
        readonly isObject3D?: true | undefined;
        readonly id?: number | undefined;
        uuid?: string | undefined;
        name?: string | undefined;
        readonly type?: string | undefined;
        parent?: Object3D<import("three").Object3DEventMap> | null | undefined;
        children?: Object3D<import("three").Object3DEventMap>[] | undefined;
        readonly modelViewMatrix?: import("three").Matrix4 | undefined;
        readonly normalMatrix?: import("three").Matrix3 | undefined;
        matrixWorld?: import("three").Matrix4 | undefined;
        matrixAutoUpdate?: boolean | undefined;
        matrixWorldAutoUpdate?: boolean | undefined;
        matrixWorldNeedsUpdate?: boolean | undefined;
        visible?: boolean | undefined;
        castShadow?: boolean | undefined;
        receiveShadow?: boolean | undefined;
        frustumCulled?: boolean | undefined;
        renderOrder?: number | undefined;
        animations?: import("three").AnimationClip[] | undefined;
        userData?: Record<string, any> | undefined;
        customDepthMaterial?: import("three").Material | undefined;
        customDistanceMaterial?: import("three").Material | undefined;
        onBeforeShadow?: ((renderer: import("three").WebGLRenderer, scene: import("three").Scene, camera: import("three").Camera, shadowCamera: import("three").Camera, geometry: import("three").BufferGeometry, depthMaterial: import("three").Material, group: Group) => void) | undefined;
        onAfterShadow?: ((renderer: import("three").WebGLRenderer, scene: import("three").Scene, camera: import("three").Camera, shadowCamera: import("three").Camera, geometry: import("three").BufferGeometry, depthMaterial: import("three").Material, group: Group) => void) | undefined;
        onBeforeRender?: ((renderer: import("three").WebGLRenderer, scene: import("three").Scene, camera: import("three").Camera, geometry: import("three").BufferGeometry, material: import("three").Material, group: Group) => void) | undefined;
        onAfterRender?: ((renderer: import("three").WebGLRenderer, scene: import("three").Scene, camera: import("three").Camera, geometry: import("three").BufferGeometry, material: import("three").Material, group: Group) => void) | undefined;
        applyMatrix4?: ((matrix: import("three").Matrix4) => void) | undefined;
        applyQuaternion?: ((quaternion: import("three").Quaternion) => Group<import("three").Object3DEventMap>) | undefined;
        setRotationFromAxisAngle?: ((axis: Vector3, angle: number) => void) | undefined;
        setRotationFromEuler?: ((euler: import("three").Euler) => void) | undefined;
        setRotationFromMatrix?: ((m: import("three").Matrix4) => void) | undefined;
        setRotationFromQuaternion?: ((q: import("three").Quaternion) => void) | undefined;
        rotateOnAxis?: ((axis: Vector3, angle: number) => Group<import("three").Object3DEventMap>) | undefined;
        rotateOnWorldAxis?: ((axis: Vector3, angle: number) => Group<import("three").Object3DEventMap>) | undefined;
        rotateX?: ((angle: number) => Group<import("three").Object3DEventMap>) | undefined;
        rotateY?: ((angle: number) => Group<import("three").Object3DEventMap>) | undefined;
        rotateZ?: ((angle: number) => Group<import("three").Object3DEventMap>) | undefined;
        translateOnAxis?: ((axis: Vector3, distance: number) => Group<import("three").Object3DEventMap>) | undefined;
        translateX?: ((distance: number) => Group<import("three").Object3DEventMap>) | undefined;
        translateY?: ((distance: number) => Group<import("three").Object3DEventMap>) | undefined;
        translateZ?: ((distance: number) => Group<import("three").Object3DEventMap>) | undefined;
        localToWorld?: ((vector: Vector3) => Vector3) | undefined;
        worldToLocal?: ((vector: Vector3) => Vector3) | undefined;
        lookAt?: {
            (vector: Vector3): void;
            (x: number, y: number, z: number): void;
        } | undefined;
        add?: ((...object: Object3D[]) => Group<import("three").Object3DEventMap>) | undefined;
        remove?: ((...object: Object3D[]) => Group<import("three").Object3DEventMap>) | undefined;
        removeFromParent?: (() => Group<import("three").Object3DEventMap>) | undefined;
        clear?: (() => Group<import("three").Object3DEventMap>) | undefined;
        getObjectById?: ((id: number) => Object3D | undefined) | undefined;
        getObjectByName?: ((name: string) => Object3D | undefined) | undefined;
        getObjectByProperty?: ((name: string, value: any) => Object3D | undefined) | undefined;
        getObjectsByProperty?: ((name: string, value: any, optionalTarget?: Object3D[]) => Object3D[]) | undefined;
        getWorldPosition?: ((target: Vector3) => Vector3) | undefined;
        getWorldQuaternion?: ((target: import("three").Quaternion) => import("three").Quaternion) | undefined;
        getWorldScale?: ((target: Vector3) => Vector3) | undefined;
        getWorldDirection?: ((target: Vector3) => Vector3) | undefined;
        traverse?: ((callback: (object: Object3D) => any) => void) | undefined;
        traverseVisible?: ((callback: (object: Object3D) => any) => void) | undefined;
        traverseAncestors?: ((callback: (object: Object3D) => any) => void) | undefined;
        updateMatrix?: (() => void) | undefined;
        updateMatrixWorld?: ((force?: boolean) => void) | undefined;
        updateWorldMatrix?: ((updateParents: boolean, updateChildren: boolean) => void) | undefined;
        toJSON?: ((meta?: import("three").JSONMeta) => import("three").Object3DJSON) | undefined;
        clone?: ((recursive?: boolean) => Group<import("three").Object3DEventMap>) | undefined;
        copy?: ((object: Object3D, recursive?: boolean) => Group<import("three").Object3DEventMap>) | undefined;
        hasEventListener?: (<T extends keyof import("three").Object3DEventMap>(type: T, listener: import("three").EventListener<import("three").Object3DEventMap[T], T, Group<import("three").Object3DEventMap>>) => boolean) | undefined;
        dispatchEvent?: (<T extends keyof import("three").Object3DEventMap>(event: import("three").BaseEvent<T> & import("three").Object3DEventMap[T]) => void) | undefined;
        position: import("angular-three").NgtVector3;
        up: import("angular-three").NgtVector3;
        scale: import("angular-three").NgtVector3;
        rotation: import("angular-three").NgtEuler;
        matrix: import("angular-three").NgtMatrix4;
        quaternion: import("angular-three").NgtQuaternion;
        layers: import("angular-three").NgtLayers;
        dispose: (() => void) | null;
        raycast: Object3D["raycast"] | null;
    }> & NgtsCenterOptions, "top" | "right" | "bottom" | "left" | "front" | "back" | "disable" | "disableX" | "disableY" | "disableZ" | "precise" | "cacheKey">>;
    centered: import("@angular/core").OutputEmitterRef<NgtsCenterState>;
    groupRef: import("@angular/core").Signal<ElementRef<Group<import("three").Object3DEventMap>>>;
    private outerRef;
    private innerRef;
    centerOptions: import("@angular/core").Signal<Pick<Partial<{
        addEventListener: (<TEventKey extends keyof import("angular-three").NgtNodeEventMap<TOriginal>>(type: TEventKey, listener: (this: import("angular-three").NgtNodeElement<Group<import("three").Object3DEventMap>, typeof Group>, ev: import("angular-three").NgtNodeEventMap<Group<import("three").Object3DEventMap>>[TEventKey]) => any) => void) & (<TEventKey extends keyof import("angular-three").NgtAllObject3DEventsMap>(type: TEventKey, listener: (this: /*elided*/ any, ev: import("angular-three").NgtAllObject3DEventsMap[TEventKey]) => any) => void);
        removeEventListener: (<TEventKey extends keyof import("angular-three").NgtNodeEventMap<TOriginal>>(type: TEventKey, listener: (this: import("angular-three").NgtNodeElement<Group<import("three").Object3DEventMap>, typeof Group>, ev: import("angular-three").NgtNodeEventMap<Group<import("three").Object3DEventMap>>[TEventKey]) => any) => void) & (<TEventKey extends keyof import("angular-three").NgtAllObject3DEventsMap>(type: TEventKey, listener: (this: /*elided*/ any, ev: import("angular-three").NgtAllObject3DEventsMap[TEventKey]) => any) => void);
        attach: string | string[] | import("angular-three").NgtAttachFunction;
        __ngt_args__: [];
        readonly isGroup?: true | undefined;
        readonly isObject3D?: true | undefined;
        readonly id?: number | undefined;
        uuid?: string | undefined;
        name?: string | undefined;
        readonly type?: string | undefined;
        parent?: Object3D<import("three").Object3DEventMap> | null | undefined;
        children?: Object3D<import("three").Object3DEventMap>[] | undefined;
        readonly modelViewMatrix?: import("three").Matrix4 | undefined;
        readonly normalMatrix?: import("three").Matrix3 | undefined;
        matrixWorld?: import("three").Matrix4 | undefined;
        matrixAutoUpdate?: boolean | undefined;
        matrixWorldAutoUpdate?: boolean | undefined;
        matrixWorldNeedsUpdate?: boolean | undefined;
        visible?: boolean | undefined;
        castShadow?: boolean | undefined;
        receiveShadow?: boolean | undefined;
        frustumCulled?: boolean | undefined;
        renderOrder?: number | undefined;
        animations?: import("three").AnimationClip[] | undefined;
        userData?: Record<string, any> | undefined;
        customDepthMaterial?: import("three").Material | undefined;
        customDistanceMaterial?: import("three").Material | undefined;
        onBeforeShadow?: ((renderer: import("three").WebGLRenderer, scene: import("three").Scene, camera: import("three").Camera, shadowCamera: import("three").Camera, geometry: import("three").BufferGeometry, depthMaterial: import("three").Material, group: Group) => void) | undefined;
        onAfterShadow?: ((renderer: import("three").WebGLRenderer, scene: import("three").Scene, camera: import("three").Camera, shadowCamera: import("three").Camera, geometry: import("three").BufferGeometry, depthMaterial: import("three").Material, group: Group) => void) | undefined;
        onBeforeRender?: ((renderer: import("three").WebGLRenderer, scene: import("three").Scene, camera: import("three").Camera, geometry: import("three").BufferGeometry, material: import("three").Material, group: Group) => void) | undefined;
        onAfterRender?: ((renderer: import("three").WebGLRenderer, scene: import("three").Scene, camera: import("three").Camera, geometry: import("three").BufferGeometry, material: import("three").Material, group: Group) => void) | undefined;
        applyMatrix4?: ((matrix: import("three").Matrix4) => void) | undefined;
        applyQuaternion?: ((quaternion: import("three").Quaternion) => Group<import("three").Object3DEventMap>) | undefined;
        setRotationFromAxisAngle?: ((axis: Vector3, angle: number) => void) | undefined;
        setRotationFromEuler?: ((euler: import("three").Euler) => void) | undefined;
        setRotationFromMatrix?: ((m: import("three").Matrix4) => void) | undefined;
        setRotationFromQuaternion?: ((q: import("three").Quaternion) => void) | undefined;
        rotateOnAxis?: ((axis: Vector3, angle: number) => Group<import("three").Object3DEventMap>) | undefined;
        rotateOnWorldAxis?: ((axis: Vector3, angle: number) => Group<import("three").Object3DEventMap>) | undefined;
        rotateX?: ((angle: number) => Group<import("three").Object3DEventMap>) | undefined;
        rotateY?: ((angle: number) => Group<import("three").Object3DEventMap>) | undefined;
        rotateZ?: ((angle: number) => Group<import("three").Object3DEventMap>) | undefined;
        translateOnAxis?: ((axis: Vector3, distance: number) => Group<import("three").Object3DEventMap>) | undefined;
        translateX?: ((distance: number) => Group<import("three").Object3DEventMap>) | undefined;
        translateY?: ((distance: number) => Group<import("three").Object3DEventMap>) | undefined;
        translateZ?: ((distance: number) => Group<import("three").Object3DEventMap>) | undefined;
        localToWorld?: ((vector: Vector3) => Vector3) | undefined;
        worldToLocal?: ((vector: Vector3) => Vector3) | undefined;
        lookAt?: {
            (vector: Vector3): void;
            (x: number, y: number, z: number): void;
        } | undefined;
        add?: ((...object: Object3D[]) => Group<import("three").Object3DEventMap>) | undefined;
        remove?: ((...object: Object3D[]) => Group<import("three").Object3DEventMap>) | undefined;
        removeFromParent?: (() => Group<import("three").Object3DEventMap>) | undefined;
        clear?: (() => Group<import("three").Object3DEventMap>) | undefined;
        getObjectById?: ((id: number) => Object3D | undefined) | undefined;
        getObjectByName?: ((name: string) => Object3D | undefined) | undefined;
        getObjectByProperty?: ((name: string, value: any) => Object3D | undefined) | undefined;
        getObjectsByProperty?: ((name: string, value: any, optionalTarget?: Object3D[]) => Object3D[]) | undefined;
        getWorldPosition?: ((target: Vector3) => Vector3) | undefined;
        getWorldQuaternion?: ((target: import("three").Quaternion) => import("three").Quaternion) | undefined;
        getWorldScale?: ((target: Vector3) => Vector3) | undefined;
        getWorldDirection?: ((target: Vector3) => Vector3) | undefined;
        traverse?: ((callback: (object: Object3D) => any) => void) | undefined;
        traverseVisible?: ((callback: (object: Object3D) => any) => void) | undefined;
        traverseAncestors?: ((callback: (object: Object3D) => any) => void) | undefined;
        updateMatrix?: (() => void) | undefined;
        updateMatrixWorld?: ((force?: boolean) => void) | undefined;
        updateWorldMatrix?: ((updateParents: boolean, updateChildren: boolean) => void) | undefined;
        toJSON?: ((meta?: import("three").JSONMeta) => import("three").Object3DJSON) | undefined;
        clone?: ((recursive?: boolean) => Group<import("three").Object3DEventMap>) | undefined;
        copy?: ((object: Object3D, recursive?: boolean) => Group<import("three").Object3DEventMap>) | undefined;
        hasEventListener?: (<T extends keyof import("three").Object3DEventMap>(type: T, listener: import("three").EventListener<import("three").Object3DEventMap[T], T, Group<import("three").Object3DEventMap>>) => boolean) | undefined;
        dispatchEvent?: (<T extends keyof import("three").Object3DEventMap>(event: import("three").BaseEvent<T> & import("three").Object3DEventMap[T]) => void) | undefined;
        position: import("angular-three").NgtVector3;
        up: import("angular-three").NgtVector3;
        scale: import("angular-three").NgtVector3;
        rotation: import("angular-three").NgtEuler;
        matrix: import("angular-three").NgtMatrix4;
        quaternion: import("angular-three").NgtQuaternion;
        layers: import("angular-three").NgtLayers;
        dispose: (() => void) | null;
        raycast: Object3D["raycast"] | null;
    }> & NgtsCenterOptions, "top" | "right" | "bottom" | "left" | "front" | "back" | "disable" | "disableX" | "disableY" | "disableZ" | "precise" | "cacheKey">>;
    constructor();
    static ɵfac: i0.ɵɵFactoryDeclaration<NgtsCenter, never>;
    static ɵcmp: i0.ɵɵComponentDeclaration<NgtsCenter, "ngts-center", never, { "options": { "alias": "options"; "required": false; "isSignal": true; }; }, { "centered": "centered"; }, never, ["*"], true, never>;
}
