import { ElementRef } from '@angular/core';
import { NgtGroup } from 'angular-three';
import { ColorRepresentation, Group, OrthographicCamera, PlaneGeometry } from 'three';
import * as i0 from "@angular/core";
export interface NgtsContactShadowsOptions extends Partial<Omit<NgtGroup, 'scale'>> {
    opacity: number;
    width: number;
    height: number;
    blur: number;
    near: number;
    far: number;
    smooth: boolean;
    resolution: number;
    frames: number;
    scale: number | [x: number, y: number];
    color: ColorRepresentation;
    depthWrite: boolean;
}
export declare class NgtsContactShadows {
    Math: Math;
    options: import("@angular/core").InputSignalWithTransform<NgtsContactShadowsOptions, "" | Partial<NgtsContactShadowsOptions>>;
    parameters: import("@angular/core").Signal<Omit<NgtsContactShadowsOptions, "scale" | "renderOrder" | "width" | "height" | "frames" | "opacity" | "color" | "resolution" | "near" | "far" | "blur" | "smooth" | "depthWrite">>;
    contactShadowsRef: import("@angular/core").Signal<ElementRef<Group<import("three").Object3DEventMap>>>;
    shadowsCameraRef: import("@angular/core").Signal<ElementRef<OrthographicCamera> | undefined>;
    private store;
    private scene;
    private gl;
    private scaledWidth;
    private scaledHeight;
    private resolution;
    private color;
    private near;
    private far;
    private smooth;
    private frames;
    private blur;
    private renderTarget;
    private renderTargetBlur;
    planeGeometry: import("@angular/core").Signal<PlaneGeometry>;
    private blurPlane;
    private depthMaterial;
    private horizontalBlurMaterial;
    private verticalBlurMaterial;
    renderOrder: import("@angular/core").Signal<number | undefined>;
    opacity: import("@angular/core").Signal<number>;
    depthWrite: import("@angular/core").Signal<boolean>;
    texture: import("@angular/core").Signal<import("three").Texture>;
    cameraArgs: import("@angular/core").Signal<number[]>;
    constructor();
    private renderShadows;
    private blurShadows;
    private createRenderTarget;
    static ɵfac: i0.ɵɵFactoryDeclaration<NgtsContactShadows, never>;
    static ɵcmp: i0.ɵɵComponentDeclaration<NgtsContactShadows, "ngts-contact-shadows", never, { "options": { "alias": "options"; "required": false; "isSignal": true; }; }, {}, never, never, true, never>;
}
