import { ElementRef, TemplateRef } from '@angular/core';
import { Euler, Scene, Texture, WebGLCubeRenderTarget } from 'three';
import { NgtsEnvironmentPresets, NgtsInjectEnvironmentOptions } from './inject-environment';
import * as i0 from "@angular/core";
export interface NgtsEnvironmentOptions extends Partial<NgtsInjectEnvironmentOptions> {
    frames?: number;
    near?: number;
    far?: number;
    resolution?: number;
    background?: boolean | 'only';
    /** deprecated, use backgroundBlurriness */
    blur?: number;
    backgroundBlurriness?: number;
    backgroundIntensity?: number;
    backgroundRotation?: Euler;
    environmentIntensity?: number;
    environmentRotation?: Euler;
    map?: Texture;
    preset?: NgtsEnvironmentPresets;
    scene?: Scene | ElementRef<Scene>;
    ground?: boolean | {
        radius?: number;
        height?: number;
        scale?: number;
    };
}
export declare class NgtsEnvironmentMap {
    options: import("@angular/core").InputSignalWithTransform<NgtsEnvironmentOptions, "" | Partial<NgtsEnvironmentOptions>>;
    envSet: import("@angular/core").OutputEmitterRef<void>;
    constructor();
    static ɵfac: i0.ɵɵFactoryDeclaration<NgtsEnvironmentMap, never>;
    static ɵdir: i0.ɵɵDirectiveDeclaration<NgtsEnvironmentMap, "ngts-environment-map", never, { "options": { "alias": "options"; "required": false; "isSignal": true; }; }, { "envSet": "envSet"; }, never, never, true, never>;
}
export declare class NgtsEnvironmentCube {
    options: import("@angular/core").InputSignalWithTransform<NgtsEnvironmentOptions, "" | Partial<NgtsEnvironmentOptions>>;
    envSet: import("@angular/core").OutputEmitterRef<void>;
    private store;
    private defaultScene;
    private envConfig;
    constructor();
    static ɵfac: i0.ɵɵFactoryDeclaration<NgtsEnvironmentCube, never>;
    static ɵdir: i0.ɵɵDirectiveDeclaration<NgtsEnvironmentCube, "ngts-environment-cube", never, { "options": { "alias": "options"; "required": false; "isSignal": true; }; }, { "envSet": "envSet"; }, never, never, true, never>;
}
export declare class NgtsEnvironmentPortal {
    private defaultOptions;
    options: import("@angular/core").InputSignalWithTransform<NgtsEnvironmentOptions, "" | Partial<NgtsEnvironmentOptions>>;
    content: import("@angular/core").InputSignal<TemplateRef<unknown>>;
    envSet: import("@angular/core").OutputEmitterRef<void>;
    private injector;
    private store;
    private defaultScene;
    private gl;
    private cameraRef;
    protected map: import("@angular/core").Signal<Texture | undefined>;
    protected files: import("@angular/core").Signal<string | string[] | undefined>;
    protected preset: import("@angular/core").Signal<"apartment" | "city" | "dawn" | "forest" | "lobby" | "night" | "park" | "studio" | "sunset" | "warehouse" | undefined>;
    private extensions;
    private path;
    protected envMapOptions: import("@angular/core").Signal<{
        background: boolean;
        map: Texture | undefined;
        extensions: ((loader: import("three").Loader) => void) | undefined;
    }>;
    protected envCubeOptions: import("@angular/core").Signal<{
        background: boolean;
        files: string | string[] | undefined;
        preset: "apartment" | "city" | "dawn" | "forest" | "lobby" | "night" | "park" | "studio" | "sunset" | "warehouse" | undefined;
        extensions: ((loader: import("three").Loader) => void) | undefined;
        path: string | undefined;
    }>;
    private near;
    private far;
    private resolution;
    private fbo;
    protected cameraArgs: import("@angular/core").Signal<(number | WebGLCubeRenderTarget | undefined)[]>;
    protected virtualScene: import("angular-three").NgtInstanceNode<Scene>;
    private setEnvEffectRef?;
    constructor();
    onEnvSet(): void;
    private setPortalEnv;
    static ɵfac: i0.ɵɵFactoryDeclaration<NgtsEnvironmentPortal, never>;
    static ɵcmp: i0.ɵɵComponentDeclaration<NgtsEnvironmentPortal, "ngts-environment-portal", never, { "options": { "alias": "options"; "required": false; "isSignal": true; }; "content": { "alias": "content"; "required": true; "isSignal": true; }; }, { "envSet": "envSet"; }, never, never, true, never>;
}
export declare class NgtsEnvironmentGround {
    options: import("@angular/core").InputSignal<NgtsEnvironmentOptions>;
    envSet: import("@angular/core").OutputEmitterRef<void>;
    private defaultTexture;
    protected height: import("@angular/core").Signal<any>;
    protected radius: import("@angular/core").Signal<any>;
    protected scale: import("@angular/core").Signal<any>;
    protected args: import("@angular/core").Signal<(Texture | null)[]>;
    protected envMapOptions: import("@angular/core").Signal<NgtsEnvironmentOptions>;
    constructor();
    static ɵfac: i0.ɵɵFactoryDeclaration<NgtsEnvironmentGround, never>;
    static ɵcmp: i0.ɵɵComponentDeclaration<NgtsEnvironmentGround, "ngts-environment-ground", never, { "options": { "alias": "options"; "required": false; "isSignal": true; }; }, { "envSet": "envSet"; }, never, never, true, never>;
}
export declare class NgtsEnvironment {
    options: import("@angular/core").InputSignal<NgtsEnvironmentOptions>;
    content: import("@angular/core").Signal<TemplateRef<any> | undefined>;
    envSet: import("@angular/core").OutputEmitterRef<void>;
    static ɵfac: i0.ɵɵFactoryDeclaration<NgtsEnvironment, never>;
    static ɵcmp: i0.ɵɵComponentDeclaration<NgtsEnvironment, "ngts-environment", never, { "options": { "alias": "options"; "required": false; "isSignal": true; }; }, { "envSet": "envSet"; }, ["content"], never, true, never>;
}
