import { Injector } from '@angular/core';
import { TextureEncoding } from 'angular-three-soba/misc';
import { CubeTexture, Loader, Texture } from 'three';
export declare const ENVIRONMENT_PRESETS: {
    apartment: string;
    city: string;
    dawn: string;
    forest: string;
    lobby: string;
    night: string;
    park: string;
    studio: string;
    sunset: string;
    warehouse: string;
};
export type NgtsEnvironmentPresets = keyof typeof ENVIRONMENT_PRESETS;
export interface NgtsInjectEnvironmentOptions {
    files: string | string[];
    path: string;
    preset?: NgtsEnvironmentPresets;
    extensions?: (loader: Loader) => void;
    encoding?: TextureEncoding;
}
export declare function injectEnvironment(options?: () => Partial<NgtsInjectEnvironmentOptions>, { injector }?: {
    injector?: Injector;
}): import("@angular/core").Signal<Texture | CubeTexture | null>;
export declare namespace injectEnvironment {
    var preload: (options?: () => Partial<NgtsInjectEnvironmentOptions>) => void;
    var clear: (clearOptions: {
        files?: string | string[];
        preset?: NgtsEnvironmentPresets;
    }) => void;
}
