import { ElementRef } from '@angular/core';
import { NgtVector3 } from 'angular-three';
import { Mesh, MeshBasicMaterial, Texture } from 'three';
import * as i0 from "@angular/core";
export interface NgtsLightformerOptions {
    map?: Texture;
    toneMapped: boolean;
    color: string;
    form: 'circle' | 'ring' | 'rect';
    scale: number | [number, number, number] | [number, number];
    intensity: number;
    target?: NgtVector3;
}
export declare class NgtsLightformer {
    side: 2;
    options: import("@angular/core").InputSignalWithTransform<Partial<Omit<{
        addEventListener: (<TEventKey extends keyof import("angular-three").NgtNodeEventMap<TOriginal>>(type: TEventKey, listener: (this: import("angular-three").NgtNodeElement<Mesh<import("three").BufferGeometry<import("three").NormalBufferAttributes>, import("three").Material | import("three").Material[], import("three").Object3DEventMap>, typeof Mesh>, ev: import("angular-three").NgtNodeEventMap<Mesh<import("three").BufferGeometry<import("three").NormalBufferAttributes>, import("three").Material | import("three").Material[], import("three").Object3DEventMap>>[TEventKey]) => any) => void) & (<TEventKey extends keyof import("angular-three").NgtAllObject3DEventsMap>(type: TEventKey, listener: (this: /*elided*/ any, ev: import("angular-three").NgtAllObject3DEventsMap[TEventKey]) => any) => void);
        removeEventListener: (<TEventKey extends keyof import("angular-three").NgtNodeEventMap<TOriginal>>(type: TEventKey, listener: (this: import("angular-three").NgtNodeElement<Mesh<import("three").BufferGeometry<import("three").NormalBufferAttributes>, import("three").Material | import("three").Material[], import("three").Object3DEventMap>, typeof Mesh>, ev: import("angular-three").NgtNodeEventMap<Mesh<import("three").BufferGeometry<import("three").NormalBufferAttributes>, import("three").Material | import("three").Material[], import("three").Object3DEventMap>>[TEventKey]) => any) => void) & (<TEventKey extends keyof import("angular-three").NgtAllObject3DEventsMap>(type: TEventKey, listener: (this: /*elided*/ any, ev: import("angular-three").NgtAllObject3DEventsMap[TEventKey]) => any) => void);
        attach: string | string[] | import("angular-three").NgtAttachFunction;
        __ngt_args__: [geometry?: import("three").BufferGeometry<import("three").NormalBufferAttributes> | undefined, material?: import("three").Material | import("three").Material[] | undefined];
        readonly isObject3D?: true | undefined;
        readonly id?: number | undefined;
        uuid?: string | undefined;
        name?: string | undefined;
        readonly type?: string | undefined;
        parent?: import("three").Object3D<import("three").Object3DEventMap> | null | undefined;
        children?: import("three").Object3D<import("three").Object3DEventMap>[] | undefined;
        readonly modelViewMatrix?: import("three").Matrix4 | undefined;
        readonly normalMatrix?: import("three").Matrix3 | undefined;
        matrixWorld?: import("three").Matrix4 | undefined;
        matrixAutoUpdate?: boolean | undefined;
        matrixWorldAutoUpdate?: boolean | undefined;
        matrixWorldNeedsUpdate?: boolean | undefined;
        visible?: boolean | undefined;
        castShadow?: boolean | undefined;
        receiveShadow?: boolean | undefined;
        frustumCulled?: boolean | undefined;
        renderOrder?: number | undefined;
        animations?: import("three").AnimationClip[] | undefined;
        userData?: Record<string, any> | undefined;
        customDepthMaterial?: import("three").Material | undefined;
        customDistanceMaterial?: import("three").Material | undefined;
        onBeforeShadow?: ((renderer: import("three").WebGLRenderer, scene: import("three").Scene, camera: import("three").Camera, shadowCamera: import("three").Camera, geometry: import("three").BufferGeometry, depthMaterial: import("three").Material, group: import("three").Group) => void) | undefined;
        onAfterShadow?: ((renderer: import("three").WebGLRenderer, scene: import("three").Scene, camera: import("three").Camera, shadowCamera: import("three").Camera, geometry: import("three").BufferGeometry, depthMaterial: import("three").Material, group: import("three").Group) => void) | undefined;
        onBeforeRender?: ((renderer: import("three").WebGLRenderer, scene: import("three").Scene, camera: import("three").Camera, geometry: import("three").BufferGeometry, material: import("three").Material, group: import("three").Group) => void) | undefined;
        onAfterRender?: ((renderer: import("three").WebGLRenderer, scene: import("three").Scene, camera: import("three").Camera, geometry: import("three").BufferGeometry, material: import("three").Material, group: import("three").Group) => void) | undefined;
        applyMatrix4?: ((matrix: import("three").Matrix4) => void) | undefined;
        applyQuaternion?: ((quaternion: import("three").Quaternion) => Mesh<import("three").BufferGeometry<import("three").NormalBufferAttributes>, import("three").Material | import("three").Material[], import("three").Object3DEventMap>) | undefined;
        setRotationFromAxisAngle?: ((axis: import("three").Vector3, angle: number) => void) | undefined;
        setRotationFromEuler?: ((euler: import("three").Euler) => void) | undefined;
        setRotationFromMatrix?: ((m: import("three").Matrix4) => void) | undefined;
        setRotationFromQuaternion?: ((q: import("three").Quaternion) => void) | undefined;
        rotateOnAxis?: ((axis: import("three").Vector3, angle: number) => Mesh<import("three").BufferGeometry<import("three").NormalBufferAttributes>, import("three").Material | import("three").Material[], import("three").Object3DEventMap>) | undefined;
        rotateOnWorldAxis?: ((axis: import("three").Vector3, angle: number) => Mesh<import("three").BufferGeometry<import("three").NormalBufferAttributes>, import("three").Material | import("three").Material[], import("three").Object3DEventMap>) | undefined;
        rotateX?: ((angle: number) => Mesh<import("three").BufferGeometry<import("three").NormalBufferAttributes>, import("three").Material | import("three").Material[], import("three").Object3DEventMap>) | undefined;
        rotateY?: ((angle: number) => Mesh<import("three").BufferGeometry<import("three").NormalBufferAttributes>, import("three").Material | import("three").Material[], import("three").Object3DEventMap>) | undefined;
        rotateZ?: ((angle: number) => Mesh<import("three").BufferGeometry<import("three").NormalBufferAttributes>, import("three").Material | import("three").Material[], import("three").Object3DEventMap>) | undefined;
        translateOnAxis?: ((axis: import("three").Vector3, distance: number) => Mesh<import("three").BufferGeometry<import("three").NormalBufferAttributes>, import("three").Material | import("three").Material[], import("three").Object3DEventMap>) | undefined;
        translateX?: ((distance: number) => Mesh<import("three").BufferGeometry<import("three").NormalBufferAttributes>, import("three").Material | import("three").Material[], import("three").Object3DEventMap>) | undefined;
        translateY?: ((distance: number) => Mesh<import("three").BufferGeometry<import("three").NormalBufferAttributes>, import("three").Material | import("three").Material[], import("three").Object3DEventMap>) | undefined;
        translateZ?: ((distance: number) => Mesh<import("three").BufferGeometry<import("three").NormalBufferAttributes>, import("three").Material | import("three").Material[], import("three").Object3DEventMap>) | undefined;
        localToWorld?: ((vector: import("three").Vector3) => import("three").Vector3) | undefined;
        worldToLocal?: ((vector: import("three").Vector3) => import("three").Vector3) | undefined;
        lookAt?: {
            (vector: import("three").Vector3): void;
            (x: number, y: number, z: number): void;
        } | undefined;
        add?: ((...object: import("three").Object3D[]) => Mesh<import("three").BufferGeometry<import("three").NormalBufferAttributes>, import("three").Material | import("three").Material[], import("three").Object3DEventMap>) | undefined;
        remove?: ((...object: import("three").Object3D[]) => Mesh<import("three").BufferGeometry<import("three").NormalBufferAttributes>, import("three").Material | import("three").Material[], import("three").Object3DEventMap>) | undefined;
        removeFromParent?: (() => Mesh<import("three").BufferGeometry<import("three").NormalBufferAttributes>, import("three").Material | import("three").Material[], import("three").Object3DEventMap>) | undefined;
        clear?: (() => Mesh<import("three").BufferGeometry<import("three").NormalBufferAttributes>, import("three").Material | import("three").Material[], import("three").Object3DEventMap>) | undefined;
        getObjectById?: ((id: number) => import("three").Object3D | undefined) | undefined;
        getObjectByName?: ((name: string) => import("three").Object3D | undefined) | undefined;
        getObjectByProperty?: ((name: string, value: any) => import("three").Object3D | undefined) | undefined;
        getObjectsByProperty?: ((name: string, value: any, optionalTarget?: import("three").Object3D[]) => import("three").Object3D[]) | undefined;
        getWorldPosition?: ((target: import("three").Vector3) => import("three").Vector3) | undefined;
        getWorldQuaternion?: ((target: import("three").Quaternion) => import("three").Quaternion) | undefined;
        getWorldScale?: ((target: import("three").Vector3) => import("three").Vector3) | undefined;
        getWorldDirection?: ((target: import("three").Vector3) => import("three").Vector3) | undefined;
        traverse?: ((callback: (object: import("three").Object3D) => any) => void) | undefined;
        traverseVisible?: ((callback: (object: import("three").Object3D) => any) => void) | undefined;
        traverseAncestors?: ((callback: (object: import("three").Object3D) => any) => void) | undefined;
        updateMatrix?: (() => void) | undefined;
        updateMatrixWorld?: ((force?: boolean) => void) | undefined;
        updateWorldMatrix?: ((updateParents: boolean, updateChildren: boolean) => void) | undefined;
        toJSON?: ((meta?: import("three").JSONMeta) => import("three").MeshJSON) | undefined;
        clone?: ((recursive?: boolean) => Mesh<import("three").BufferGeometry<import("three").NormalBufferAttributes>, import("three").Material | import("three").Material[], import("three").Object3DEventMap>) | undefined;
        copy?: ((object: import("three").Object3D, recursive?: boolean) => Mesh<import("three").BufferGeometry<import("three").NormalBufferAttributes>, import("three").Material | import("three").Material[], import("three").Object3DEventMap>) | undefined;
        hasEventListener?: (<T extends keyof import("three").Object3DEventMap>(type: T, listener: import("three").EventListener<import("three").Object3DEventMap[T], T, Mesh<import("three").BufferGeometry<import("three").NormalBufferAttributes>, import("three").Material | import("three").Material[], import("three").Object3DEventMap>>) => boolean) | undefined;
        dispatchEvent?: (<T extends keyof import("three").Object3DEventMap>(event: import("three").BaseEvent<T> & import("three").Object3DEventMap[T]) => void) | undefined;
        readonly isMesh?: true | undefined;
        geometry?: import("three").BufferGeometry<import("three").NormalBufferAttributes> | undefined;
        material?: import("three").Material | import("three").Material[] | undefined;
        morphTargetInfluences?: number[] | undefined | undefined;
        morphTargetDictionary?: {
            [key: string]: number;
        } | undefined | undefined;
        updateMorphTargets?: (() => void) | undefined;
        getVertexPosition?: ((index: number, target: import("three").Vector3) => import("three").Vector3) | undefined;
        position: NgtVector3;
        up: NgtVector3;
        scale: NgtVector3;
        rotation: import("angular-three").NgtEuler;
        matrix: import("angular-three").NgtMatrix4;
        quaternion: import("angular-three").NgtQuaternion;
        layers: import("angular-three").NgtLayers;
        dispose: (() => void) | null;
        raycast: import("three").Object3D["raycast"] | null;
    }, "scale">> & NgtsLightformerOptions, "" | Partial<Partial<Omit<{
        addEventListener: (<TEventKey extends keyof import("angular-three").NgtNodeEventMap<TOriginal>>(type: TEventKey, listener: (this: import("angular-three").NgtNodeElement<Mesh<import("three").BufferGeometry<import("three").NormalBufferAttributes>, import("three").Material | import("three").Material[], import("three").Object3DEventMap>, typeof Mesh>, ev: import("angular-three").NgtNodeEventMap<Mesh<import("three").BufferGeometry<import("three").NormalBufferAttributes>, import("three").Material | import("three").Material[], import("three").Object3DEventMap>>[TEventKey]) => any) => void) & (<TEventKey extends keyof import("angular-three").NgtAllObject3DEventsMap>(type: TEventKey, listener: (this: /*elided*/ any, ev: import("angular-three").NgtAllObject3DEventsMap[TEventKey]) => any) => void);
        removeEventListener: (<TEventKey extends keyof import("angular-three").NgtNodeEventMap<TOriginal>>(type: TEventKey, listener: (this: import("angular-three").NgtNodeElement<Mesh<import("three").BufferGeometry<import("three").NormalBufferAttributes>, import("three").Material | import("three").Material[], import("three").Object3DEventMap>, typeof Mesh>, ev: import("angular-three").NgtNodeEventMap<Mesh<import("three").BufferGeometry<import("three").NormalBufferAttributes>, import("three").Material | import("three").Material[], import("three").Object3DEventMap>>[TEventKey]) => any) => void) & (<TEventKey extends keyof import("angular-three").NgtAllObject3DEventsMap>(type: TEventKey, listener: (this: /*elided*/ any, ev: import("angular-three").NgtAllObject3DEventsMap[TEventKey]) => any) => void);
        attach: string | string[] | import("angular-three").NgtAttachFunction;
        __ngt_args__: [geometry?: import("three").BufferGeometry<import("three").NormalBufferAttributes> | undefined, material?: import("three").Material | import("three").Material[] | undefined];
        readonly isObject3D?: true | undefined;
        readonly id?: number | undefined;
        uuid?: string | undefined;
        name?: string | undefined;
        readonly type?: string | undefined;
        parent?: import("three").Object3D<import("three").Object3DEventMap> | null | undefined;
        children?: import("three").Object3D<import("three").Object3DEventMap>[] | undefined;
        readonly modelViewMatrix?: import("three").Matrix4 | undefined;
        readonly normalMatrix?: import("three").Matrix3 | undefined;
        matrixWorld?: import("three").Matrix4 | undefined;
        matrixAutoUpdate?: boolean | undefined;
        matrixWorldAutoUpdate?: boolean | undefined;
        matrixWorldNeedsUpdate?: boolean | undefined;
        visible?: boolean | undefined;
        castShadow?: boolean | undefined;
        receiveShadow?: boolean | undefined;
        frustumCulled?: boolean | undefined;
        renderOrder?: number | undefined;
        animations?: import("three").AnimationClip[] | undefined;
        userData?: Record<string, any> | undefined;
        customDepthMaterial?: import("three").Material | undefined;
        customDistanceMaterial?: import("three").Material | undefined;
        onBeforeShadow?: ((renderer: import("three").WebGLRenderer, scene: import("three").Scene, camera: import("three").Camera, shadowCamera: import("three").Camera, geometry: import("three").BufferGeometry, depthMaterial: import("three").Material, group: import("three").Group) => void) | undefined;
        onAfterShadow?: ((renderer: import("three").WebGLRenderer, scene: import("three").Scene, camera: import("three").Camera, shadowCamera: import("three").Camera, geometry: import("three").BufferGeometry, depthMaterial: import("three").Material, group: import("three").Group) => void) | undefined;
        onBeforeRender?: ((renderer: import("three").WebGLRenderer, scene: import("three").Scene, camera: import("three").Camera, geometry: import("three").BufferGeometry, material: import("three").Material, group: import("three").Group) => void) | undefined;
        onAfterRender?: ((renderer: import("three").WebGLRenderer, scene: import("three").Scene, camera: import("three").Camera, geometry: import("three").BufferGeometry, material: import("three").Material, group: import("three").Group) => void) | undefined;
        applyMatrix4?: ((matrix: import("three").Matrix4) => void) | undefined;
        applyQuaternion?: ((quaternion: import("three").Quaternion) => Mesh<import("three").BufferGeometry<import("three").NormalBufferAttributes>, import("three").Material | import("three").Material[], import("three").Object3DEventMap>) | undefined;
        setRotationFromAxisAngle?: ((axis: import("three").Vector3, angle: number) => void) | undefined;
        setRotationFromEuler?: ((euler: import("three").Euler) => void) | undefined;
        setRotationFromMatrix?: ((m: import("three").Matrix4) => void) | undefined;
        setRotationFromQuaternion?: ((q: import("three").Quaternion) => void) | undefined;
        rotateOnAxis?: ((axis: import("three").Vector3, angle: number) => Mesh<import("three").BufferGeometry<import("three").NormalBufferAttributes>, import("three").Material | import("three").Material[], import("three").Object3DEventMap>) | undefined;
        rotateOnWorldAxis?: ((axis: import("three").Vector3, angle: number) => Mesh<import("three").BufferGeometry<import("three").NormalBufferAttributes>, import("three").Material | import("three").Material[], import("three").Object3DEventMap>) | undefined;
        rotateX?: ((angle: number) => Mesh<import("three").BufferGeometry<import("three").NormalBufferAttributes>, import("three").Material | import("three").Material[], import("three").Object3DEventMap>) | undefined;
        rotateY?: ((angle: number) => Mesh<import("three").BufferGeometry<import("three").NormalBufferAttributes>, import("three").Material | import("three").Material[], import("three").Object3DEventMap>) | undefined;
        rotateZ?: ((angle: number) => Mesh<import("three").BufferGeometry<import("three").NormalBufferAttributes>, import("three").Material | import("three").Material[], import("three").Object3DEventMap>) | undefined;
        translateOnAxis?: ((axis: import("three").Vector3, distance: number) => Mesh<import("three").BufferGeometry<import("three").NormalBufferAttributes>, import("three").Material | import("three").Material[], import("three").Object3DEventMap>) | undefined;
        translateX?: ((distance: number) => Mesh<import("three").BufferGeometry<import("three").NormalBufferAttributes>, import("three").Material | import("three").Material[], import("three").Object3DEventMap>) | undefined;
        translateY?: ((distance: number) => Mesh<import("three").BufferGeometry<import("three").NormalBufferAttributes>, import("three").Material | import("three").Material[], import("three").Object3DEventMap>) | undefined;
        translateZ?: ((distance: number) => Mesh<import("three").BufferGeometry<import("three").NormalBufferAttributes>, import("three").Material | import("three").Material[], import("three").Object3DEventMap>) | undefined;
        localToWorld?: ((vector: import("three").Vector3) => import("three").Vector3) | undefined;
        worldToLocal?: ((vector: import("three").Vector3) => import("three").Vector3) | undefined;
        lookAt?: {
            (vector: import("three").Vector3): void;
            (x: number, y: number, z: number): void;
        } | undefined;
        add?: ((...object: import("three").Object3D[]) => Mesh<import("three").BufferGeometry<import("three").NormalBufferAttributes>, import("three").Material | import("three").Material[], import("three").Object3DEventMap>) | undefined;
        remove?: ((...object: import("three").Object3D[]) => Mesh<import("three").BufferGeometry<import("three").NormalBufferAttributes>, import("three").Material | import("three").Material[], import("three").Object3DEventMap>) | undefined;
        removeFromParent?: (() => Mesh<import("three").BufferGeometry<import("three").NormalBufferAttributes>, import("three").Material | import("three").Material[], import("three").Object3DEventMap>) | undefined;
        clear?: (() => Mesh<import("three").BufferGeometry<import("three").NormalBufferAttributes>, import("three").Material | import("three").Material[], import("three").Object3DEventMap>) | undefined;
        getObjectById?: ((id: number) => import("three").Object3D | undefined) | undefined;
        getObjectByName?: ((name: string) => import("three").Object3D | undefined) | undefined;
        getObjectByProperty?: ((name: string, value: any) => import("three").Object3D | undefined) | undefined;
        getObjectsByProperty?: ((name: string, value: any, optionalTarget?: import("three").Object3D[]) => import("three").Object3D[]) | undefined;
        getWorldPosition?: ((target: import("three").Vector3) => import("three").Vector3) | undefined;
        getWorldQuaternion?: ((target: import("three").Quaternion) => import("three").Quaternion) | undefined;
        getWorldScale?: ((target: import("three").Vector3) => import("three").Vector3) | undefined;
        getWorldDirection?: ((target: import("three").Vector3) => import("three").Vector3) | undefined;
        traverse?: ((callback: (object: import("three").Object3D) => any) => void) | undefined;
        traverseVisible?: ((callback: (object: import("three").Object3D) => any) => void) | undefined;
        traverseAncestors?: ((callback: (object: import("three").Object3D) => any) => void) | undefined;
        updateMatrix?: (() => void) | undefined;
        updateMatrixWorld?: ((force?: boolean) => void) | undefined;
        updateWorldMatrix?: ((updateParents: boolean, updateChildren: boolean) => void) | undefined;
        toJSON?: ((meta?: import("three").JSONMeta) => import("three").MeshJSON) | undefined;
        clone?: ((recursive?: boolean) => Mesh<import("three").BufferGeometry<import("three").NormalBufferAttributes>, import("three").Material | import("three").Material[], import("three").Object3DEventMap>) | undefined;
        copy?: ((object: import("three").Object3D, recursive?: boolean) => Mesh<import("three").BufferGeometry<import("three").NormalBufferAttributes>, import("three").Material | import("three").Material[], import("three").Object3DEventMap>) | undefined;
        hasEventListener?: (<T extends keyof import("three").Object3DEventMap>(type: T, listener: import("three").EventListener<import("three").Object3DEventMap[T], T, Mesh<import("three").BufferGeometry<import("three").NormalBufferAttributes>, import("three").Material | import("three").Material[], import("three").Object3DEventMap>>) => boolean) | undefined;
        dispatchEvent?: (<T extends keyof import("three").Object3DEventMap>(event: import("three").BaseEvent<T> & import("three").Object3DEventMap[T]) => void) | undefined;
        readonly isMesh?: true | undefined;
        geometry?: import("three").BufferGeometry<import("three").NormalBufferAttributes> | undefined;
        material?: import("three").Material | import("three").Material[] | undefined;
        morphTargetInfluences?: number[] | undefined | undefined;
        morphTargetDictionary?: {
            [key: string]: number;
        } | undefined | undefined;
        updateMorphTargets?: (() => void) | undefined;
        getVertexPosition?: ((index: number, target: import("three").Vector3) => import("three").Vector3) | undefined;
        position: NgtVector3;
        up: NgtVector3;
        scale: NgtVector3;
        rotation: import("angular-three").NgtEuler;
        matrix: import("angular-three").NgtMatrix4;
        quaternion: import("angular-three").NgtQuaternion;
        layers: import("angular-three").NgtLayers;
        dispose: (() => void) | null;
        raycast: import("three").Object3D["raycast"] | null;
    }, "scale">> & NgtsLightformerOptions>>;
    parameters: import("@angular/core").Signal<Omit<Partial<Omit<{
        addEventListener: (<TEventKey extends keyof import("angular-three").NgtNodeEventMap<TOriginal>>(type: TEventKey, listener: (this: import("angular-three").NgtNodeElement<Mesh<import("three").BufferGeometry<import("three").NormalBufferAttributes>, import("three").Material | import("three").Material[], import("three").Object3DEventMap>, typeof Mesh>, ev: import("angular-three").NgtNodeEventMap<Mesh<import("three").BufferGeometry<import("three").NormalBufferAttributes>, import("three").Material | import("three").Material[], import("three").Object3DEventMap>>[TEventKey]) => any) => void) & (<TEventKey extends keyof import("angular-three").NgtAllObject3DEventsMap>(type: TEventKey, listener: (this: /*elided*/ any, ev: import("angular-three").NgtAllObject3DEventsMap[TEventKey]) => any) => void);
        removeEventListener: (<TEventKey extends keyof import("angular-three").NgtNodeEventMap<TOriginal>>(type: TEventKey, listener: (this: import("angular-three").NgtNodeElement<Mesh<import("three").BufferGeometry<import("three").NormalBufferAttributes>, import("three").Material | import("three").Material[], import("three").Object3DEventMap>, typeof Mesh>, ev: import("angular-three").NgtNodeEventMap<Mesh<import("three").BufferGeometry<import("three").NormalBufferAttributes>, import("three").Material | import("three").Material[], import("three").Object3DEventMap>>[TEventKey]) => any) => void) & (<TEventKey extends keyof import("angular-three").NgtAllObject3DEventsMap>(type: TEventKey, listener: (this: /*elided*/ any, ev: import("angular-three").NgtAllObject3DEventsMap[TEventKey]) => any) => void);
        attach: string | string[] | import("angular-three").NgtAttachFunction;
        __ngt_args__: [geometry?: import("three").BufferGeometry<import("three").NormalBufferAttributes> | undefined, material?: import("three").Material | import("three").Material[] | undefined];
        readonly isObject3D?: true | undefined;
        readonly id?: number | undefined;
        uuid?: string | undefined;
        name?: string | undefined;
        readonly type?: string | undefined;
        parent?: import("three").Object3D<import("three").Object3DEventMap> | null | undefined;
        children?: import("three").Object3D<import("three").Object3DEventMap>[] | undefined;
        readonly modelViewMatrix?: import("three").Matrix4 | undefined;
        readonly normalMatrix?: import("three").Matrix3 | undefined;
        matrixWorld?: import("three").Matrix4 | undefined;
        matrixAutoUpdate?: boolean | undefined;
        matrixWorldAutoUpdate?: boolean | undefined;
        matrixWorldNeedsUpdate?: boolean | undefined;
        visible?: boolean | undefined;
        castShadow?: boolean | undefined;
        receiveShadow?: boolean | undefined;
        frustumCulled?: boolean | undefined;
        renderOrder?: number | undefined;
        animations?: import("three").AnimationClip[] | undefined;
        userData?: Record<string, any> | undefined;
        customDepthMaterial?: import("three").Material | undefined;
        customDistanceMaterial?: import("three").Material | undefined;
        onBeforeShadow?: ((renderer: import("three").WebGLRenderer, scene: import("three").Scene, camera: import("three").Camera, shadowCamera: import("three").Camera, geometry: import("three").BufferGeometry, depthMaterial: import("three").Material, group: import("three").Group) => void) | undefined;
        onAfterShadow?: ((renderer: import("three").WebGLRenderer, scene: import("three").Scene, camera: import("three").Camera, shadowCamera: import("three").Camera, geometry: import("three").BufferGeometry, depthMaterial: import("three").Material, group: import("three").Group) => void) | undefined;
        onBeforeRender?: ((renderer: import("three").WebGLRenderer, scene: import("three").Scene, camera: import("three").Camera, geometry: import("three").BufferGeometry, material: import("three").Material, group: import("three").Group) => void) | undefined;
        onAfterRender?: ((renderer: import("three").WebGLRenderer, scene: import("three").Scene, camera: import("three").Camera, geometry: import("three").BufferGeometry, material: import("three").Material, group: import("three").Group) => void) | undefined;
        applyMatrix4?: ((matrix: import("three").Matrix4) => void) | undefined;
        applyQuaternion?: ((quaternion: import("three").Quaternion) => Mesh<import("three").BufferGeometry<import("three").NormalBufferAttributes>, import("three").Material | import("three").Material[], import("three").Object3DEventMap>) | undefined;
        setRotationFromAxisAngle?: ((axis: import("three").Vector3, angle: number) => void) | undefined;
        setRotationFromEuler?: ((euler: import("three").Euler) => void) | undefined;
        setRotationFromMatrix?: ((m: import("three").Matrix4) => void) | undefined;
        setRotationFromQuaternion?: ((q: import("three").Quaternion) => void) | undefined;
        rotateOnAxis?: ((axis: import("three").Vector3, angle: number) => Mesh<import("three").BufferGeometry<import("three").NormalBufferAttributes>, import("three").Material | import("three").Material[], import("three").Object3DEventMap>) | undefined;
        rotateOnWorldAxis?: ((axis: import("three").Vector3, angle: number) => Mesh<import("three").BufferGeometry<import("three").NormalBufferAttributes>, import("three").Material | import("three").Material[], import("three").Object3DEventMap>) | undefined;
        rotateX?: ((angle: number) => Mesh<import("three").BufferGeometry<import("three").NormalBufferAttributes>, import("three").Material | import("three").Material[], import("three").Object3DEventMap>) | undefined;
        rotateY?: ((angle: number) => Mesh<import("three").BufferGeometry<import("three").NormalBufferAttributes>, import("three").Material | import("three").Material[], import("three").Object3DEventMap>) | undefined;
        rotateZ?: ((angle: number) => Mesh<import("three").BufferGeometry<import("three").NormalBufferAttributes>, import("three").Material | import("three").Material[], import("three").Object3DEventMap>) | undefined;
        translateOnAxis?: ((axis: import("three").Vector3, distance: number) => Mesh<import("three").BufferGeometry<import("three").NormalBufferAttributes>, import("three").Material | import("three").Material[], import("three").Object3DEventMap>) | undefined;
        translateX?: ((distance: number) => Mesh<import("three").BufferGeometry<import("three").NormalBufferAttributes>, import("three").Material | import("three").Material[], import("three").Object3DEventMap>) | undefined;
        translateY?: ((distance: number) => Mesh<import("three").BufferGeometry<import("three").NormalBufferAttributes>, import("three").Material | import("three").Material[], import("three").Object3DEventMap>) | undefined;
        translateZ?: ((distance: number) => Mesh<import("three").BufferGeometry<import("three").NormalBufferAttributes>, import("three").Material | import("three").Material[], import("three").Object3DEventMap>) | undefined;
        localToWorld?: ((vector: import("three").Vector3) => import("three").Vector3) | undefined;
        worldToLocal?: ((vector: import("three").Vector3) => import("three").Vector3) | undefined;
        lookAt?: {
            (vector: import("three").Vector3): void;
            (x: number, y: number, z: number): void;
        } | undefined;
        add?: ((...object: import("three").Object3D[]) => Mesh<import("three").BufferGeometry<import("three").NormalBufferAttributes>, import("three").Material | import("three").Material[], import("three").Object3DEventMap>) | undefined;
        remove?: ((...object: import("three").Object3D[]) => Mesh<import("three").BufferGeometry<import("three").NormalBufferAttributes>, import("three").Material | import("three").Material[], import("three").Object3DEventMap>) | undefined;
        removeFromParent?: (() => Mesh<import("three").BufferGeometry<import("three").NormalBufferAttributes>, import("three").Material | import("three").Material[], import("three").Object3DEventMap>) | undefined;
        clear?: (() => Mesh<import("three").BufferGeometry<import("three").NormalBufferAttributes>, import("three").Material | import("three").Material[], import("three").Object3DEventMap>) | undefined;
        getObjectById?: ((id: number) => import("three").Object3D | undefined) | undefined;
        getObjectByName?: ((name: string) => import("three").Object3D | undefined) | undefined;
        getObjectByProperty?: ((name: string, value: any) => import("three").Object3D | undefined) | undefined;
        getObjectsByProperty?: ((name: string, value: any, optionalTarget?: import("three").Object3D[]) => import("three").Object3D[]) | undefined;
        getWorldPosition?: ((target: import("three").Vector3) => import("three").Vector3) | undefined;
        getWorldQuaternion?: ((target: import("three").Quaternion) => import("three").Quaternion) | undefined;
        getWorldScale?: ((target: import("three").Vector3) => import("three").Vector3) | undefined;
        getWorldDirection?: ((target: import("three").Vector3) => import("three").Vector3) | undefined;
        traverse?: ((callback: (object: import("three").Object3D) => any) => void) | undefined;
        traverseVisible?: ((callback: (object: import("three").Object3D) => any) => void) | undefined;
        traverseAncestors?: ((callback: (object: import("three").Object3D) => any) => void) | undefined;
        updateMatrix?: (() => void) | undefined;
        updateMatrixWorld?: ((force?: boolean) => void) | undefined;
        updateWorldMatrix?: ((updateParents: boolean, updateChildren: boolean) => void) | undefined;
        toJSON?: ((meta?: import("three").JSONMeta) => import("three").MeshJSON) | undefined;
        clone?: ((recursive?: boolean) => Mesh<import("three").BufferGeometry<import("three").NormalBufferAttributes>, import("three").Material | import("three").Material[], import("three").Object3DEventMap>) | undefined;
        copy?: ((object: import("three").Object3D, recursive?: boolean) => Mesh<import("three").BufferGeometry<import("three").NormalBufferAttributes>, import("three").Material | import("three").Material[], import("three").Object3DEventMap>) | undefined;
        hasEventListener?: (<T extends keyof import("three").Object3DEventMap>(type: T, listener: import("three").EventListener<import("three").Object3DEventMap[T], T, Mesh<import("three").BufferGeometry<import("three").NormalBufferAttributes>, import("three").Material | import("three").Material[], import("three").Object3DEventMap>>) => boolean) | undefined;
        dispatchEvent?: (<T extends keyof import("three").Object3DEventMap>(event: import("three").BaseEvent<T> & import("three").Object3DEventMap[T]) => void) | undefined;
        readonly isMesh?: true | undefined;
        geometry?: import("three").BufferGeometry<import("three").NormalBufferAttributes> | undefined;
        material?: import("three").Material | import("three").Material[] | undefined;
        morphTargetInfluences?: number[] | undefined | undefined;
        morphTargetDictionary?: {
            [key: string]: number;
        } | undefined | undefined;
        updateMorphTargets?: (() => void) | undefined;
        getVertexPosition?: ((index: number, target: import("three").Vector3) => import("three").Vector3) | undefined;
        position: NgtVector3;
        up: NgtVector3;
        scale: NgtVector3;
        rotation: import("angular-three").NgtEuler;
        matrix: import("angular-three").NgtMatrix4;
        quaternion: import("angular-three").NgtQuaternion;
        layers: import("angular-three").NgtLayers;
        dispose: (() => void) | null;
        raycast: import("three").Object3D["raycast"] | null;
    }, "scale">> & NgtsLightformerOptions, "scale" | "intensity" | "color" | "toneMapped" | "map" | "target" | "form">>;
    private intensity;
    private color;
    private target;
    private scale;
    fixedScale: import("@angular/core").Signal<number | number[]>;
    form: import("@angular/core").Signal<"circle" | "ring" | "rect">;
    toneMapped: import("@angular/core").Signal<boolean>;
    map: import("@angular/core").Signal<Texture | undefined>;
    meshRef: import("@angular/core").Signal<ElementRef<Mesh<import("three").BufferGeometry<import("three").NormalBufferAttributes>, import("three").Material | import("three").Material[], import("three").Object3DEventMap>>>;
    defaultMaterialRef: import("@angular/core").Signal<ElementRef<MeshBasicMaterial> | undefined>;
    constructor();
    static ɵfac: i0.ɵɵFactoryDeclaration<NgtsLightformer, never>;
    static ɵcmp: i0.ɵɵComponentDeclaration<NgtsLightformer, "ngts-lightformer", never, { "options": { "alias": "options"; "required": false; "isSignal": true; }; }, {}, never, ["[data-lightformer-geometry]", "[data-lightformer-material]", "*"], true, never>;
}
