import { ElementRef } from '@angular/core';
import { NgtGroup } from 'angular-three';
import { Group } from 'three';
import * as i0 from "@angular/core";
export interface NgtsRandomizedLightsOptions extends Partial<NgtGroup> {
    /** How many frames it will jiggle the lights, 1.
     *  Frames is context aware, if a provider like AccumulativeShadows exists, frames will be taken from there!  */
    frames: number;
    /** Light position, [0, 0, 0] */
    position: [x: number, y: number, z: number];
    /** Radius of the jiggle, higher values make softer light, 5 */
    radius: number;
    /** Amount of lights, 8 */
    amount: number;
    /** Light intensity, 1 */
    intensity: number;
    /** Ambient occlusion, lower values mean less AO, hight more, you can mix AO and directional light, 0.5 */
    ambient: number;
    /** If the lights cast shadows, this is true by default */
    castShadow: boolean;
    /** Default shadow bias, 0 */
    bias: number;
    /** Default map size, 512 */
    mapSize: number;
    /** Default size of the shadow camera, 10 */
    size: number;
    /** Default shadow camera near, 0.5 */
    near: number;
    /** Default shadow camera far, 500 */
    far: number;
}
export declare class NgtsRandomizedLights {
    options: import("@angular/core").InputSignalWithTransform<NgtsRandomizedLightsOptions, "" | Partial<NgtsRandomizedLightsOptions>>;
    parameters: import("@angular/core").Signal<Omit<NgtsRandomizedLightsOptions, keyof NgtsRandomizedLightsOptions>>;
    lightsRef: import("@angular/core").Signal<ElementRef<Group<import("three").Object3DEventMap>>>;
    private accumulativeShadows;
    castShadow: import("@angular/core").Signal<boolean>;
    bias: import("@angular/core").Signal<number>;
    intensity: import("@angular/core").Signal<number>;
    amount: import("@angular/core").Signal<number>;
    private mapSize;
    shadowMapSize: import("@angular/core").Signal<number[]>;
    private position;
    length: import("@angular/core").Signal<number>;
    count: import("@angular/core").Signal<number[]>;
    private size;
    private near;
    private far;
    cameraArgs: import("@angular/core").Signal<number[]>;
    constructor();
    update(): void;
    static ɵfac: i0.ɵɵFactoryDeclaration<NgtsRandomizedLights, never>;
    static ɵcmp: i0.ɵɵComponentDeclaration<NgtsRandomizedLights, "ngts-randomized-lights", never, { "options": { "alias": "options"; "required": false; "isSignal": true; }; }, {}, never, never, true, never>;
}
