import { Injector, TemplateRef } from '@angular/core';
import { NgtAttachable, NgtComputeFunction, NgtTexture } from 'angular-three';
import { Object3D, Scene, WebGLRenderTarget } from 'three';
import * as i0 from "@angular/core";
export interface NgtsRenderTextureOptions extends Partial<Omit<NgtTexture, 'attach'>> {
    /** Optional width of the texture, defaults to viewport bounds */
    width?: number;
    /** Optional height of the texture, defaults to viewport bounds */
    height?: number;
    /** Optional fbo samples */
    samples: number;
    /** Optional stencil buffer, defaults to false */
    stencilBuffer: boolean;
    /** Optional depth buffer, defaults to true */
    depthBuffer: boolean;
    /** Optional generate mipmaps, defaults to false */
    generateMipmaps: boolean;
    /** Optional render priority, defaults to 0 */
    renderPriority: number;
    /** Optional event priority, defaults to 0 */
    eventPriority: number;
    /** Optional frame count, defaults to Infinity. If you set it to 1, it would only render a single frame, etc */
    frames: number;
    /** Optional event compute, defaults to undefined */
    compute?: (event: any, state: any, previous: any) => false | undefined;
}
export declare class NgtsRenderTextureContainer {
    fbo: import("@angular/core").InputSignal<WebGLRenderTarget<import("three").Texture>>;
    renderPriority: import("@angular/core").InputSignal<number>;
    frames: import("@angular/core").InputSignal<number>;
    injector: import("@angular/core").InputSignal<Injector>;
    private store;
    constructor();
    static ɵfac: i0.ɵɵFactoryDeclaration<NgtsRenderTextureContainer, never>;
    static ɵdir: i0.ɵɵDirectiveDeclaration<NgtsRenderTextureContainer, "[ngtsRenderTextureContainer]", never, { "fbo": { "alias": "fbo"; "required": true; "isSignal": true; }; "renderPriority": { "alias": "renderPriority"; "required": true; "isSignal": true; }; "frames": { "alias": "frames"; "required": true; "isSignal": true; }; "injector": { "alias": "injector"; "required": true; "isSignal": true; }; }, {}, never, never, true, never>;
}
export declare class NgtsRenderTextureContent {
    static ngTemplateContextGuard(_: NgtsRenderTextureContent, ctx: unknown): ctx is {
        container: Object3D;
        injector: Injector;
    };
    static ɵfac: i0.ɵɵFactoryDeclaration<NgtsRenderTextureContent, never>;
    static ɵdir: i0.ɵɵDirectiveDeclaration<NgtsRenderTextureContent, "ng-template[renderTextureContent]", never, {}, {}, never, never, true, never>;
}
export declare class NgtsRenderTexture {
    attach: import("@angular/core").InputSignal<NgtAttachable>;
    options: import("@angular/core").InputSignalWithTransform<NgtsRenderTextureOptions, "" | Partial<NgtsRenderTextureOptions>>;
    parameters: import("@angular/core").Signal<Omit<NgtsRenderTextureOptions, "width" | "height" | "frames" | "depthBuffer" | "stencilBuffer" | "generateMipmaps" | "samples" | "renderPriority" | "eventPriority" | "compute">>;
    content: import("@angular/core").Signal<TemplateRef<any>>;
    private store;
    private size;
    private viewport;
    private fboParams;
    renderPriority: import("@angular/core").Signal<number>;
    frames: import("@angular/core").Signal<number>;
    fbo: import("@angular/core").Signal<WebGLRenderTarget<import("three").Texture>>;
    virtualScene: import("@angular/core").Signal<import("angular-three").NgtInstanceNode<Scene>>;
    eventPriority: import("@angular/core").Signal<number>;
    compute: import("@angular/core").Signal<NgtComputeFunction>;
    private uvCompute;
    onPointerOver(): void;
    static ɵfac: i0.ɵɵFactoryDeclaration<NgtsRenderTexture, never>;
    static ɵcmp: i0.ɵɵComponentDeclaration<NgtsRenderTexture, "ngts-render-texture", never, { "attach": { "alias": "attach"; "required": false; "isSignal": true; }; "options": { "alias": "options"; "required": false; "isSignal": true; }; }, {}, ["content"], never, true, never>;
}
