import { NgtMesh, NgtVector3 } from 'angular-three';
import { Vector3 } from 'three';
import { Sky } from 'three-stdlib';
import * as i0 from "@angular/core";
export declare function calcPosFromAngles(inclination: number, azimuth: number, vector?: Vector3): Vector3;
export interface NgtsSkyOptions extends Partial<Omit<NgtMesh, 'scale'>> {
    distance: number;
    inclination: number;
    azimuth: number;
    mieCoefficient: number;
    mieDirectionalG: number;
    rayleigh: number;
    turbidity: number;
    sunPosition?: NgtVector3;
}
export declare class NgtsSky {
    options: import("@angular/core").InputSignalWithTransform<NgtsSkyOptions, "" | Partial<NgtsSkyOptions>>;
    parameters: import("@angular/core").Signal<Omit<NgtsSkyOptions, "distance" | "inclination" | "azimuth" | "sunPosition" | "turbidity" | "mieCoefficient" | "mieDirectionalG">>;
    distance: import("@angular/core").Signal<number>;
    turbidity: import("@angular/core").Signal<number>;
    mieCoefficient: import("@angular/core").Signal<number>;
    mieDirectionalG: import("@angular/core").Signal<number>;
    rayleigh: import("@angular/core").Signal<number>;
    scale: import("@angular/core").Signal<Vector3>;
    private inclination;
    private azimuth;
    private sunPosition;
    calculatedSunPosition: import("@angular/core").Signal<Vector3>;
    sky: Sky;
    static ɵfac: i0.ɵɵFactoryDeclaration<NgtsSky, never>;
    static ɵcmp: i0.ɵɵComponentDeclaration<NgtsSky, "ngts-sky", never, { "options": { "alias": "options"; "required": false; "isSignal": true; }; }, {}, never, ["*"], true, never>;
}
